/**
 * 点击主页会员卡跳转到此界面
 * Created by jin on 2016.06.07.
 */
app.controller("HuiYuanCard", ["$scope", "$timeout", "$location", 'auth', 'AuthService', '$rootScope', 'UniqueIDService', 'CardService', 'AjaxLogger','PosSystemConfigService',
    function ($scope, $timeout, $location, auth, AuthService, $rootScope, UniqueIDService, CardService, AjaxLogger,PosSystemConfigService) {

        $scope.cardstep = 0;
        $scope.cardNo ; // 会员卡号
        $scope.clickCardType = 0;

        var paymentMethodList = null;
        var member = new Member();
        var cardcz = new CardChongZhi();
        var tempinput = null;
        $scope.pmList = paymentMethodList;
        $scope.member = member;
        $scope.cardcz = cardcz;
        $scope.xieChongzhi = 0;
        $scope.xieZengsong = 0;
        $scope.clickPm ;

        $scope.cardType = "";

        var posSystemConfigs = [];
        $scope.posSystemConfigs = posSystemConfigs;
        $scope.init = function () {
            //所有支付方式
            loadAllPayMethod();
            initConfig();
        };
        //充值去数字以外
        $scope.reOther = function () {
            //设定第一个数字不为0
            /*            if($scope.cardcz.chongzhi){
             return
             }*/
            $scope.cardcz.chongzhi = $scope.cardcz.chongzhi.replace(/[^\d]/g, '').replaceAll(' ', '');

        }

        function initConfig() {
            PosSystemConfigService.getAllConfigsByValueType(function (err, result) {
                $scope.posSystemConfigs = result;
                $scope.cardType = getSystemConfigValue("readCardType");//读卡类型
                for(var cardt in BIZCONSTANT.READCARD_TYPES){
                    if(BIZCONSTANT.READCARD_TYPES[cardt].value==$scope.cardType){
                        $scope.cardType = BIZCONSTANT.READCARD_TYPES[cardt].name;
                        break;
                    }
                }
            }, BIZCONSTANT.POS_SYSTEM_CONFIG_MODULE.gongneng);
        }
        function getSystemConfigValue(key) {
            var systemconfig = Utils.arrayFind($scope.posSystemConfigs, key, "systemConfigName");
            if (null == systemconfig)
                return null;
            else
                return systemconfig.systemConfigValue;
        }



        $scope.doKaiKa = function(){
            $location.url("/card");
        }

        $scope.gotoBack = function(){
            $location.url("/main");
        }

        $scope.clickIcCard = function(){
            $scope.clickCardType = 0;
        }

        $scope.clickM1Card = function(){
            $scope.clickCardType = 1;
        }

        $scope.showSelectCardType = function(cardType){
            return  $scope.clickCardType==cardType ;
        }

        $scope.hynextstep = function(){
            //if(Utils.isEmpty($scope.cardNo)){
            //    return Utils.showFailureInfo("卡号不能为空");
            //}
            $scope.numcontrlclick();
        }
        
        $scope.backToZ = function () {
            cardcz.chongzhi = 0;
            $scope.cardNo='';
            $scope.cardstep = 0;
        }

        $scope.backToOne = function(){
            $scope.cardstep = 1;
        }

        $scope.paymoney = function(){
            $scope.cardstep = 2;
        }

        $scope.clickPay = function(pm){
            $scope.cardstep = 2;
            $scope.clickPm = pm;

        }

        $scope.numcontrlclick = function () {
            var cardno = $scope.cardNo;
            if (!cardno || cardno == ''){
                CardService.ReadCard(function (result) {
                    if (result.error != '')
                        return Utils.showFailureInfo(result.error);
                    if (result.card_no == '')
                        return Utils.showFailureInfo('此卡为空卡，请先发卡');
                    $scope.cardNo = result.card_no;
                    duka(result.card_no);
                }, function (error) {
                    Utils.showFailureInfo(error);
                });
            }else{
                return duka(cardno);
            }
        }


        function duka(cardno) {
            $.maskLoader('show');
            CardService.GetCardInfo(cardno, function (result) {
                $.maskLoader('hide');
                if (result.status == 'failed') {
                    $scope.member = new Member();
                    return Utils.showFailureInfo(result.errorDetails[0].desc);
                }
                var card = result.data;
                if (card) {
                    if (card.cardStatus != 1)
                    {
                        $scope.member = new Member();
                        switch (card.cardStatus)
                        {
                            case 2:
                                return Utils.showFailureInfo('此卡已挂失');
                            case 3:
                                return Utils.showFailureInfo('此卡已冻结');
                            case 4:
                                return Utils.showFailureInfo('此卡已作废');
                        }
                    }
                    $scope.member._cardNum = card.cardCode;
                    $scope.member._name = card.crmMemberInfo.hyName;
                    $scope.member.setCZ(parseFloat(card.crmCardAccountInfo.prepaidBalance));
                    $scope.member.setZS(parseFloat(card.crmCardAccountInfo.presentBalance));
                    $scope.member._ye = $scope.member.getYe();
                    $scope.member._integral = card.crmCardAccountInfo.points;//积分
                    $scope.member._phone = card.crmMemberInfo.hyMobile;
                    $scope.member._dob = Utils.formatDate(card.crmMemberInfo.hyBirthday, 'yyyy-MM-dd');
                    $scope.member._address = card.crmMemberInfo.hyAddress;
                    $scope.member._remark = card.crmMemberInfo.hyDesc;
                    $scope.member.hytype =  card.crmCardTypeInfo.cardTypeName;

                    $scope.member.crmCardLevelInfo = card.crmCardLevelInfo;
                    $scope.member.crmLevelRuleInfos = card.crmCardLevelInfo.crmLevelRuleInfos;
                    $('#czinput')[0].focus();
                    $scope.xieChongzhi = 1;
                    zshandl();
                    $scope.cardstep = 1;
                } else {
                    $scope.member = new Member();
                    return Utils.showFailureInfo('未查询到此卡');
                }

            }, function () {
                $.maskLoader('hide');
                $scope.member = new Member();
                $scope.backToOne();
                Utils.showFailureInfo('读卡失败,请重试'); });
        }

        function zshandl () {
            cardcz.zongsong = 0;
            $scope.xieZengsong = 0;
            $scope.isChongzhi = true;
            //$( "#zsinput").attr("readonly", true);
            var forCompare = 0;
            // 根据规则，得出赠送金额并且绑定
            var cardtype = $scope.member.crmCardLevelInfo.cardLevelIsDeposit;
            if(!cardtype){
                $scope.xieChongzhi = 0;
                $scope.isChongzhi = false
                return;
            }
            var rules = $scope.member.crmLevelRuleInfos;
            if (rules && rules.length == 0){
                return cardcz.zongsong = 0;
            }

            var rerules = [];
            for (var i in rules) {
                if (rules[i].ruleType == 3)
                    rerules.push(rules[i]);
            }
            // 判断定额和比例赠送
            //将value 与 model绑定
            cardcz.chongzhi = $( "#czinput" ).val()
            if(!cardcz.chongzhi){
                return
            }
            for (var i in rerules) {
                if(rerules[i].ruleManualInput){
                    //$("#zsinput").removeAttr("readonly");
                    $scope.xieZengsong = 1;
                    return;
                }
                if(rerules[i].ruleSubType ==31){
                    if(rerules[i].ruleConditionValue == cardcz.chongzhi){
                        cardcz.zongsong = rerules[i].ruleResultValue;
                    }
                }else if (rerules[i].ruleSubType ==32){
                    if(rerules[i].ruleConditionValue <= cardcz.chongzhi){
                        if(forCompare <= rerules[i].ruleResultValue){
                            cardcz.zongsong =cardcz.chongzhi / 100 * rerules[i].ruleResultValue;
                            forCompare = rerules[i].ruleResultValue;
                        }
                    }
                }else{
                    console.log("此处可能是错误的规则，打印ruleSubType："+rerules[i].ruleSubType)
                }
            }
        }

        function loadAllPayMethod() {
            var ret = [];
            var pmlist = BIZCONSTANT.ALLPMs;
            for (var i = 0; i < pmlist.length; i++)
            {
                var tppm = pmlist[i];
                if (tppm.name == '现金' || tppm.name == '银行卡' || tppm.name == '支付宝')
                {
                    ret.push(tppm);
                }
            }

            paymentMethodList = ret;
            $scope.pmList = ret;
            //TODO,会调用DAO
        }

        //充值
        $scope.inputfocuschongzhi = function (event) {
            //debugger
            // 读卡后激活，可写入
            if($scope.xieChongzhi){
                tempinput = event.currentTarget;
                zshandl ();
            }else{
                tempinput = null;
            }
        }
        //赠送
        $scope.inputfocuszengsong = function (event) {
            //debugger
            //赠送规则里面有可写规则，则激活
            if($scope.xieZengsong){
                tempinput = event.currentTarget;
            }else{
                tempinput = null;
            }

        }

        $scope.save = function () {
            if(!$scope.isChongzhi){
                $scope.isChongzhi = true;
                return Utils.showFailureInfo("该会员类型的卡不允许充值！");
            }
            var cardcz = $scope.cardcz;
            cardcz.fkfs = $scope.clickPm.name;
            try {
                cardcz.chongzhi = parseFloat($('#czinput').val());
                //var zongSong = $('#zsinput').val();
                var zengSong;
                if(!zengSong){
                    zengSong = 0;
                }
                cardcz.zongsong = parseFloat(zengSong);
                cardcz.card_no = $scope.member._cardNum;
            } catch (e) { }
            //debugger;
            if (!cardcz.card_no || cardcz.card_no == '')
                return Utils.showFailureInfo("请先读卡");
            if (!cardcz.chongzhi)
                return Utils.showFailureInfo("请输入充值金额");
            if (!cardcz.fkfs || cardcz.fkfs == null || cardcz.fkfs == '')
                return Utils.showFailureInfo("请选择付款方式");

            var czinfo = {};
            czinfo.cardCode = cardcz.card_no;
            czinfo.rechargeAmount = cardcz.chongzhi;
            czinfo.rechargePresentAmount = cardcz.zongsong;
            czinfo.rechargePayType = cardcz.fkfs;
            czinfo.rechargePayTypeName = $scope.clickPm.name;
            czinfo.rechargeFapiaoMoney = 0;//发票金额
            czinfo.timestamp = Utils.now();
            $.maskLoader('show');
            //调用接口
            CardService.ReCharge(czinfo, function (result) {
                $.maskLoader('hide');
                if (result.status == 'success' && result.errorDetails.length == 0) {

                    //打印begin
                    var chongzhiobj = new ChongZhiObject();
                    debugger;
                    chongzhiobj.cardNo = czinfo.cardCode;
                    chongzhiobj.hyName = $scope.member._name;
                    chongzhiobj.money = czinfo.rechargeAmount;
                    chongzhiobj.zengsong = czinfo.rechargePresentAmount;
                    chongzhiobj.yue = parseFloat(result.data.crmCardAccountInfo.prepaidBalance) + parseFloat(result.data.crmCardAccountInfo.presentBalance);
                    chongzhiobj.paytype = czinfo.rechargePayTypeName;
                    chongzhiobj.operatorName = BIZCONSTANT.POSUSER.name;
                    chongzhiobj.HotelName = BIZCONSTANT.POSUSER.HotelName;

                    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.CHONGZHIDAN);
                    var printtext = printhelp.printtext(chongzhiobj, receipt);
                    var printjob = new PrinterJob();

                    printjob.name = "充值通知单";
                    printjob.mPrinterId = receipt.printId;
                    printjob.status = 0;
                    printjob.errorCount = 0;
                    printjob.content = printtext;
                    printjob.createTime = null;
                    printjob.processing = 0;
                    printjob.invoiceCode = receipt.code;
                    printjob.ref = null;
                    printjob.orderId = '';
                    printjob.jobNo = null;
                    printjob.printTime = null;
                    printjob.printCount = 0;

                    tickPrinter(printjob, function (err) {
                        if (err != null)
                            return Utils.showFailureInfo(err);
                        Utils.showSuccessInfo("打印成功");
                    });
                    //打印end
                    Utils.showSuccessInfo("充值成功");
                    $scope.cardNo='';
                    $scope.cardstep = 0;
                    return;
                }
                Utils.showFailureInfo(result.errorDetails[0].desc);
            }, function () { $.maskLoader('hide'); Utils.showFailureInfo('操作失败'); });
        }
    }
]);
