app.controller("IndexController", ["$scope", "$location", "$window", '$q', 'database', "AuthService", '$rootScope', 'SystemConfigService', 'database', 'AjaxLogger', 'ZhangdanQueryService', 'UploadService',
    function ($scope, $location, $window, $q, database, AuthService, $rootScope, SystemConfigService, database, AjaxLogger, ZhangdanQueryService, UploadService) {
        $scope.userName = null;
        $scope.passWord = null;
        $scope.installDetails = "";
        $scope.step = 1;
        $scope.executedCount = 0;
        $scope.selectInputName = null;
        $scope.MasterConfig = null;
        $scope.CurRemoteInstallConfig = null;

        $rootScope.ContextEnv = window.CONTEXT.env;

        $scope.masterIp = null;//主机IP

        $scope.serverHost = SERVER_HOST.BASE_HOST;
        $scope.canyinURL = null;
        $scope.hqURL = null;
        $scope.posURL = null;

        $scope.jqName = null;
        $scope.jqIP = null;
        $scope.jqMAC = null;
        $scope.jqUDID = null;

        $scope.runningDBCount = 0;

        $scope.checkItems = {
            pos_system_config: { required: true, installed: false, execute: false },
            pos_canbie: { required: true, installed: false, execute: false },
            pos_person: { required: true, installed: false, execute: false },
            pos_person_func_mission: { required: true, installed: false, execute: false },
            pos_person_pos_mission: { required: false, installed: false, execute: false },
            pos_person_role: { required: true, installed: false, execute: false },
            pos_area: { required: false, installed: false, execute: false },
            pos_zhuotai: { required: false, installed: false, execute: false },
            pos_caipin_type: { required: false, installed: false, execute: false },
            pos_caipin: { required: false, installed: false, execute: false },
            pos_zuofa: { required: false, installed: false, execute: false },
            pos_zuofa_type: { required: false, installed: false, execute: false },
            pos_kouwei: { required: false, installed: false, execute: false },
            pos_tuicai_reason: { required: false, installed: false, execute: false },
            pos_zengsong_reason: { required: false, installed: false, execute: false },
            pos_zhekou: { required: false, installed: false, execute: false },
            pos_cai_wu_ke_mu: { required: false, installed: false, execute: false },
            pos_scomb_caipin: { required: false, installed: false, execute: false },
            pos_scomb_beixuan_caipin: { required: false, installed: false, execute: false },
            pos_caipin_zuofa: { required: false, installed: false, execute: false },
            pos_caipin_unit: { required: false, installed: false, execute: false },
            printer: { required: false, installed: false, execute: false },
            printer_config: { required: false, installed: false, execute: false },
            pos_print_receipt: { required: false, installed: false, execute: false },
            pos_print_receipt_template: { required: false, installed: false, execute: false },
            pos_print_caipin: { required: false, installed: false, execute: false },
            pos_print_scheme: { required: false, installed: false, execute: false },
            pos_sys_print_receipt_template: { required: false, installed: false, execute: false },
            pos_consumption_type: { required: false, installed: false, execute: false },
            pos_consumption_caipin: { required: false, installed: false, execute: false },
            pos_third_coupon: { required: false, installed: false, execute: false },
            pos_third_coupon_not_use_caipintype: { required: false, installed: false, execute: false }
        }



        var vm = $scope.vm = {};
        vm.value = 0;
        vm.style = 'progress-bar-info';
        vm.showLabel = true;

        //加载条移动
        function progress() {
            $scope.vm.value += $scope.oneSpace;
        }

        $scope.minWindow = function () {
            if (window.CONTEXT.env == CONSTANTS.EnvConstants.ANDROID) {
                window.yunshan.moveAppToBack();
            } else {
                if (typeof (require) != 'undefined') {
                    var gui = require('nw.gui');
                    win = gui.Window.get();
                    win.minimize();
                }
            }
        };

        $scope.init = function () {
            var moduleCount = 1;
            $scope.selectInputName = "name";
            for (var key in $scope.checkItems) {
                if ($scope.checkItems[key].required)
                    moduleCount += 1;
            }

            $scope.oneSpace = parseInt(100 / moduleCount);

            if ($scope.serverHost.toLowerCase().indexOf("http://") == -1) {
                $scope.serverHost = "http://" + $scope.serverHost;
            }


            $scope.canyinURL = $scope.serverHost;
            $scope.hqURL = $scope.serverHost + API_CONTEXT.BASIC;
            $scope.posURL = $scope.serverHost + API_CONTEXT.POS;


            if (window.CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS) {
                loadDeviceName($rootScope);
                if ('FAKE DEVICE,NOT IMPLEMENTED' == $rootScope.deviceName) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_registererrornoIP"]);
                }
                var deviceName = $rootScope.deviceName.split("_");

                $scope.jqName = deviceName[1];
                $scope.jqIP = deviceName[0];

                var os = require("getmac");
                os.getMac(function (err, macAddress) {
                    if (err) {
                        $.maskLoader("hide");
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_registererrornoMAC"]);
                    }
                    $scope.jqMAC = macAddress; // windows 必传
                });
            } else if (window.CONTEXT.env == CONSTANTS.EnvConstants.ANDROID) {
                $scope.jqName = AndroidAdapter.getDeviceName();
                $scope.jqIP = AndroidAdapter.getIp();
                $scope.jqMAC = AndroidAdapter.getMacAddress();
                $scope.jqUDID = AndroidAdapter.getUdid();
            } else if (window.CONTEXT.env == CONSTANTS.EnvConstants.IOS) {
                $scope.jqName = IOSAdapter.getDeviceName();
                $scope.jqIP = IOSAdapter.getIp();
                $scope.jqMAC = IOSAdapter.getMacAddress();
                $scope.jqUDID = IOSAdapter.getUdid();
            }

        }
        $scope.$on('kjj', function (d, data) {
            switch (data) {
                case 'enter':
                    $scope.startInit();
                    break;
            }

        });

        $scope.keypress = function (ev) {
            if (ev.keyCode == 13) {
                if ($scope.selectInputName == "name") {
                    $("#pwd").focus();
                    $scope.selectInputName = "pwd";
                } else if ($scope.selectInputName == "pwd") {
                    $scope.startInit();
                }
            }
        }



        //开始初始化
        $scope.startInit = function () {
            if (Utils.isEmpty($scope.userName)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputaccount"]);
            }
            if (Utils.isEmpty($scope.passWord)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputpassword"]);
            }

            var loadUrl = $scope.hqURL + "/api/v1/login/login?t=1&token=1";
            $.maskLoader("show");
            //登录
            callAjax(loadUrl,
                function (result) {
                    $.maskLoader("hide");
                    if (result.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }
                    if (result.data == null) {
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_getaccountinfofail"]);
                    }

                    var LoginInfo = result.data;

                    //登录成功存储数据
                    $scope.groupCode = result.data.groupCode;
                    $scope.groupID = result.data.groupId;
                    $scope.MDInfo = result.data.authUserOrgInfoList[0];
                    $scope.storeID = result.data.orgid;
                    $scope.storeCode = result.data.orgNo;
                    $scope.groupIdType = result.data.groupModelInfo.groupIdType;

                    $scope.userID = result.data.userId;
                    //$scope.userName = result.data.userName;

                    var currentUser = new PosUser();

                    currentUser.id = result.personId;
                    currentUser.code = result.personNo;
                    currentUser.name = result.personName;
                    currentUser.mdId = result.data.orgid;

                    currentUser.groupCode = result.data.groupCode;
                    currentUser.groupId = result.data.groupId;
                    currentUser.groupIdType = result.data.groupModelInfo.groupIdType;

                    Utils.setStorage("CLOUD_USERNAME",$scope.userName);

                    currentUser.device = $rootScope.deviceName;

                    BIZCONSTANT.POSUSER = currentUser;

                    //进入引导页
                    $scope.step = 2;
                    $scope.$apply();
                }, JSON.stringify({ loginName: $scope.userName, password: $scope.passWord }),
                "POST",
                function (xhr, status, error, data) {
                    $.maskLoader("hide");
                    if (status == "timeout" || status == "error") {
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_checknetinfofail"]);
                    }
                })

        }

        /**
         * 统一的安装入口
         * type   z 代表主机   f代表分机
         */
        $scope.install = function (type) {
            $.maskLoader("show");
            var getMasterUrl = $scope.posURL + INSTALL_CONFIG.GETMASTER.url + "?groupId=" + $scope.groupID + "&orgId=" + $scope.storeID + "&groupCode=" + $scope.groupCode;

            InstallConfigService.getRemoteMasterConfig(getMasterUrl, function (config) {
                $.maskLoader("hide");
                if (config != null && "err" == config.status) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_gethostinfofail"]);
                }
                $scope.MasterConfig = config;
                if ('z' == type) {
                    installZhu();
                }
                else if ('f' == type) {
                    if ($scope.MasterConfig == null) {
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_mustsettinghost"]);
                    }
                    $scope.masterIp = config.ip;
                    $scope.step = 4;
                    $scope.selectInputName = "ip";
                    $scope.$apply();
                }
            }, true);
        }

        //主机安装方法
        function installZhu() {
            if (window.CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS) {
                if ($scope.MasterConfig != null && $scope.jqMAC != $scope.MasterConfig.mac) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_hadhhostandhostname"] + $scope.MasterConfig.name +'<br/>' +LANGUAGECACHE["str_tip_backtochooseextension"]);
                } else if ($scope.MasterConfig != null && $scope.jqMAC == $scope.MasterConfig.mac) {
                    $scope.CurRemoteInstallConfig = $scope.MasterConfig;
                    install();
                } else {
                    handleInstalZhuji();
                }
            } else if (window.CONTEXT.env == CONSTANTS.EnvConstants.ANDROID) {

                if ($scope.MasterConfig != null && $scope.jqUDID != $scope.MasterConfig.udid) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_hadhhostandhostname"] + $scope.MasterConfig.name +'<br/>' +LANGUAGECACHE["str_tip_backtochooseextension"]);
                } else if ($scope.MasterConfig != null && $scope.jqUDID == $scope.MasterConfig.udid) {
                    $scope.CurRemoteInstallConfig = $scope.MasterConfig;
                    install();
                } else {
                    handleInstalZhuji();
                }
            } else if (window.CONTEXT.env == CONSTANTS.EnvConstants.IOS) {

                if ($scope.MasterConfig != null && $scope.jqUDID != $scope.MasterConfig.udid) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_hadhhostandhostname"] + $scope.MasterConfig.name +'<br/>' +LANGUAGECACHE["str_tip_backtochooseextension"]);
                } else if ($scope.MasterConfig != null && $scope.jqUDID == $scope.MasterConfig.udid) {
                    $scope.CurRemoteInstallConfig = $scope.MasterConfig;
                    install();
                } else {
                    handleInstalZhuji();
                }
            }
        }
        function handleInstalZhuji() {
            InstallConfigService.saveLocal({ isMaster: "true", ip: "127.0.0.1" });
            install();
        }



        //分机安装方法
        $scope.fenjiNext = function () {
            //TODO 安装分机
            if (!/^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$/.test($scope.masterIp)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputIPagain"]);
            }
            $.maskLoader("show");

            addInstallConfig($scope.MasterConfig);
            return;
        }

        $scope.return = function () {
            $scope.step = 2;
        }


        function CreateInstallConfigObject(masterConfig) {
            var installConfig = new InstallConfig();

            installConfig.name = $scope.jqName;
            installConfig.ip = $scope.jqIP;
            installConfig.mac = $scope.jqMAC;
            installConfig.udid = $scope.jqUDID;

            installConfig.os = CONTEXT.env;
            if (masterConfig == null) {
                installConfig.isMaster = true;
            }
            else {
                installConfig.isMaster = false;
                installConfig.masterHost = masterConfig.ip;
            }

            installConfig.groupCode = $scope.groupCode;
            installConfig.groupId = $scope.groupID;
            installConfig.groupIdType = $scope.groupIdType;
            installConfig.addGroupId = $scope.groupID;
            installConfig.addGroupIdType = $scope.groupIdType;
            installConfig.addUserId = $scope.userID;
            installConfig.addUser = $scope.userName;
            installConfig.modUserId = $scope.userID;
            installConfig.modUser = $scope.userName;
            installConfig.orgid = $scope.storeID;

            return installConfig;
        }

        function addInstallConfig(masterConfig) {
            var installConfig = CreateInstallConfigObject(masterConfig);

            var saveRemoteURL = $scope.posURL + INSTALL_CONFIG.ADD_INSTALLCONFIG.url;

            InstallConfigService.saveRemote(saveRemoteURL, installConfig, function (config) {
                saveRemoteCallback(installConfig);
            }, true);
        }

        function saveRemoteCallback(config) {
            if (config == null) {
                $.maskLoader("hide");
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_installinfofail"]);
            }
            InstallConfigService.saveLocal(config);

            $scope.vm.value = 100;
            //安装成功记录云端账号
            InstallConfigService.saveCloudAccount($scope.userName);

            gotoLogin();

        }

        function gotoLogin() {
            if ($scope.runningDBCount == 0) {
                $.maskLoader("hide");
                window.location = "index.html";
            }
            else {
                window.setTimeout(gotoLogin, 100);
            }
        }

        function install() {
            database.init(true, function () {
                $.maskLoader("hide");
                $scope.step = 3;
                $scope.$apply();
                installResultDeferExecut();
                var queryStr = "?t=&token=";
                var getQueryStr = "&t=&token=";
                var prefix = $scope.posURL;

                $scope.initOrg($scope.hqURL, INIT.CONFIG);

                $scope.initSimple(prefix, INIT.AREA)
                $scope.initSimple(prefix, INIT.ZHUOTAI);
                $scope.initSimple(prefix, INIT.DISH_TYPE);
                $scope.initSimple(prefix, INIT.ZHUOFA);
                $scope.initSimple(prefix, INIT.ZHUOFA_TYPE);
                $scope.initSimple(prefix, INIT.KOUWEI);
                $scope.initSimple(prefix, INIT.TUICAIREASON);
                $scope.initSimple(prefix, INIT.RESENTREASON);
                $scope.initSimple(prefix, INIT.ZHEKOU_TEMPLATE);
                $scope.initSimple(prefix, INIT.CAIWUKEMU);
                $scope.initSimple(prefix, INIT.CAIBIE);

                $scope.initSimple(prefix, INIT.PRINT_TEMPLTE);
                $scope.initSimple(prefix, INIT.CONSUMPTION_TYPE);
                $scope.initSimple(prefix, INIT.CONSUMPTION_CP);
                $scope.initSimple(prefix, INIT.THIRDCOUPON);
                $scope.initSimple(prefix, INIT.THIRDCOUPONEXCLUDEDISH);

                $scope.initPerson($scope.hqURL, INIT.PERSON);

                $scope.initSimpleGet($scope.hqURL, INIT.PERSON_ROLE);

                $scope.initPersonFuncMissions($scope.hqURL, INIT.PERSON_FUNC_MISSIONS);

                $scope.initPersonPosMissions($scope.hqURL, INIT.PERSON_POS_MISSIONS);


                $scope.initPos_caipin(prefix, INIT.CAIPIN);

                $scope.initPrint(prefix, INIT.PRINT);

                $scope.initPos_ScombCaipin(prefix, INIT.SCOMB_CAIPIN);

                //恢复注销前同步的数据
                UploadService.getUploadData(function (res) {
                    if (res == null) {
                        console.info("恢复注销数据成功！");
                    }
                });

            });
        }


        function installResultDeferExecut() {
            setTimeout(function () {
                for (var key in $scope.checkItems) {
                    if ($scope.checkItems[key].required && !$scope.checkItems[key].installed) {
                        InstallConfigService.removeLocalStorageInstallConfig();
                        break;
                    }
                }
            }, 90000);
        }

        $scope._checkInstallCompleted = function () {
            var isOK = true;

            for (var key in $scope.checkItems) {
                if (!$scope.checkItems[key].execute || ($scope.checkItems[key].required && !$scope.checkItems[key].installed)) {
                    isOK = false;
                    break;
                }
            }
            if (isOK) {
                if ($scope.CurRemoteInstallConfig == null)
                    addInstallConfig($scope.MasterConfig);
                else
                    saveRemoteCallback($scope.CurRemoteInstallConfig);
            }
        };


        $scope.initPos_ScombCaipin = function (prefix, urlModel) {

            callAjax(prefix + urlModel.url, function (response) {

                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID, searchKey: "" }), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        $scope.installDetails += "<div style='color:red;'>"+LANGUAGECACHE["str_tip_initfail"]+response.errorDetails[0].desc+"</div>";
                        return ;
                    }

                    if (!validateResponseData(response, "pos_scomb_caipin", "套餐菜品")) {
                        responseDataNull("pos_scomb_beixuan_caipin", "套餐备选菜品");
                        return;
                    }

                    if (!Utils.isEmpty(response.dataList)) {
                        var data = [];
                        var scombCaipins = [];
                        var scombBXCaipins = [];
                        var caipinunits = [];
                        var BXCaipins = [];

                        for (var idx in response.dataList) {

                            var tempScombCaipins = response.dataList[idx].tcDishList;
                            for (var i in tempScombCaipins) {
                                var tempScombCaipin = _buildModelData("pos_scomb_caipin", tempScombCaipins[i]);
                                tempScombCaipin.scombId = response.dataList[idx].guid;
                                scombCaipins.push(tempScombCaipin);

                                if (tempScombCaipins[i].tcbxDishList.length > 0) {
                                    var tempBXCaipins = tempScombCaipins[i].tcbxDishList;
                                    for (var k in tempBXCaipins) {
                                        var tempBXCaipin = _buildModelData("pos_scomb_beixuan_caipin", tempBXCaipins[k]);
                                        tempBXCaipin.scombId = response.dataList[idx].guid;
                                        tempBXCaipin.scombCaipinId = tempScombCaipin.guid;
                                        BXCaipins.push(tempBXCaipin);
                                    }
                                }
                            }
                        }
                        var scp = new DatabaseFuncDelegate($q, database, 'pos_scomb_caipin');
                        scp.query("delete from pos_scomb_caipin ").then(function () {
                            if (scombCaipins.length > 0) {
                                $scope.moduleCount += 1;
                                $scope.runningDBCount++;
                                scp.insertBatch(scombCaipins).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_scomb_caipin", "套餐菜品");
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_scomb_caipin", "套餐菜品", err, sql);
                                });
                            } else {
                                responseDataNull("pos_scomb_caipin", "套餐菜品");
                            }
                        });

                        var bxcp = new DatabaseFuncDelegate($q, database, 'pos_scomb_beixuan_caipin');
                        bxcp.query("delete from pos_scomb_beixuan_caipin ").then(function () {
                            if (BXCaipins.length > 0) {
                                $scope.moduleCount += 1;
                                $scope.runningDBCount++;
                                bxcp.insertBatch(BXCaipins).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_scomb_beixuan_caipin", "套餐备选菜品");
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_scomb_beixuan_caipin", "套餐备选菜品", err, sql);
                                });
                            } else {
                                responseDataNull("pos_scomb_beixuan_caipin", "套餐备选菜品");
                            }
                        });
                    } else {
                        $scope.checkItems["pos_scomb_beixuan_caipin"].execute = true;
                        responseDataNull("pos_scomb_caipin", "套餐菜品");
                    }
                }, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID, searchKey: "" }),
                "POST",
                function (xhr, status, error, data) {
                    $scope.checkItems["pos_scomb_beixuan_caipin"].execute = true;
                    responseError("pos_scomb_caipin", "套餐菜品", error, data, status);
                });
        }


        $scope.initPos_caipin = function (prefix, urlModel) {
            callAjax(prefix + urlModel.url, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        $scope.installDetails += "<div style='color:red;'>" +LANGUAGECACHE["str_tip_initfail"]+response.errorDetails[0].desc+"</div>";
                        return;
                    }


                    if (!validateResponseData(response, urlModel.tableName, urlModel.desc)) {
                        $scope.checkItems["pos_caipin_zuofa"].execute = true;
                        responseDataNull("pos_caipin_unit", LANGUAGECACHE["str_tip_caipindanwei"]);
                        return;
                    }

                    if (!Utils.isEmpty(response.dataList)) {
                        response.dataList = Utils.uniqueArrayObject(response.dataList, "guid");
                        var db = new DatabaseFuncDelegate($q, database, 'pos_caipin');
                        var data = [];
                        var caipinZuofaData = [];
                        var caipinunits = [];
                        for (var idx in response.dataList) {
                            data.push(_buildModelData("pos_caipin", response.dataList[idx]));


                            if (!Utils.isEmpty(response.dataList[idx].caipinZuofas)) {
                                for (var zdx in response.dataList[idx].caipinZuofas) {
                                    var caipinZuofaModel = _buildModelData("pos_caipin_zuofa", response.dataList[idx].caipinZuofas[zdx]);
                                    caipinZuofaModel["caipinId"] = response.dataList[idx]["guid"];
                                    caipinZuofaData.push(caipinZuofaModel);
                                }
                            }


                            if (!Utils.isEmpty(response.dataList[idx].caipinUnits)) {
                                for (var zdx in response.dataList[idx].caipinUnits) {
                                    var caipinunitModel = _buildModelData("pos_caipin_unit", response.dataList[idx].caipinUnits[zdx]);
                                    caipinunitModel["caipinId"] = response.dataList[idx]["guid"];
                                    caipinunits.push(caipinunitModel);
                                }
                            }
                        }
                        db.query("delete from pos_caipin ").then(function () {
                            if (data.length > 0) {
                                $scope.runningDBCount++;


                                db.insertBatch(data).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess(urlModel.tableName, urlModel.desc);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError(urlModel.tableName, urlModel.desc, err, sql);
                                });

                            } else {
                                responseDataNull(urlModel.tableName, urlModel.desc);
                            }
                        });
                        var zfdb = new DatabaseFuncDelegate($q, database, 'pos_caipin_zuofa');
                        zfdb.query("delete from pos_caipin_zuofa").then(function () {
                            if (caipinZuofaData.length > 0) {

                                $scope.runningDBCount++;

                                zfdb.insertBatch(caipinZuofaData).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_caipin_zuofa", LANGUAGECACHE["str_tip_caipinzufoa"]);
                                    //$scope.checkItems["pos_caipin_zuofa"].installed = true;

                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_caipin_zuofa", LANGUAGECACHE["str_tip_caipinzufoa"], err, sql);

                                });

                            } else {
                                responseDataNull("pos_caipin_zuofa", LANGUAGECACHE["str_tip_caipinzufoa"]);
                            }
                        });
                        var czdb = new DatabaseFuncDelegate($q, database, 'pos_caipin_unit');

                        czdb.query("delete from pos_caipin_unit").then(function () {
                            if (caipinunits.length > 0) {
                                $scope.runningDBCount++;
                                czdb.insertBatch(caipinunits).then(function () {
                                    installSuccess("pos_caipin_unit", LANGUAGECACHE["str_tip_caipindanwei"]);
                                    $scope.runningDBCount--;
                                    // $scope.checkItems["pos_caipin_unit"].installed = true;
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_caipin_unit", LANGUAGECACHE["str_tip_caipindanwei"], err, sql);

                                });

                            } else {
                                responseDataNull("pos_caipin_unit", LANGUAGECACHE["str_tip_caipindanwei"]);
                            }
                        });
                    } else {
                        $scope.checkItems["pos_caipin_zuofa"].execute = true;
                        $scope.checkItems["pos_caipin_unit"].execute = true;

                        responseDataNull(urlModel.tableName, urlModel.desc);
                    }
                }, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }),
                "POST",
                function (xhr, status, error, data) {
                    $scope.checkItems["pos_caipin_zuofa"].execute = true;
                    $scope.checkItems["pos_caipin_unit"].execute = true;

                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                })
        };



        $scope.initPrint = function (prefix, urlModel) {

            callAjax(prefix + urlModel.url, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }

                    if (!validateResponseData(response, "printer", LANGUAGECACHE["str_tip_printsetting"])) {
                        $scope.checkItems["printer_config"].execute = true;
                        $scope.checkItems["pos_print_receipt"].execute = true;
                        $scope.checkItems["pos_print_receipt_template"].execute = true;
                        $scope.checkItems["pos_print_caipin"].execute = true;
                        //installSuccess("printer_config", "打印机基础配置");
                        //installSuccess("pos_print_receipt", "打印机高级配置");
                        //installSuccess("pos_print_receipt_template", "打印机模板");
                        // installSuccess("pos_print_caipin", "打印机菜品配置");
                        responseDataNull("pos_print_scheme", LANGUAGECACHE["str_tip_printplan"]);
                        return;
                    }


                    if (!Utils.isEmpty(response.dataList)) {
                        response.dataList = Utils.uniqueArrayObject(response.dataList, "guid");

                        var printerdb = new DatabaseFuncDelegate($q, database, 'printer');
                        var printerconfigdb = new DatabaseFuncDelegate($q, database, 'printer_config');
                        var receiptdb = new DatabaseFuncDelegate($q, database, 'pos_print_receipt');
                        var templatedb = new DatabaseFuncDelegate($q, database, 'pos_print_receipt_template');
                        var schemedb = new DatabaseFuncDelegate($q, database, 'pos_print_scheme');
                        var printecaipindb = new DatabaseFuncDelegate($q, database, 'pos_print_caipin');

                        var printerdata = [];
                        var printerconfigdata = [];
                        var receiptdata = [];
                        var templatedata = [];
                        var schemedata = [];
                        var printecaipindata = [];


                        for (var idx in response.dataList) {
                            printerdata.push(_buildModelData("printer", response.dataList[idx]));
                            if (!Utils.isEmpty(response.dataList[idx].printConfigs)) {
                                for (var configidx in response.dataList[idx].printConfigs) {
                                    printerconfigdata.push(_buildModelData("printer_config", response.dataList[idx].printConfigs[configidx]));
                                }
                            }

                            if (!Utils.isEmpty(response.dataList[idx].printReceipts)) {
                                for (var reciptidx in response.dataList[idx].printReceipts) {
                                    receiptdata.push(_buildModelData("pos_print_receipt", response.dataList[idx].printReceipts[reciptidx]));
                                    if (!Utils.isEmpty(response.dataList[idx].printReceipts[reciptidx].printReceiptTemplates)) {
                                        templatedata.push(_buildModelData("pos_print_receipt_template", response.dataList[idx].printReceipts[reciptidx].printReceiptTemplates[0]));
                                    }
                                }
                            }

                            if (!Utils.isEmpty(response.dataList[idx].printScheme)) {
                                schemedata.push(_buildModelData("pos_print_scheme", response.dataList[idx].printScheme));
                                if (!Utils.isEmpty(response.dataList[idx].printScheme.printCaipins)) {
                                    for (var cpidx in response.dataList[idx].printScheme.printCaipins) {
                                        printecaipindata.push(_buildModelData("pos_print_caipin", response.dataList[idx].printScheme.printCaipins[cpidx]));
                                    }
                                }
                            }
                        }
                        printerdb.query("delete from printer").then(function () {
                            if (printerdata.length > 0) {
                                $scope.runningDBCount++;

                                printerdb.insertBatch(printerdata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("printer", LANGUAGECACHE["str_tip_printsetting"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("printer", LANGUAGECACHE["str_tip_printsetting"], err, sql);
                                });

                            } else {
                                responseDataNull("printer", LANGUAGECACHE["str_tip_printsetting"]);
                            }
                        });
                        printerconfigdb.query("delete from printer_config").then(function () {
                            if (printerconfigdata.length > 0) {
                                $scope.runningDBCount++;

                                printerconfigdb.insertBatch(printerconfigdata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("printer_config", LANGUAGECACHE["str_tip_printbasesetting"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("printer_config", LANGUAGECACHE["str_tip_printbasesetting"], err, sql);
                                });

                            } else {
                                responseDataNull("printer_config", LANGUAGECACHE["str_tip_printbasesetting"]);
                            }
                        });
                        receiptdb.query("delete from pos_print_receipt").then(function () {
                            if (receiptdata.length > 0) {
                                $scope.runningDBCount++;

                                receiptdb.insertBatch(receiptdata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_print_receipt", LANGUAGECACHE["str_tip_printhighersetting"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_print_receipt", LANGUAGECACHE["str_tip_printhighersetting"], err, sql);
                                });

                            } else {
                                responseDataNull("pos_print_receipt", LANGUAGECACHE["str_tip_printhighersetting"]);
                            }
                        });
                        templatedb.query("delete from pos_print_receipt_template").then(function () {
                            if (templatedata.length > 0) {
                                $scope.runningDBCount++;

                                templatedb.insertBatch(templatedata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_print_receipt_template", LANGUAGECACHE["str_tip_printtemplate"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_print_receipt_template", LANGUAGECACHE["str_tip_printtemplate"], err, sql);
                                });

                            } else {
                                responseDataNull("pos_print_receipt_template", LANGUAGECACHE["str_tip_printtemplate"]);
                            }
                        });
                        printecaipindb.query("delete from pos_print_caipin").then(function () {
                            if (printecaipindata.length > 0) {
                                $scope.runningDBCount++;

                                printecaipindb.insertBatch(printecaipindata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_print_caipin", LANGUAGECACHE["str_tip_printcaipinsetting"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_print_caipin", LANGUAGECACHE["str_tip_printcaipinsetting"], err, sql);
                                });

                            } else {
                                responseDataNull("pos_print_caipin", LANGUAGECACHE["str_tip_printcaipinsetting"]);
                            }
                        });
                        schemedb.query("delete from pos_print_scheme").then(function () {
                            if (schemedata.length > 0) {
                                $scope.runningDBCount++;

                                schemedb.insertBatch(schemedata).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess("pos_print_scheme", LANGUAGECACHE["str_tip_printplan"]);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError("pos_print_scheme", LANGUAGECACHE["str_tip_printplan"], err, sql);
                                });

                            } else {
                                responseDataNull("pos_print_scheme", LANGUAGECACHE["str_tip_printplan"]);
                            }
                        });
                    } else {
                        $scope.checkItems["printer_config"].execute = true;
                        $scope.checkItems["pos_print_receipt"].execute = true;
                        $scope.checkItems["pos_print_receipt_template"].execute = true;
                        $scope.checkItems["pos_print_caipin"].execute = true;
                        $scope.checkItems["pos_print_scheme"].execute = true;

                        responseDataNull("printer", LANGUAGECACHE["str_tip_printjisetting"]);
                    }
                }, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }),
                "POST",
                function (xhr, status, error, data) {
                    $scope.checkItems["printer_config"].execute = true;
                    $scope.checkItems["pos_print_receipt"].execute = true;
                    $scope.checkItems["pos_print_receipt_template"].execute = true;
                    $scope.checkItems["pos_print_caipin"].execute = true;
                    $scope.checkItems["pos_print_scheme"].execute = true;

                    responseError("printer", LANGUAGECACHE["str_tip_printjisetting"], error, data, status);
                })
        };


        $scope.initOrg = function (prefix, urlModel) {

            callAjax(prefix + urlModel.url, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": $scope.groupID, "guid": $scope.storeID }), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }
                    var db = new DatabaseFuncDelegate($q, database, 'pos_system_config');
                    db.query("delete from " + urlModel.tableName).then(function () {
                        validateResponseData(response, urlModel.tableName, urlModel.desc);
                        if (!Utils.isEmpty(response.data)) {
                            $scope.MDInfo = response.data;
                            $scope.initSystem_config();
                        } else {
                            responseDataNull(urlModel.tableName, urlModel.desc);
                        }
                    }, function (err, sql) {
                        installError(urlModel.tableName, urlModel.desc, err, sql);
                    })
                }, JSON.stringify({ "groupId": $scope.groupID, "guid": $scope.storeID }),
                "POST",
                function (xhr, status, error, data) {
                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                });
        }



        $scope.initSystem_config = function () {
            $scope.runningDBCount++;
            SystemConfigService.batchSaveConfig({
                "MD_ID": $scope.storeID,
                "GroupID": $scope.groupID,
                "GroupCode": $scope.groupCode,
                "StoreCode": $scope.storeCode,
                "ServerHost": $scope.serverHost,
                "OrderPrefix": ("" + $scope.storeCode).replace("" + $scope.groupCode, ""),
                "GroupType": $scope.groupIdType
            }, function (err, results) {
                $scope.runningDBCount--;
                if (err) {
                    installError("pos_system_config", LANGUAGECACHE["str_tip_baseinfo"], err);
                    return Utils.showFailureInfo(err.message);
                }
                $scope.runningDBCount++;
                SystemConfigService.batchSaveConfig({
                    "HotelName": ($scope.MDInfo.orgName == null || $scope.MDInfo.orgName == "null") ? "" : $scope.MDInfo.orgName,
                    "HotelAddress": ($scope.MDInfo.address == null || $scope.MDInfo.address == "null") ? "" : $scope.MDInfo.address,
                    "HotelTel": ($scope.MDInfo.tel == null || $scope.MDInfo.tel == "null") ? "" : $scope.MDInfo.tel
                }, function (err, results) {
                    $scope.runningDBCount--;
                    if (err) {
                        installError("pos_system_config",  LANGUAGECACHE["str_tip_baseinfo"], err);
                        return Utils.showFailureInfo(err.message);
                    }
                    installSuccess("pos_system_config",  LANGUAGECACHE["str_tip_baseinfo"]);
                    //此处暂定为以下默认值
                    var initXiao = [{ systmConfigName: "wangluo_Port", systemConfigAlias:  LANGUAGECACHE["str_tip_xpprintduankou"], systemConfigValue: "9100", mdId: $scope.storeID },
                        { systmConfigName: "dayinZhangshu", systemConfigAlias: LANGUAGECACHE["str_tip_xpprintpages"], systemConfigValue: "1", mdId: $scope.storeID },
                        { systmConfigName: "dayinSize", systemConfigAlias: LANGUAGECACHE["str_tip_xpprintstandards"], systemConfigValue: "80mm", mdId: $scope.storeID },
                        { systmConfigName: "dayinType", systemConfigAlias:LANGUAGECACHE["str_tip_xpprintstyle"] , systemConfigValue: "network", mdId: $scope.storeID },
                        { systmConfigName: "zouziHangshu", systemConfigAlias: LANGUAGECACHE["str_tip_xpprintlines"], systemConfigValue: "4", mdId: $scope.storeID },
                        { systmConfigName: "wangluo_DayinjiIP", systemConfigAlias: LANGUAGECACHE["str_tip_xpprintnetIP"], systemConfigValue: "0.0.0.0", mdId: $scope.storeID }]
                    for (var i in initXiao) {
                        onInstall(initXiao[i]);
                    }
                });

            });
        };

        function onInstall(obj) {
            var setPiaoInit = setXiaoPiaoInit(obj.systmConfigName, obj.systemConfigAlias, obj.systemConfigValue, obj.mdId);
            SystemConfigService.setInitSystemconfig(setPiaoInit);
        }

        function setXiaoPiaoInit(systmConfigName, systemConfigAlias, systemConfigValue, mdId) {
            var xiaoPiaoInit = new SystemConfig();
            xiaoPiaoInit.systmConfigName = systmConfigName;//类型拼音名称
            xiaoPiaoInit.systemConfigAlias = systemConfigAlias;//类型中文名称
            xiaoPiaoInit.systemConfigValue = systemConfigValue;//存入值
            xiaoPiaoInit.mdId = mdId;//门店ID
            xiaoPiaoInit.valueType = BIZCONSTANT.POS_SYSTEM_CONFIG_MODULE.xiaopiao;//插入类型为小票
            xiaoPiaoInit.operatorTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");//插入日期

            return xiaoPiaoInit;
        };


        var _buildModelData = function (tableName, row, db) {
            var tableMeta = null;
            for (var idx in TABLES_SCHEME) {
                if (TABLES_SCHEME[idx].name.toLowerCase() == tableName.toLowerCase()) {
                    tableMeta = TABLES_SCHEME[idx];
                    break;
                }
            }
            var output = {};
            if (tableMeta != null) {
                for (var idx in tableMeta.columns) {
                    var colDef = tableMeta.columns[idx];
                    if (row[colDef.name] != null) {
                        var value = row[colDef.name];
                        if (value.length > 0 && value.indexOf("/Date") != -1) {
                            value = value.replace("/Date(", "").replace(")/", "");
                            value = new Date(parseInt(value)).format("yyyy-MM-dd hh:mm:ss");
                        }
                        if (colDef.name == "enabled") {
                            if (value) {
                                value = "true";
                            } else {
                                value = "false";
                            }
                        }
                        output[colDef.name] = value;
                    }
                    if (colDef.name == "isDeleted") {
                        if (row["deleted"] != null) {
                            if (row["deleted"]) {
                                output[colDef.name] = "true";
                            } else {
                                output[colDef.name] = "false";
                            }

                        } else {
                            output[colDef.name] = "false";
                        }
                    }
                }
                if (tableName == "pos_caipin") {
                    output["isScomb"] = row["ifScomb"] == null ? false : row["ifScomb"] == "null" ? false : row["ifScomb"] == "" ? false : row["ifScomb"];
                    output["costprice"] = row["costPrice"];
                }
                if (tableName == "pos_scomb_caipin") {
                    output["caipinId"] = row["tcdishId"];
                    output["name"] = row["tcdishName"];
                    output["num"] = row["tcdishNum"];
                    output["unitId"] = row["tcdishUnitId"];
                    output["unitName"] = row["tcdishUnitName"];
                    output["isBeixuan"] = row["tcdishIfbx"];
                    output["costprice"] = row["costPrice"];
                }
                if (tableName == "pos_scomb_beixuan_caipin") {
                    output["bxCaipinId"] = row["bxDishId"];
                    output["bxCaipinNum"] = row["bxDishNum"];
                    output["bxCaipinName"] = row["bxDishName"];
                    output["bxCaipinUnitId"] = row["bxDishUnitId"];
                    output["bxCaipinUnitName"] = row["bxDishUnitName"];
                    output["bxCaipinSalePrice"] = row["bxDishPrice"];
                    output["costprice"] = row["bxDishCostPrice"];
                }

                if (tableName == "pos_zhuotai") {
                    output["code"] = row["orderNo"];
                }
                if (tableName == "pos_kouwei") {
                    output["quickCode"] = row["kwQuickCode"];
                }
                if (tableName == "pos_zuofa") {
                    output["typeId"] = row["zuoFaTypeId"];
                }
                if (tableName == "pos_cai_wu_ke_mu") {
                    output["code"] = row["cwkmCode"];
                    output["name"] = row["cwkmName"];
                    //如果实收字段不为空
                    if (row["isShiShou"] != null) {
                        if (row["isShiShou"])
                            output["isshishou"] = "true";
                        else
                            output["isshishou"] = "false";
                    }

                }
                if (tableName == "pos_canbie") {
                    output["code"] = row["canbieNo"];
                    output["name"] = row["canbieName"];
                    output["starttime"] = row["startTime"];
                    output["eattime"] = row["eatTime"];
                    output["endtime"] = row["endTime"];
                    output["mdId"] = row["orgId"];
                    output["formatStarttime"] = row["formatStartTime"];
                    output["formatEattime"] = row["formatEatTime"];
                    output["formatEndtime"] = row["formatEndTime"];
                }
                if (tableName == "printer") {
                    output["size"] = row["guiGe"];
                    output["is_zhenda"] = row["isZhenShi"] == 'N' ? 0 : 1;
                    output["backup_id"] = row["backupPrintId1"];
                    output["backup_id2"] = row["backupPrintId2"];
                }
                if (tableName == "printer_config") {
                    output["printer_id"] = row["printId"];
                }
                if (tableName == "pos_print_caipin") {
                    output["printSchemeId"] = row["schemeId"];
                }
                if (tableName == "pos_print_scheme") {
                    output["printid"] = row["printId"];
                }

                if(tableName == "pos_zhekou"){
                    if (colDef.name == "applyWholeOrder") {
                        var colName = "apply_whole_order";
                        var v = row["applyWholeOrder"];
                        if (v != null) {
                            if (v) {
                                output[colName] = "true";
                            } else {
                                output[colName] = "false";
                            }
                        } else {
                            output[colName] = "false";
                        }
                    }
                }

            }
            return output;
        };

        $scope.initPerson = function (prefix, urlModel) {

            callAjax(prefix + urlModel.url, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": $scope.groupID, "orgId": $scope.storeID }), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(response.msg);
                    }
                    var db = new DatabaseFuncDelegate($q, database, urlModel.tableName);
                    db.query("delete from " + urlModel.tableName).then(function () {
                        if (!validateResponseData(response, urlModel.tableName, urlModel.desc)) {
                            return;
                        }
                        if (!Utils.isEmpty(response.pageList) && response.pageList.rows.length > 0) {

                            var data = [];
                            for (var idx in response.pageList.rows) {
                                data.push(_buildModelData(urlModel.tableName, response.pageList.rows[idx]));
                            }
                            if (data.length > 0) {
                                $scope.runningDBCount++;

                                db.insertBatch(data).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess(urlModel.tableName, urlModel.desc);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError(urlModel.tableName, urlModel.desc, err, sql);
                                });
                            }
                        } else {
                            responseDataNull(urlModel.tableName, urlModel.desc);
                        }
                    });
                },
                JSON.stringify({ "groupId": $scope.groupID, "orgId": $scope.storeID }),
                "POST",
                function (xhr, status, error, data) {

                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                })
        }

        $scope.initPersonFuncMissions = function (prefix, urlModel, strQuery) {
            if (strQuery == null)
                strQuery = "?orgId=" + $scope.storeID + "&groupId=" + $scope.groupID;

            callAjax(prefix + urlModel.url + strQuery, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, strQuery, JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }
                    var db = new DatabaseFuncDelegate($q, database, urlModel.tableName);
                    db.query("delete from " + urlModel.tableName).then(function () {
                        if (!validateResponseData(response, urlModel.tableName, urlModel.desc)) {
                            return;
                        }
                        if (!Utils.isEmpty(response.data) && response.data.functionPermissions.length > 0) {

                            var data = [];
                            for (var idx in response.data.functionPermissions) {
                                data.push(_buildModelData(urlModel.tableName, response.data.functionPermissions[idx]));
                            }
                            if (data.length > 0) {
                                $scope.runningDBCount++;
                                db.insertBatch(data).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess(urlModel.tableName, urlModel.desc);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError(urlModel.tableName, urlModel.desc, err, sql);
                                });
                            }
                        } else {
                            responseDataNull(urlModel.tableName, urlModel.desc);
                        }
                    });
                }, {},
                "GET",
                function (xhr, status, error, data) {
                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                });
        }

        $scope.initPersonPosMissions = function (prefix, urlModel, strQuery) {
            if (strQuery == null)
                strQuery = "?orgId=" + $scope.storeID + "&groupId=" + $scope.groupID;

            callAjax(prefix + urlModel.url + strQuery, function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, strQuery, JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }
                    var db = new DatabaseFuncDelegate($q, database, urlModel.tableName);
                    db.query("delete from " + urlModel.tableName).then(function () {
                        if (!validateResponseData(response, urlModel.tableName, urlModel.desc)) {
                            return;
                        }
                        if (!Utils.isEmpty(response.data) && !Utils.isEmpty(response.data.dataPermissions) && response.data.dataPermissions.posPermission.length > 0) {

                            var data = [];
                            for (var idx in response.data.dataPermissions.posPermission) {
                                data.push(_buildModelData(urlModel.tableName, response.data.dataPermissions.posPermission[idx]));
                            }
                            if (data.length > 0) {
                                $scope.runningDBCount++;

                                db.insertBatch(data).then(function () {
                                    $scope.runningDBCount--;
                                    installSuccess(urlModel.tableName, urlModel.desc);
                                }, function (err, sql) {
                                    $scope.runningDBCount--;
                                    installError(urlModel.tableName, urlModel.desc, err, sql);
                                });
                            }
                        } else {
                            responseDataNull(urlModel.tableName, urlModel.desc);
                        }
                    });
                },
                {},
                "GET", function (xhr, status, error, data) {
                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                })
        }


        $scope.initSimpleGet = function (prefix, urlModel, strQuery) {
            if (strQuery == null)
                strQuery = "?orgId=" + $scope.storeID + "&groupId=" + $scope.groupID;


            callAjax(prefix + urlModel.url + strQuery,
                function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, strQuery, JSON.stringify(response), this.url);

                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }

                    $scope.initSimpleCallback(response, urlModel.tableName, urlModel.desc);
                }, {},
                "GET",
                function (xhr, status, error, data) {
                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                });

        };


        $scope.initSimple = function (prefix, urlModel, rb) {
            var requestBody = null;
            if (rb)
                requestBody = rb;
            else
                requestBody = { "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID, "mdId": $scope.storeID };

            callAjax(prefix + urlModel.url,
                function (response) {
                    AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify(requestBody), JSON.stringify(response), this.url);
                    if (response.status != "success") {
                        return Utils.showFailureInfo(result.msg);
                    }

                    $scope.initSimpleCallback(response, urlModel.tableName, urlModel.desc);
                }, JSON.stringify(requestBody),
                "POST",
                function (xhr, status, error, data) {
                    responseError(urlModel.tableName, urlModel.desc, error, data, status);
                });

        };


        $scope.initSimpleCallback = function (response, tableName, desc) {
            var db = new DatabaseFuncDelegate($q, database, tableName);
            db.query("delete from " + tableName).then(function () {
                if (!validateResponseData(response, tableName, desc)) {
                    return;
                }

                if (!Utils.isEmpty(response.dataList)) {

                    response.dataList = Utils.uniqueArrayObject(response.dataList, "guid");
                    if (tableName == INIT.CAIBIE.tableName) {

                    }

                    var data = [];
                    for (var idx in response.dataList) {
                        if (validateResponseRow(tableName, response.dataList[idx]))
                            data.push(_buildModelData(tableName, response.dataList[idx]));
                    }
                    if (data.length > 0) {
                        $scope.runningDBCount++;

                        db.insertBatch(data).then(function () {
                            $scope.runningDBCount--;
                            installSuccess(tableName, desc);
                        }, function (err, sql) {
                            $scope.runningDBCount--;
                            installError(tableName, desc, err, sql);
                        });

                    } else {
                        responseDataNull(tableName, desc);
                    }
                } else {
                    responseDataNull(tableName, desc);
                }
            });
        }

        $scope.installDbData = function (db, data) {
            db.insertBatch(data).then(function () {
                $scope.runningDBCount--;
                installSuccess(urlModel.tableName, urlModel.desc);
            }, function (err, sql) {
                $scope.runningDBCount--;
                installError(urlModel.tableName, urlModel.desc, err, sql);
            });
        }

        /* JP 2016-04-13
         * 防止后台出现无效的数据
         */
        function validateResponseRow(tableName, row) {
            //if (tableName == INIT.ZHUOFA.tableName || tableName == INIT.TUICAIREASON.tableName || tableName == INIT.RESENTREASON.tableName || tableName == INIT.CAIPIN.tableName ) {
            //    if (row.code == undefined || row.code == "undefined")
            //        return false;
            //} else if (tableName == INIT.AREA.tableName) {
            //    if (row.areaCode == undefined || row.areaCode == "undefined")
            //        return false;
            //} else if (tableName == INIT.DISH_TYPE.tableName) {
            //    if (row.dishTypeCode == undefined || row.dishTypeCode == "undefined")
            //        return false;
            //} else if (tableName == INIT.DISH_TYPE.tableName) {
            //    if (row.dishTypeCode == undefined || row.dishTypeCode == "undefined")
            //        return false;
            //} else if (tableName == INIT.ZHUOFA_TYPE.tableName) {
            //    if (row.orderNo == undefined || row.orderNo == "undefined")
            //        return false;
            //} else if (tableName == INIT.KOUWEI.tableName) {
            //    if (row.kwCode == undefined || row.kwCode == "undefined")
            //        return false;
            //} else if (tableName == INIT.PERSON.tableName) {
            //    if (row.personNo == undefined || row.personNo == "undefined")
            //        return false;
            //} else if (tableName == INIT.PERSON_ROLE.tableName) {
            //    if (row.roleCode == undefined || row.roleCode == "undefined")
            //        return false;
            //} else if (tableName == INIT.SCOMB_CAIPIN.tableName) {
            //    if (row.name == undefined || row.name == "undefined")
            //        return false;
            //}


            //上面先注释掉 需要再放出来
            if (tableName == INIT.CAIWUKEMU.tableName) {
                if (row.cwkmCode == undefined || row.cwkmCode == "undefined")
                    return false;
            } else if (tableName == INIT.CAIBIE.tableName) {
                if (row.canbieNo == undefined || row.canbieNo == "undefined")
                    return false;
            } else if (tableName == INIT.ZHUOTAI.tableName) {
                if (row.orderNo == undefined || row.orderNo == "undefined")
                    return false;
            }
            return true;
        }


        /* 提示集中处理 开始  */

        //安装时验证获取到的数据源
        function validateResponseData(response, tableName, desc) {
            //$scope.checkItems[tableName].execute = true;
            if (response == null) {
                if ($scope.checkItems[tableName].required == true)
                    $scope.installDetails += "<div style='color:red;'> " + desc + LANGUAGECACHE["str_tip_initfaildatazero"]+"</div>";
                responseDataNull(tableName, desc)
                return false;
            }
            if (response.status != "success") {
                if ($scope.checkItems[tableName].required == true)
                    $scope.installDetails += "<div style='color:red;'> " + desc + LANGUAGECACHE["str_tip_initfailreason"] + response.msg + "</div>";
                installErrorByBack(tableName, desc, response)
                return false;
            }
            return true;
        }
        //安装成功时的提示
        function installSuccess(tableName, desc) {
            $scope.checkItems[tableName].installed = true;

            if ($scope.checkItems[tableName].required == true) {
                progress();

                //$scope._checkInstallCompleted();
            }
            $scope.checkItems[tableName].execute = true;

            $scope._checkInstallCompleted();
        }

        //安装失败时的提示  后台请求出错
        function installErrorByBack(tableName, desc, response) {

            AjaxLogger.log(BIZCONSTANT.POSUSER, desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), JSON.stringify(response));

            //console.log(desc + "安装失败原因----->::" + err.message + "----->SQL::" + err.sql);
            if ($scope.checkItems[tableName].required == true)
                $scope.installDetails += "<div style='color:red;'>" + desc + LANGUAGECACHE["str_tip_initfail"]+"<br/>" + response.msg;

            $scope.checkItems[tableName].execute = true;
            $scope._checkInstallCompleted();
        }


        //安装失败时的提示
        function installError(tableName, desc, err, sql) {

            AjaxLogger.log(BIZCONSTANT.POSUSER, desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), JSON.stringify(err));

            //console.log(desc + "安装失败原因----->::" + err.message + "----->SQL::" + err.sql);
            if ($scope.checkItems[tableName].required == true)
                $scope.installDetails += "<div style='color:red;'>" + desc + LANGUAGECACHE["str_tip_initfail"]+"<br/>" + err.message + "<br/>" + err.sql + "</div>";

            $scope.checkItems[tableName].execute = true;
            $scope._checkInstallCompleted();
        }
        //安装时获取请求出错的提示
        function responseError(tableName, desc, error, data, status) {
            AjaxLogger.log(BIZCONSTANT.POSUSER, desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), JSON.stringify(error));

            if (status == "timeout" || status == "error") {
                $scope.installDetails += "<div style='color:red;'>"+LANGUAGECACHE["str_tip_initfailinstallfail"]+"</div>";
                return;
            }

            //console.log(desc + "获取请求原因:" + err.message + "error----->:: " + error.responseText + ":: data=" + data);
            if ($scope.checkItems[tableName].required == true)
                $scope.installDetails += "<div style='color:red;'>" + desc + LANGUAGECACHE["str_tip_initfailconnectrooterror"] + error.responseText + " :: data=" + data + "</div>";

            $scope.checkItems[tableName].execute = true;
            $scope._checkInstallCompleted();
        }
        //安装时获取数据为空时的提示
        function responseDataNull(tableName, desc) {
            AjaxLogger.log(BIZCONSTANT.POSUSER, desc, JSON.stringify({ "groupId": $scope.groupID, "groupCode": $scope.groupCode, "orgid": $scope.storeID }), LANGUAGECACHE["str_tip_installfailnotdata"]);
            //console.log(desc + "安装失败,没有数据");
            if ($scope.checkItems[tableName].required == true)
                $scope.installDetails += "<div style='color:red;'>" + desc + LANGUAGECACHE["str_tip_initfailconnectroot"]+"</div>";

            $scope.checkItems[tableName].execute = true;
            $scope._checkInstallCompleted();
        }
        /* 提示集中处理 结束  */


        //$scope.begin = function () {
        //    var gui = require('nw.gui');
        //    var win = gui.Window.get();
        //    win.close();
        //};


        $scope.selectInput = function (key) {
            $scope.selectInputName = key;
        }


        /*大键盘事件 开始*/
        $scope.clickKey = function (key) {
            if ("ENTER" == key) {

            } else if ("DELETE" == key) {
                deleteSelectValue();
            } else {
                inputSelectValue(key);
            }
        }
        function inputSelectValue(key) {
            if ("name" == $scope.selectInputName) {
                $scope.userName = ($scope.userName == null ? "" : $scope.userName) + "" + key;
            } else if ("pwd" == $scope.selectInputName) {
                $scope.passWord = ($scope.passWord == null ? "" : $scope.passWord) + "" + key;
            } else if ("ip" == $scope.selectInputName) {
                $scope.masterIp = ($scope.masterIp == null ? "" : $scope.masterIp) + "" + key;
            }

        }
        //按下确认键
        function keyFormOK() {
            $scope.zhuotais.items = $scope.validateSources;
            getValidateSources();
            showAndHideJP();
        }
        //按下删除键
        function deleteSelectValue() {
            var value = null;
            if ("name" == $scope.selectInputName) {
                value = $scope.userName == null ? "" : $scope.userName;
            } else if ("pwd" == $scope.selectInputName) {
                value = $scope.passWord == null ? "" : $scope.passWord;
            } else if ("ip" == $scope.selectInputName) {
                value = $scope.masterIp == null ? "" : $scope.masterIp;
            }

            value += "";
            if (value.length > 0)
                value = value.substring(0, value.length - 1);

            if ("name" == $scope.selectInputName) {
                $scope.userName = value;
            } else if ("pwd" == $scope.selectInputName) {
                $scope.passWord = value;
            } else if ("ip" == $scope.selectInputName) {
                $scope.masterIp = value;
            }

        }

        //清除输入
        $scope.clearValur = function () {
            if ("name" == $scope.selectInputName) {
                $scope.userName = "";
            } else if ("pwd" == $scope.selectInputName) {
                $scope.passWord = "";
            } else if ("ip" == $scope.selectInputName) {
                $scope.masterIp = "";
            }
        }
        /*大键盘事件 结束*/

        $scope.closeWindow = function () {
            window.close();
        }

        $scope.isShowCloseBtn = function () {
            return $scope.installDetails.length > 0;
        }

        $rootScope.$on("dishSelected", $scope.onDishSelected);
        $rootScope.$on("tasteSelected", $scope.onTasteSelected);
        $rootScope.$on("tasteUnSelected", $scope.onTasteUnSelected);
        $rootScope.$on("unitSelected", $scope.onUnitSelected);
        $rootScope.$on("unitUnSelected", $scope.onUnitUnSelected);
        $rootScope.$on("addDishCount", $scope.onAddDishCount);
        $rootScope.$on("orderRemoved", $scope.onOrderRemoved);
        $rootScope.$on("orderRecharged", $scope.onOrderRecharged);
        $rootScope.$on("doShowPanel", $scope.showTabPanel);
        $rootScope.$on("doBillOrder", $scope.doBillOrderAction);
        $rootScope.$on("doLogout", $scope.logout);
        $rootScope.$on("initStartupDevice", $scope.doInitStartupDevice);
        $rootScope.$on("afterLogin", $scope.doAfterLogin);
        $rootScope.$on("orderAbondonChanged", $scope.onOrderAbondonChanged);
    }]);