app.controller("ZhuotaiJieSuan", ["$scope", "$location", "$timeout", '$interval', '$q', 'database', 'auth', 'AuthService', '$rootScope', 'ZhuotaiJieSuanService',
    'PrintService', 'DiancaiService', 'BanciService', 'OperatorService', 'ZhuotaiService', 'AndroidService',
    function ($scope, $location, $timeout, $interval, $q, database, auth, AuthService, $rootScope, ZhuotaiJieSuanService, PrintService, DiancaiService,
              BanciService, OperatorService, ZhuotaiService, AndroidService) {
        $scope.currentOperator = $rootScope.curUser;
        $scope.areas = [];
        $scope.contentNum = 1;
        $scope.deskAreaHeight = 0;
        $scope.zhuotais = {
            total: 0,
            pages: 0,
            rows: 100,
            currentPage: 1,
            items: []
        };
        $scope.currentArea = null;
        $scope.currentZhuotai = null;
        $scope.currentOrder = new Order();
        $scope.currentFocus = null;

        $scope.ztfootloading = true;

        $scope.inHuantai = false;
        $scope.huantaiOrignal = null;
        $scope.huantaiTarget = null;

        $scope.selectValue = null;
        $scope.oldZhuotais = null;

        $scope.operators = [];
        $scope.selectOperator = null;
        $scope.validateSources = [];
        $scope.pagination = new pagination({rows: [], size: 1});
        $scope.allZhuotais = [];
        var stop = true;
        // $scope.pagination.culsize($('.ys-check-list').height() - 41, 41);

        //计算每页显示的桌台数
        function calZhuotaiRows() {
            //var deskAreaHeight = $("#_rootElement").height() - $(".bg-main").height() - $(".swiper-container").height() - $(".text-main").height();
            //var deskAreaWidth = $(".desk-wrap").width();
            //var deskMargin = 5;
            //var deskHeight = 40;
            //var deskWidth = deskAreaWidth / 3;
            //var rows = Math.floor(deskAreaHeight / (deskMargin + deskHeight)) * Math.floor(deskAreaWidth / (deskMargin + deskWidth));
            ////对计算出来的数量求余，确保填充完每一行
            //var calnum = rows % 3;
            //rows = rows - calnum;
            //$scope.zhuotais.rows = rows;
            //$scope.refreshrows = rows;
            var deskAreaHeight = $("#_rootElement").height() - $(".bg-main").height() - $(".swiper-container").height() - $(".text-main").height();
            $scope.deskAreaHeight = deskAreaHeight;
            var deskAreaWidth = $(window).width();
            var deskHeight = 70;
            var rows = Math.floor(deskAreaHeight / deskHeight) * 3;
            //对计算出来的数量求余，确保填充完每一行
            var calnum = rows % 3;
            rows = rows - calnum;
            $scope.zhuotais.rows = rows;
            $scope.refreshrows = rows;
        }

        function loadAreas() {
            ZhuotaiJieSuanService.getAreas(function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.areas = seq;
            });
        }

        function loadAllJieSuanZhuotais() {
            ZhuotaiJieSuanService.getJieSuanZhuotaisCount(function (err, seq) {
                if (seq == 0) {
                    $scope.ztfootloading = false;
                }
                //ZhuotaiJieSuanService.getJieSuanZhuotais(0, seq, function (err, seq) {
                //    if (err) {
                //        return Utils.showFailureInfo(err.message);
                //    }
                //    $scope.allZhuotais = seq;
                //});

                ZhuotaiJieSuanService.getZhuotaisByParams("",0,seq,function(err,seq){
                    if(err){
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.allZhuotais = seq;
                })
            });
        }

        function loadZhuotaisByArea(areaId) {
            $(window).scrollTop(0);
            $scope.zhuotais.currentPage = 1;
            $scope.refreshrows = $scope.zhuotais.rows;
            ZhuotaiJieSuanService.getJieSuanZhuotaisCountByArea(areaId, function (err, seq) {
                Utils.hideLoading();
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.zhuotais.total = seq;
                $scope.zhuotais.pages = Math.ceil($scope.zhuotais.total / $scope.zhuotais.rows);
                if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                    $scope.ztfootloading = true;
                } else {
                    $scope.ztfootloading = false;
                }
                ZhuotaiJieSuanService.getZhuotaisByParams(areaId, ($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.zhuotais.items = seq;
                });
            });
            clear();
        }

        function loadJieSuanZhuotais() {
            $(window).scrollTop(0);
            $scope.zhuotais.currentPage = 1;
            $scope.refreshrows = $scope.zhuotais.rows;
            ZhuotaiJieSuanService.getJieSuanZhuotaisCount(function (err, seq) {
                if (err) {
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.message);
                }
                $scope.zhuotais.total = seq;
                if ($scope.zhuotais.total > 0) {
                    $scope.zhuotais.pages = Math.ceil($scope.zhuotais.total / $scope.zhuotais.rows);
                    if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                        $scope.ztfootloading = true;
                    } else {
                        $scope.ztfootloading = false;
                    }
                    ZhuotaiJieSuanService.getZhuotaisByParams("",($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                        Utils.hideLoading();
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }
                        $scope.zhuotais.items = seq;
                    });
                } else {
                    Utils.hideLoading();
                }
            });
            clear();
        }

        $scope.initkaitai = function () {
            if (BUSINESS.CURRENT_ORDER != null) {
                $scope.currentOrder = BUSINESS.CURRENT_ORDER;
            }
            Utils.showLoading();
            stop = true;
            loadAreas();
            calZhuotaiRows();
            loadJieSuanZhuotais();
            $scope.currentZhuotai = null;
            loadAllJieSuanZhuotais();
            scrollinit();
            //if (CONSTANTS.SystemConfigs["ServerHost"] != null && CONSTANTS.SystemConfigs["ServerHost"].SystemConfigValue != null) {
            //    $scope.serverHost = CONSTANTS.SystemConfigs["ServerHost"].SystemConfigValue;
            //    $scope.posURL = $scope.serverHost + "/sop-pos-api";
            //}
        }

        $scope.clearInput = function () {
            clear();
        };

        function clear() {
            if ($scope.oldZhuoTais != null) {
                $scope.zhuotais.items = $scope.oldZhuoTais;
                $scope.selectValue = '';
                $scope.lastselectvalue = '';
                $scope.oldZhuoTais = null;
                if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                    $scope.ztfootloading = true;
                } else {
                    $scope.ztfootloading = false;
                }
            }
        }

        $scope.selectAll = function () {
            if (!Utils.isEmpty($scope.selectValue)) {
                $("#jiesuan_search").select();
            }
        }

        $scope.selectArea = function (area) {
            $scope.contentNum = 1;
            stop = true;
            $scope.currentArea = area;
            $scope.showKaitai = null;
            $scope.currentZhuotai = null;
            $scope.currentOrder = new Order();
            $scope.zhuotais.currentPage = 1;
            if (area == null) {
                loadJieSuanZhuotais();
            } else {
                loadZhuotaisByArea(area.guid);
            }
        };

        $scope.gotoBack = function () {
            $location.url("/main");
        }

        $scope.clickNextPage = function () {
            if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                $scope.currentZhuotai = null;
                $scope.currentOrder = new Order();
                $scope.zhuotais.currentPage += 1;
                if ($scope.currentArea != null) {
                    ZhuotaiJieSuanService.getZhuotaisByParams($scope.currentArea.guid, ($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }
                        $scope.refreshrows = $scope.zhuotais.currentPage * $scope.zhuotais.rows;
                        for (var i = 0; i < seq.length; i++) {
                            $scope.zhuotais.items.push(seq[i]);
                        }
                    });
                } else {
                    ZhuotaiJieSuanService.getZhuotaisByParams("",($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }
                        $scope.refreshrows = $scope.zhuotais.currentPage * $scope.zhuotais.rows;
                        for (var i = 0; i < seq.length; i++) {
                            $scope.zhuotais.items.push(seq[i]);
                        }
                    });
                }
            }
        };

        //滑动到底监听
        function scrollinit() {
            $("#desk_list").scroll(function () {
                if (!Utils.isEmpty($scope.selectValue)) {
                    $scope.ztfootloading = false;
                    return;
                }
                var scrollOffset = $(this).scrollTop();
                var divHeight = $(this).height();
                var contentHeight = $(this).height();

                if (scrollOffset + divHeight >= contentHeight * $scope.contentNum) {
                    //此处是滚动条到底部时候触发的事件，在这里写要加载的数据，或者是拉动滚动条的操作
                    if (stop == true) {
                        $scope.contentNum++;
                        stop = false;
                        $scope.ztfootloading = true;
                        $scope.clickNextPage();
                    }
                    if ($scope.zhuotais.currentPage == $scope.zhuotais.pages) {
                        $scope.ztfootloading = false;
                    }
                }
            });
        }

        //$(function () {
        //        $("#desk_list").scroll(function () {
        //        if (!Utils.isEmpty($scope.selectValue)) {
        //            $scope.ztfootloading = false;
        //            return;
        //        }
        //        var scrollOffset = $(this).scrollTop();
        //        var divHeight = $(this).height();
        //        var contentHeight = $(this).height();
        //
        //        if ( scrollOffset + divHeight >= contentHeight * $scope.contentNum) {
        //            //此处是滚动条到底部时候触发的事件，在这里写要加载的数据，或者是拉动滚动条的操作
        //            if (stop == true) {
        //            $scope.contentNum ++;
        //                stop = false;
        //                $scope.ztfootloading = true;
        //                $scope.clickNextPage();
        //            }
        //            if ($scope.zhuotais.currentPage == $scope.zhuotais.pages) {
        //                $scope.ztfootloading = false;
        //            }
        //        }
        //    });
        //});

        $scope.sglClickZhuotai = function (zhuotai) {
            if ($scope.inHuantai) {
                if (zhuotai.orderId != null) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_cantchangetable"]);
                }
                $scope.huantaiTarget = zhuotai;
                $("#huantaiDialog").modal('show');
            } else {
                $scope.currentZhuotai = zhuotai;
                if (zhuotai.order != null) {
                    $scope.currentOrder = zhuotai.order;
                }
            }
        };

        $scope.gotoJieSuan = function (zhuotai) {
            $scope.currentZhuotai = zhuotai;
            if (zhuotai.order != null) {
                $scope.currentOrder = zhuotai.order;
            }
            if (BIZCONSTANT.ORDER_STATUS_YI_KAI_TAI < $scope.currentZhuotai.order.status < BIZCONSTANT.ORDER_STATUS_YI_JIE_SUAN) {
                $scope.currentZhuotai.inPage = $scope.zhuotais.currentPage;
                $scope.currentZhuotai.inArea = $scope.currentArea;
                $scope.currentZhuotai.showKaitai = $scope.showKaitai;
                BUSINESS.CURRENT_ZHUOTAI = $scope.currentZhuotai;
                BUSINESS.CURRENT_ORDER = $scope.currentOrder;
            }

            if (!Utils.roleAble(ROLE_POWER.JS)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            if ($rootScope.curUser.getNeedKaiBan()) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstkaibanthatjiesuan"]);
                return;
            }
            // 在本地查是否有未落单菜品
            if (!Utils.isEmpty(localStorage.getItem(zhuotai.name))) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstluodan"]);
            }
            Utils.showLoading();
            //TODO ,怎样去检查是否有未落单的菜品(在数据库查)
            ZhuotaiJieSuanService.existsUnconfirmedCaiPin(zhuotai.orderId, function (err, luoDanTime) {
                Utils.hideLoading();
                if (err) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstluodan"]);
                    return;
                }
                if (_.isNil(luoDanTime)) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_cantjiesuanbecauseluodan"]);
                    return;
                }
                AndroidService.needChengZhong($scope.currentOrder.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, cb) {
                    if (err != null) {
                        Utils.showFailureInfo(err);
                        return;
                    }
                    if (cb > 0) {
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_pleasesureheft"]);
                        return;
                    } else {
                        //查看当前账单的落单时间是否是和班次匹配
                        if (!$rootScope.curUser.jieSuanRiAllowed($scope.currentOrder.luoDanTime)) {
                            Utils.showFailureInfo(LANGUAGECACHE["str_tip_banciwei"]+"【" + $rootScope.curUser.banCiHao + "】"+LANGUAGECACHE["str_tip_jiebanandjiesuan"]);
                            return;
                        }
                        ZhuotaiService.lockZhuoTai($scope.currentZhuotai.guid, null, function (err, cb) {
                            if (err != null) {
                                return Utils.showFailureInfo(err);
                            }
                            $rootScope.currentZhuotai = $scope.currentZhuotai;
                            $rootScope.currentOrder = $scope.currentOrder;
                            BUSINESS.CURRENT_ZHUOTAI = $scope.currentZhuotai;
                            BUSINESS.CURRENT_ORDER = $scope.currentOrder;
                            $rootScope.source = LANGUAGECACHE["str_tip_jiesuan"];
                            $location.url("/jiesuan");
                        });
                    }
                });
            });
        };

        $scope.areaSelected = function (area) {
            if ($scope.currentArea == null) {
                return area == null;
            } else {
                return area != null && $scope.currentArea.guid == area.guid;
            }
        };

        $scope.zhuotaiSelected = function (zhuotai) {
            return $scope.currentZhuotai != null && $scope.currentZhuotai.guid == zhuotai.guid;
        };

        $scope.zhuotaiStatus = function (zhuotai, status) {
            return zhuotai.order.status == status;
        };

        $scope.zhuotaiYiKaitai = function (zhuotai) {
            return zhuotai.order.status > 0;
        };

        $scope.zhuotaiYiYuJie = function (zhuotai) {
            return zhuotai.order.status == BIZCONSTANT.ORDER_STATUS_YI_YuJie;
        };


        function inputSelectValue(key) {
            $scope.selectValue = ($scope.selectValue == null ? "" : $scope.selectValue) + "" + key;
        }


        $scope.oldZhuoTais = null;
        $scope.lastselectvalue = '';
        $scope.searchChange = function (zhuoTaiItems) {
            if (Utils.isEmpty(zhuoTaiItems)) {
                zhuoTaiItems = $scope.allZhuotais;
            }
            if ($scope.selectValue && $scope.selectValue != '') {
                if (!$scope.lastselectvalue || $scope.lastselectvalue == '') {
                    $scope.oldZhuoTais = $scope.zhuotais.items;
                }
                var filterList = [];
                for (var i = 0; i < zhuoTaiItems.length; i++) {
                    var item = zhuoTaiItems[i];
                    if (item.code.toLocaleLowerCase().indexOf($scope.selectValue) > -1 || item.quickCode.toLocaleLowerCase().indexOf($scope.selectValue) > -1) {
                        filterList.push(item);
                        //每次只查10条,如果当前结果集大于10条就跳出循环，继续输入匹配
                        if (filterList.length >= 10 && filterList.length % 3 == 0) {
                            break;
                        }
                    }
                }
                $scope.zhuotais.items = filterList;
                $scope.ztfootloading = false;
            } else {
                if ($scope.oldZhuoTais != null) {
                    $scope.zhuotais.items = $scope.oldZhuoTais;
                    $scope.selectValue = '';
                    $scope.lastselectvalue = '';
                    $scope.oldZhuoTais = null;
                    if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                        $scope.ztfootloading = true;
                    } else {
                        $scope.ztfootloading = false;
                    }
                }
            }
            $scope.lastselectvalue = $scope.selectValue;
        }

        var refreshInterval = $interval(function () {
            $rootScope.$broadcast('refreshZTJS');
        }, 10000);

        $scope.$on('refreshZTJS', function (event, data) {
            refresh();
        });

        $scope.$on("$destroy", function () {
            $interval.cancel(refreshInterval);
        })

        function refresh() {
            if (!Utils.isEmpty($scope.selectValue)) {
                return;
            }
            if ($scope.currentArea != null) {
                ZhuotaiJieSuanService.getZhuotaisByParams($scope.currentArea.guid, 0, $scope.refreshrows, function (err, seq) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.zhuotais.items = seq;
                });
            } else {
                ZhuotaiJieSuanService.getZhuotaisByParams("",0, $scope.refreshrows, function (err, seq) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.zhuotais.items = seq;
                });
            }
        }
    }]);
