function AndroidPrinter() {
    this.base = NetPrinter;
    this.base();

    this.getEnv = function () {
        return CONSTANTS.EnvConstants.ANDROID;
    };

    this.newInstance = function () {
        return new AndroidPrinter();
    };

    var config = null;

    this.connect = function (cfg, callback, errorCallback) {
        config = cfg;
        requestIndex++;
        android_hook["connect" + requestIndex] = {success: callback, error: errorCallback};
        window.yunshan.connect(cfg.port, cfg.host, requestIndex);
    };

    this.print = function (buffer, callback, errorCallback) {
        requestIndex++;
        android_hook["print" + requestIndex] = callback;
        window.yunshan.print(buffer, requestIndex, config.host);
    };

    this.flush = function () {

    };

    this.disconnect = function (callback) {
        requestIndex++;
        android_hook["close" + requestIndex] = callback;
        window.yunshan.close(requestIndex, config.host);
    };

};

var android_hook = {};
var requestIndex = 0;
function _ANDROID_PRINTER_(type, requestIndex, result) {
    if ("connect" == type) {
        var funcs = android_hook["connect" + requestIndex];
        if ("true" == result) {
            if (funcs.success) {
                funcs.success();
            }
        }
        else {
            if (funcs.error) {
                Utils.confirm(result, function () {
                });
                var msg = {message: result};
                funcs.error(msg);
            }
        }
    }
    else if ("print" == type) {
        var func = android_hook["print" + requestIndex];
        if (func) {
            func();
        }
    }
    else if ("close" == type) {
        var func = android_hook["close" + requestIndex];
        if (func) {
            func();
        }
    }
}
HardWareManager.register(new AndroidPrinter());