﻿function EntityNameMap() {
    var _self = this;
    this.guid = null;
    this.entityGuid=null;
    this.entityName=null;
    this.entityType=null;
    this.sendTime=null;
    this.status = null;
    this.redisIdSet = null;
    this.chainTypeName = null;
    this.redisId = null;

    this.setChainTypeName = function() {
        this.chainTypeName = ChainTypeMap[this.entityType];
    }
}

//获取实际资料需要返回的实体信息
function ReturnEntity() {
    this.guid = null;
    this.addUserId = null;
    this.addUser = null;
    this.addTime = null;
    this.modUserId = null;
    this.BatchSchedule = null;
    this.modTime = null;
    this.addOrgId = null;
    this.addOrgName = null;
    this.addOrgShortName = null;
    this.addOrgNo = null;
    this.addDeptId = null;
    this.addDeptNo = null;
    this.addSupplierId = null;
    this.addSupplierName = null;
    this.addRunTemlateId = null;
    this.groupId = null;
    this.groupIdType = null;
    this.addGroupId = null;
    this.addGroupIdType = null;
    this.deleted = null;
    this.page = null;
    this.rows = null;
    this.groupCode = null;
    this.deviceType = null;
    this.orgid = null;
    this.orgControlMode = null;
    this.originalOrgId = null;
    this.sort = null;
    this.order = null;
    this.entityNameMap = null;
    this.dataNameInfo = null;
    this.redisIdMap = null;
    this.redisIdSet = null;
    this.baseOperator = null;
    this.isChain = "Y";
    this.sendTime = null;
    this.requestIp = null;
    this.redisIdType = null;
}

var testEntity = {"guid":null,"addUserId":null,"addUser":null,"addTime":null,"modUserId":null,"modUser":"BatchSchedule",
    "modTime":null,"addOrgId":null,"addOrgName":null,"addOrgShortName":null,"addOrgNo":null,"addDeptId":null,"addDeptName":null,
    "addDeptNo":null,"addSupplierId":null,"addSuppplierName":null,"addRunTemplateId":null,"groupId":"56adb0bb-d226-498b-9cd3-a5cc7aefb4bb",
    "groupIdType":null,"addGroupId":null,"addGroupIdType":null,"deleted":null,"page":null,"rows":null,"groupCode":"10085","deviceType":null,
    "orgid":"9424904e-132c-4ad8-bc44-194a5b9e291c","orgControlModel":null,"originalOrgId":null,"sort":null,"order":null,
    "entityNameMap":{"PosCaiPinInfo":["cd7c1c30-97df-45d0-8ea2-0bc5103106d3"],"PosChainCaipuCaipinInfo":["6087e450-c007-411a-a6ee-5f40bb9f506f"],"PosKouWeiInfo":["b293e682-08c8-48f2-9262-315613b6c833"]},
    "dataNameInfo":{"PosCaiPinInfo":["牛肉炒"],"PosChainCaipuCaipinInfo":["小炒菜"],"PosKouWeiInfo":["重口味2"]},
    "redisIdSet":["YS_CHAIN_ID_a99045d2-2a2d-487c-a8b5-a1566379ed4a","YS_CHAIN_ID_b3874272-31a4-43a8-9dc4-9434bd06c36a","YS_CHAIN_ID_70c4eaa9-ff05-4448-b3cf-c9662b5e47b0"],
    "baseOperator":"N","isChain":"Y","sendTime":null,"requestIp":null}


var ChainTypeMap = {
    FastCaiWuKeMuInfo : "付款方式",
    PosKouWeiInfo : "口味管理",
    PosPresentReasonInfo : "赠菜原因",
    PosTuiCaiReasonInfo  : "退菜原因",
    PosZheKouTemplateInfo  : "折扣模板",
    PosZuoFaInfo  : "做法管理",
    PosZuoFaTypeInfo   : "做法类型",
    PosChainMDCaipuInfo   : "门店菜谱",
    PosCaiPinInfo   : "菜品",
    PosChainCaipuCaipinInfo    : "菜谱",
    PosThirdCouponInfo    : "抵用券"
}

setKeyValue = function(obj, key, value) {
    if(!obj || !key || !value) return;
    if(key == 'FastCaiWuKeMuInfo') {
        obj['FastCaiWuKeMuInfo'] = value;
    }else if(key == 'PosKouWeiInfo') {
        obj['PosKouWeiInfo'] = value;
    }else if(key == 'PosPresentReasonInfo') {
        obj['PosPresentReasonInfo'] = value;
    }else if(key == 'PosTuiCaiReasonInfo') {
        obj['PosTuiCaiReasonInfo'] = value;
    }else if(key == 'PosZheKouTemplateInfo') {
        obj['PosZheKouTemplateInfo'] = value;
    }else if(key == 'PosZuoFaInfo') {
        obj['PosZuoFaInfo'] = value;
    }else if(key == 'PosZuoFaTypeInfo') {
        obj['PosZuoFaTypeInfo'] = value;
    }else if(key == 'PosChainMDCaipuInfo') {
        obj['PosChainMDCaipuInfo'] = value;
    }else if(key == 'PosCaiPinInfo') {
        obj['PosCaiPinInfo'] = value;
    }else if(key == 'PosChainCaipuCaipinInfo') {
        obj['PosChainCaipuCaipinInfo'] = value;
    }else if(key == 'PosThirdCouponInfo') {
        obj['PosThirdCouponInfo'] = value;
    }

}


var TabelName_RedisTypeMap = {}
TabelName_RedisTypeMap["pos_area"] = "PosAreaInfo";
TabelName_RedisTypeMap["pos_caipin"] = "PosCaiPinInfo";
TabelName_RedisTypeMap["pos_caipin_type"] = "FastDishTypeInfo";
TabelName_RedisTypeMap["pos_kouwei"] = "PosKouWeiInfo";
TabelName_RedisTypeMap["pos_zengsong_reason"] = "PosPresentReasonInfo";
TabelName_RedisTypeMap["pos_tuicai_reason"] = "PosTuiCaiReasonInfo";
TabelName_RedisTypeMap["pos_tcbxdish"] = "PosTcBxDishInfo";
TabelName_RedisTypeMap["pos_tcdish"] = "PosTcDishInfo";
TabelName_RedisTypeMap["pos_zhekou"] = "PosZheKouTemplateInfo";
TabelName_RedisTypeMap["pos_zhuotai"] = "PosZhuotaiInfo";
TabelName_RedisTypeMap["pos_zuofa"] = "PosZuoFaInfo";
TabelName_RedisTypeMap["pos_zuofa_type"] = "PosZuoFaTypeInfo";
TabelName_RedisTypeMap["pos_canbie"] = "PosCanbieInfo";
TabelName_RedisTypeMap["pos_cai_wu_ke_mu"] = "FastCaiWuKeMuInfo";
TabelName_RedisTypeMap["printer"] = "PosPrintInfo";
TabelName_RedisTypeMap["pos_print_caipin"] = "PosPrintCaipinInfo";

TabelName_RedisTypeMap["pos_weixin_order"] = "PosWeixinOrderInfo";
TabelName_RedisTypeMap["pos_person"] = "BasePersonInfo";
TabelName_RedisTypeMap["pos_person_role"] = "AuthUserRoleInfo";
TabelName_RedisTypeMap["pos_person_pos_mission"] = "AuthPosPermissionInfo";
TabelName_RedisTypeMap["pos_person_func_mission"] = "AuthPermissionInfo";
TabelName_RedisTypeMap["pos_sys_print_receipt_template"] = "SysPrintReceiptTemplateInfo";
TabelName_RedisTypeMap["pos_consumption_type"] = "PosConsumptionTypeInfo";
TabelName_RedisTypeMap["pos_third_coupon"] = "PosThirdCouponInfo";

TabelName_RedisTypeMap["PosZheKouTemplateInfo"] = "PosZheKouTemplateInfo";






