/**
 * Created by peter.shang on 2016-02-25.
 */


function MemberTrans( mt  ){
    var _mt = mt;
    var _member = null;
    var self = this;

    this.getTransTypeDesc = function(){
        return _mt.desc;
    }


    this.isChongZhi = function(){
        return _mt.code  == BIZCONSTANT.MEMBER_TRANS_CHUNZHI.code ;
    }

    this.isZengSong = function(){
        return _mt.code ==  BIZCONSTANT.MEMBER_TRANS_PRESENT.code ;
    }

    this.isXianJin = function(){
        return  _mt.code == BIZCONSTANT.MEMBER_TRANS_CASH.code ;
    }
    this.isJiFen = function(){
        return  _mt.code == BIZCONSTANT.MEMBER_TRANS_JIFEN.code ;
    }
    //付款方式
    this.pmDesc = function(){
        var desc = "";
        if(self.isChongZhi() ||  self.isZengSong())
            desc = "会员卡";
        else if(self.isXianJin()){
            var allpm = _member.getJieSuan().payMethodList;

            _.each(allpm, function(e){
                if(!e.isMember() && !e.isMemberFanZhi())
                    desc = desc + e.name + ",";
            });

            desc = desc.substring(0,desc.lastIndexOf(","));
        } else  if(self.isJiFen()){
            desc = BIZCONSTANT.JS_XF_MEMBER_JF;
        }


        return desc;
    }
    //返回会员卡是否允许积分消费的描述
    this.huiYuanJiFenDesc = function(){

        var ret = "";

        if(self.isChongZhi() ||  self.isZengSong()){
            var allpm = _member.getJieSuan().payMethodList;
            _.each(allpm, function(e){
                if(e.isMember() )
                    ret = "" + e.isOfHuiYuanJiFen();
            });

        }

        return ret;
    }

    this.pmCode = function(){
        var codes = "";
        if(self.isChongZhi() ||  self.isZengSong())
            codes = BIZCONSTANT.PM_HUI_YUAN;
        else if(self.isXianJin()){
            var allpm = _member.getJieSuan().payMethodList;

            _.each(allpm, function(e){
                if(!e.isMember() && !e.isMemberFanZhi())
                    codes = codes + e.code + ",";
            });

            codes = codes.substring(0,codes.lastIndexOf(","));
        }


        return codes;
    }

    this.pmGuid = function(){
        var ret = "";
        if(self.isChongZhi() ||  self.isZengSong()){
            var allpm = _member.getJieSuan().payMethodList;
            _.each(allpm, function(e){
                if(e.isMember() )
                   ret = e.pmId;
            });

        }


        return ret;
    }

    this.getAmount = function(){
        var ret = 0.00;
        //1. 得到会员支付的支付金额
        var balance =   _member.getJieSuan().getMoneyPaidByMember();

        //.2.会员储值金额
        var cz = _member.getCZ();
        // 3.会员赠送金额
        var zs = _member.getZS();


        if(self.isChongZhi())
            ret = _member.getPolicy().chongZhi(balance, cz, zs);
        else if(self.isZengSong())
            ret = _member.getPolicy().zengSong(balance, cz, zs);
        else if(self.isXianJin()){
            var original = 0.00;
            //1.5 如果是反结算
            if(_member.getJieSuan().order.isFanJieSuan){
                var exists = _member.getJieSuan().getPreviousMemberPayment();
                original = exists.pmMoney();
            }
            ret = _member.getJieSuan().order.getYingShou() - balance - original;
        } else if(self.isJiFen()){
            var jfCandidate =  _member.getJieSuan().getMemberPaymentOfJiFen();
            ret = jfCandidate == null ? 0 : jfCandidate.pmMoney();
        }

        return ret;

    }
    this.setParent = function(member){
        _member = member;
    }

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////// POLICY //////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




function BiLi(){
    var _self = this;

    this.chongZhi = function(balance, cz, zs) {
        var amount = Utils.m(balance - _self.zengSong(balance, cz, zs));
        return amount;
    };
    this.zengSong = function(balance, cz, zs){
        var mother = cz + zs;
        var amount = 0;

        if(mother > 0 )
            amount = Utils.m(zs / (cz+zs)  * balance);
        return amount ;
    }
};



function ChongZhiPrefer(){
    var _self = this;
    this.chongZhi = function(balance, cz, zs) {
        var amount = null;

        if(balance < cz )
            amount = balance;
        else
            amount = cz;
        return amount;
    };

    this.zengSong = function(balance, cz, zs) {
        var remain = balance - _self.chongZhi(balance, cz, zs);
        var amount = null;

        if( remain < zs){
            amount = remain;
        }else
            amount = zs;

        return amount ;

    };

};




function ZongSongPrefer(){
    var _self = this;

    this.chongZhi = function(balance, cz, zs) {
        var amount = null;
        var remain = balance - _self.zengSong(balance, cz, zs);
        if( remain < cz)
            amount = remain;
        else
            amount = cz;

        return amount;
    };
    this.zengSong = function(balance, cz, zs) {
        var amount = null;

        if(balance < zs )
            amount =  balance;
        else
            amount =  zs;

        return amount ;
    };

};



