function OrderCaipin(){
    var _self = this;
    this.guid = null;
    this.orderId = null;
    this.caipinId = null;
    this.caipinCode = null;
    this.orderZhuotaiId = null;

    this.orderCaipinType  =null;
    this.name = null;
    this.price = null;
    this.hyPrice = null; //会员价格，以后会有多个会员价格。
    //this.hyPrice1 = null; //会员价格
    this.num = 1;
    this.tuiNum = 0;
    this.zengNum = 0;
    this.unitName = null;
    this.printId = null;
    this.printName = null;
    this.chupin = null;
    this.luodan = null;
    this.operator = null;
    this.modTime = null;
    this.dianCaiYuanNo = null;
    this.dianCaiYuan = null;
    this.dianCaiYuanName = null;
    this.dianCaiTime =null;
    this.luoDanTime = null;
    this.chuPinTime = null;
    this.parentId = null;
    this.tuicaiReasonId = null;
    this.tuicaiReasonName = null;
    this.zengReasonId = null;
    this.zengReasonName = null;
    this.kouweis = [];
    this.zuofas = [];
    this.customize = 0;
    this.needweigh = 0;
    this.isScomb = null;

    this.hyPrice = null;
    this.caipinTypeId = null;
    this.caipinTypeCode = null;
    this.caipinTypeName = null;

    this.caiwuTypeName = null;
    this.caiwuTypeId = null;

    this.unitId = null;
    this.cpdept = null;
    this.cpdeptName = null;
    this.customize = null;

    //与当前菜品相关的退菜菜品
    this._childTuiCaiPin = [];

    /******BEGIN 套餐所使用的变量 ****************************/

    this.scombCaipins = [];//套餐的菜品明细
    this.scombMainCaipinId = null;//套餐菜品用，表示当前套餐菜品所属的主菜ID
    this.orderCaipinId = null;//套餐菜品 所关联的 订单中的套餐ID
    var _parentScom = null; //套餐菜品 所关联的 订单中的套餐对象, added by peter

    /******END 套餐所使用的变量****************************/

    //begin,added by peter
    this.maxWeightInCurrentOrder = false;
    this.parentOrder = null;
    this.minAgio = 0;//最小折扣,需从数据库中读取【整型],数值，非折扣对象。默认为0，即无最小限制
    this.danPinBiLiZheKou = 0;//单品比例折扣
    this.danPinJineZheKou = 0;//单品金额折扣(总金额，一部分属于菜品，一部分属于做法） -  如果有做法和该菜品相关，那么后续的菜品的折扣
    this.danPinZheKou = 0; //是否是单品折扣

    this.orderZhuoTaiId = null; //order与zhuotai关联表guid

    // pos竖屏自用字段
    this.fromDB = false;
    this.isLuodan = false;
    this.orgNum = null;
    this.mom = null;
    this.tzs = 0;




    this.setParentScom = function(o){
        _parentScom = o;
        _self.orderCaipinId  = o.guid;
    }

    this.getParentScom = function(){
        return _parentScom;
    }

    //与当前菜品相关的做法的实收价格
    this.calShiShouTotal4ZuoFa = function(){
        var ret = 0.00;
        _.each(this.zuofas, function(e){
            ret = ret + e.calShiShou();
        });

        return Utils.m(ret);
    }
    //与当前菜品相关的做法的折扣金额
    this.calZheKouTotal4ZuoFa = function(){
        var ret = 0.00;
        _.each(this.zuofas, function(e){
            ret = ret + e.mZk();
        });

        return ret;
    }


    //与当前菜品相关的做法的折前金额
    this.calMoneyTotal4ZuoFa = function(){
        var ret = 0.00;
        _.each(this.zuofas, function(e){
            ret = ret + e.mRaw();
        });

        return ret;
    }

    //当前菜品相关的做法的分摊金额的合计
    this.calFenTanTotal4ZuoFa = function(){
        var ret = 0.00;
        _.each(this.zuofas, function(e){
            ret = ret + e.calFenTan();
        });

        return ret;
    }

    //当前菜品相关的做法的抹零金额的合计
    this.calMoLingTotal4ZuoFa = function(){
        var ret = 0.00;
        _.each(this.zuofas, function(e){
            ret = ret + e.calMoLing();
        });

        return ret;
    }

    //end, added by peter

    /************************************************************************************/
    /************************************************************************************/
    /************************************************************************************/
    /************************************************************************************/

    /*
     * 菜品权重
     *    # 菜品权重=（菜品折前金额-菜品折扣金额）/（【参与分摊的】菜品折前金额总计-【参与分摊的】菜品折扣金额总计）
     */
    this.weight = function(){
        //if(_self.name.indexOf("（套）") > -1)
        //console.log("_self.weight" +":["+_self.mRaw() + ":"+_self.mZk()  +"]:"+this.parentOrder.getRawTotalMoney4FenTan() +":" +this.parentOrder.getRawTotalZheKou4FenTan());

        if(!this.isFenTan())
            return 0;

        var m  = this.parentOrder.getRawTotalMoney4FenTan() - this.parentOrder.getRawTotalZheKou4FenTan();
        if(m == 0)
            return 0;
        return (_self.mRaw() - _self.mZk()) / m;
    };

    //是否参与分摊
    this.isFenTan = function(){
        if(_self.parentOrder.isQuanYuanFenTan())
            return true;

        //菜品最低折扣为100，则不参与分摊
        if( this.minAgio == 100 )
            return false;


        return true;
    }

    /**
     * 菜品的折前金额
     */
    this.mRaw = function(){
        var p = _.isNil(_self.price) ? 0 : _self.price;
        var n = _.isNil(this.num )? 1 : this.num;
        return Utils.m(p * n);
    }

    /**
     * 菜品的退菜金额
     */
    this.m4TuiMoney = function(){
        var p = _.isNil(_self.price) ? 0 : _self.price;
        var n = _.isNil(this.tuiNum )? 1 : this.tuiNum;
        return Utils.m(p * n);
    }

    /**
     * 与该菜品相关 所有做法  折前金额
     */
    this.mRawOfZuoFa = function(){
        var sum = 0;
        _.each(_self.zuofas, function(e){
            sum = sum + e.mRaw();
        });

        return sum;
    }

    /**
     * 菜品的赠送金额
     */
    this.mFree = function(){
        if(_self.existDpZk())
            return 0;

        var p = _.isNil(_self.price) ? 0 : _self.price;
        var zm = _.isNil(_self.zengNum) ? 0 :_self.zengNum;
        return Utils.m(p * zm);

    }

    /**
     * 菜品[参与整单折扣]的金额
     */
    this.mRaw4ZhengDan = function(){
        //1.是单品折扣则为0
        if(_self.existDpZk())
            return 0;

        //2.
        return this.mRaw() - this.mFree();
    }

    /**
     * 菜品赠从产生的折扣
     */
    this.mZkFromFree = function(){
        return _self.mFree();
    }

    /**
     * 【菜品整单折扣】产生的折扣, 整单比例
     */
    this.mZkFromZhengDan = function(){
        if(_self.existDpZk())
            return 0;
        return Utils.m(_self.mRaw4ZhengDan() *  (100-_self.getAvailableZheKou())/100);
    }

    /**
     * 会员价所产生的折扣
     */
    this.mZKFromHuiYuanJia = function(){
      return  Utils.m(( _self.price  - _self.getEffectivePrice()) * (_self.num - _self.zengNum));

    }


    /**
     * 菜品 单品比例 产生的折扣金额
     */
    this.mZkFromDanPinBiLi = function(){
        if(! _self.existDpZk())
            return 0;
        //console.log(this.name +"::"+ _self.mRaw() +":" + _self.getAvailableZheKou());
       return  Utils.m(_self.mRaw() *(100 -_self.getAvailableZheKou() ) / 100);
    }

    /**
     * 菜品 单品比例 产生的折扣金额-打印
     */
    this.mZkFromDanPinBiLi4Print= function(){
        if(! _self.existDpZk())
            return 0;
        //console.log(this.name +"::"+ _self.mRaw() +":" + _self.getAvailableZheKou());
        return  _self.mRaw4Print() *(100 -_self.getAvailableZheKou() ) / 100;
    }

    /**
     * 与该菜品相关 所有做法 对应的【整单折扣金额‘
     */
    this.mZkFromZhengDanOfZuoFa = function(){
        var sum = 0;
        _.each(_self.zuofas, function(e){
            sum = sum + e.mZkFromZhengDan();
        });

        return sum;
    }

    /**
     * 菜品的折扣总金额
     */
    this.mZk = function(){
        //套餐中的菜品，那么菜品折扣为0
        if(_self.isScombCaipin()){
            return 0;
        }
        var m = Utils.m( _self.mZkFromDanPinBiLi() + _self.mZkFromFree() + _self.mZkFromZhengDan() + _self.mZKFromHuiYuanJia());
        // console.log("_self.mZkFromDanPinBiLi() : " + _self.mZkFromDanPinBiLi() + ", _self.mZkFromZhengDan() : " + _self.mZkFromZhengDan());
        //console.log(this.name +">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" + this.mZkFromDanPinBiLi() + ":" + this.mZkFromFree() + ":"+ this.mZkFromZhengDan() +":" + _self.mZKFromHuiYuanJia());
        return m;
    }

    /**
     * 与该菜品相关 所有做法  折扣金额
     */
    this.mZkOfZuoFa = function(){
        var sum = 0;
        _.each(_self.zuofas, function(e){
            sum = sum +  e.mZk();
        });

        return sum;
    }

    /**
     * 与该菜品相关的做法的单品比例折扣
     *
     * @returns {number}
     */
    this.mZkDanPinOfZuoFa = function(){
        var sum = 0;
        _.each(_self.zuofas, function(e){
            sum = sum +  e.mZkFromDanPinBiLi();
        });

        return sum;
    }




    /**
     *     分配到当前菜品的【抹零的金额】.
     *
     *     只有最大权重的菜品，并且才会分摊【被抹零的】的金额
     *     非最大权重的菜品，默认被抹零到的金额为0
     * @returns {number}
     */
    this.calMoLing = function(){
        var ret = 0.00;

        if(_self.maxWeightInCurrentOrder){
            var tmp = _self.parentOrder.fenTanZongJinE();
           if( !_self.greaterOrEqualOne(tmp.zheKouAmount) ){
               ret = ret +   _self.parentOrder.zhangDanMoLing();
           }

        }

        return ret;
    }

    /**
     *  菜品实收金额
     */
    this.calShiShou =  function(){
        // var m1 = Utils.accSub(_self.mRaw(),  _self.mZk());
        // var m2 = Utils.accSub(m1, _self.calFenTan());
        // return parseFloat(m2);
        // return  _self.mRaw() -  _self.mZk() - _self.calFenTan();
        return Utils.m(Utils.m( _self.mRaw()) -  Utils.m(_self.mZk()) - Utils.m(_self.calFenTan()));
    }

    this.calShiShou4Display = function(){
        return "["+_self.mRaw() + ",    " + _self.mZk() + ",  " +_self.calFenTan()+"]";
    }
    /**
     * 菜品的分摊金额 （做法也参与分摊）
     */
    this.calFenTan = function(){

        var tmp = _self.parentOrder.fenTanZongJinE();
        var ret = 0.00;
        //非最大权重
        if(! _self.maxWeightInCurrentOrder ){
            ret =  _self.greaterOrEqualOne(tmp.zheKouAmount) ? _self.weight() *  tmp.zheKouAmount : ret;
            return Utils.m(ret);
        }

        //是最大权重
        ret =  _self.greaterOrEqualOne(tmp.zheKouAmount) ?   tmp.zheKouAmount -  _self.parentOrder.getSumFenTanOfCommon() :  tmp.zheKouAmount ;

        return Utils.m(ret);

    }


    this.greaterOrEqualOne = function(amount){
        if( Math.abs(amount)  >= 1)
            return true;


        return false;

    }

    /**
     * 是否是单品比率折扣
     *
     * @returns {boolean}
     */
    this.isDanPinBiLiZheKou = function(){
        if(this.danPinBiLiZheKou != null && this.danPinBiLiZheKou > 0 )
            return true;

        return false;
    }

    /*******************************helper*****************************/
    /**
     * 是否是单品折扣
     */
    this.existDpZk = function(){
        if(this.danPinZheKou != null && this.danPinZheKou > 0)
            return true;
        return false;
    }
    /**
     * 得到当前菜品的比例折扣值
     * 1.无单品比例折扣，无整单比例折扣，返回100
     * 2.有单品比例折扣，以单品比例为准，返回单品比例
     * 3.只有整单比例折扣，那么需要和该菜品内置的最小折扣比较，取最小值
     * 4.
     */
    this.getAvailableZheKou = function(){
        //1. 如果存在单品比例折扣，则以单品折扣为准
        if(  this.isDanPinBiLiZheKou() )
            return 	this.danPinBiLiZheKou ;

        var bl = _self.getBl();
        //0,如果比例折扣为整单打折，则优先级最高
        if(bl!= null && bl.isApplyWholeOrder())
            return bl.zheKouAmount;

        //2.只要有折扣模板类，但是其折扣小于菜品的最低折扣，那么以菜品最低折扣为准
        var min = _self.minAgio == null ? 0 : _self.minAgio;
        if( bl.zheKouAmount < min)
            return min;
        //3. 返回整单比例折扣
        return bl.zheKouAmount;

    }



    //与当前菜品相关的 退菜菜品信息， 仅仅在退菜的时候使用
    this.addTuiCai = function(tc){
       if( _.isArray(tc)){
           _.forEach(tc, function(o){
               _self._childTuiCaiPin.push(o);
           });
           return;
       }
        _self._childTuiCaiPin.push(tc);
    }
    this.getTuiCai = function(){
        return _self._childTuiCaiPin
    }

    //查看当前菜品是否是退菜菜品
    this.isTui = function(){
        if(_self.parentId != null )
            return true;

        return false;
    }

    //与当前菜品相关的赠送部分的做法价格合计
    this.calFreeTotal4ZuoFa = function () {
        var ret = 0.00;
        _.each(this.zuofas, function (e) {
            ret = ret + e.mFree();
        });

        return Utils.m(ret);
    }

    //判断是否是套餐
    this.isScombInfo= function () {
        if (_self.isScomb != null && _self.isScomb == "true" && _self.scombMainCaipinId == null)
            return true;

        return false;
    }

    //判断是否是套餐中的菜品
    this.isScombCaipin = function () {
        if (_self.orderCaipinId != null)
            return true;

        return false;
    }


    //设置单品比例折扣
    this.setDanPinBiLi = function(bili){
        if(bili != null) {
            _self.danPinZheKou = 1;
            _self.danPinBiLiZheKou = bili;
            //如果和当前菜品关联的退菜菜品数量不为零，那么也应设置
            _.each(_self._childTuiCaiPin, function(e){
                e.danPinZheKou = 1;
                e.danPinBiLiZheKou = bili;
            });
        }else{
            _self.danPinZheKou = 0;
            _self.danPinBiLiZheKou = null;
            //如果和当前菜品关联的退菜菜品数量不为零，那么也应设置
            _.each(_self._childTuiCaiPin, function(e){
                e.danPinZheKou = 0;
                e.danPinBiLiZheKou = null;
            });
        }

    }

    this.getEffectivePrice = function(){
        if(_self.parentOrder == null)
            return  _self.price;

        //菜品无会员价，则使用原价
        if(_self.hyPrice == null)
            return _self.price;

        //菜品已经是单品打折，那么仍然使用原价
        if(_self.isDanPinBiLiZheKou())
            return _self.price;

        //TODO,根据不同的级别返回不同的会员价，
        //如果结算对象中有会员价折扣，则使用会员价
        if(_self.parentOrder.getJieSuan().existHuiYuanPriceZheKou() )
            return _self.hyPrice;

        //1.得到会员对象
        var mem =  _self.parentOrder.getJieSuan().getMember();
        //2. 非会员则使用原价
        if(mem == null)
            return _self.price;
        //3. 使用会员价
        if(mem.isHuiYuanPrice())
            return _self.hyPrice;

        return _self.price;
    }

    /***********************BEGIN账单使用的价格***********************/

    //菜品的在对账单和结算单上显示的价格 = 折前价格 - 单品折扣的价格
    this.m4Print = function(){
        return _self.mRaw() - _self.m4TuiMoney() - _self.mFree() - _self.mZkFromDanPinBiLi();
    }


    /***********************END ***************************/

    /****************************BEGIN: 以下方法是为了 [点菜界面以及结算界面的菜品金额的显示】，并非为计算用
     *点菜中的菜品金额受：单品折扣 ， 赠送， 退菜 这3个动作影响。
     *
     * 1. 如果某个菜品A进行两次退菜AT1，AT2,，那么 _self._childTuiCaiPin属性值 有 AT1和AT2.  AT1和AT2作为普通的菜品进行各种运算
     * 2. 单品折扣目前只支持比例折扣
     *
     * *************************************/

    /**
     * 包括菜品和做法
     */
    this.calMoney4DianCai = function(){        
        var ret = 0;
        var m = _self.mRaw() + _self.calMoneyTotal4ZuoFa();
        if (_self.existDpZk()) {
            m -= _self.mZk() + _self.mZkDanPinOfZuoFa();
        }
        m -= _self.mFree() + _self.calFreeTotal4ZuoFa();
        ret += m;



        _.each(_self._childTuiCaiPin, function(e){
            ret = Utils.m(ret) + Utils.m(e.calMoney4DianCai());
        });

        return Utils.m(ret);
    }

    //菜品的价格
    this.calMoneyCaiPin4DianCai = function(){
        var ret = 0;
        var m = _self.mRaw() ;
        if (_self.existDpZk()) {
            m -= _self.mZk() ;
        }
        m -= _self.mFree() ;
        ret += m;



        _.each(_self._childTuiCaiPin, function(e){
            ret = Utils.m(ret) + Utils.m(e.calMoneyCaiPin4DianCai());
        });

        return Utils.m(ret);
    }


    /****************************END: 以上方法是为了点菜界面的各种金额的显示，并非为计算用*************************************/



    //得到应用于此菜品的比例类折扣对象
    this.getBl = function(){
        if(_self.parentOrder == null || _self.parentOrder.getJieSuan() == null)
            return null;
        var candidate = _self.parentOrder.getJieSuan().getZheKouMap().bl ;
        return candidate == null ? ZheKou.BL_100() : candidate;
    }



}

OrderCaipin.SQL_UPDATE_OCP_TO_ORDER_CAIPIN = function(_self, operator, jieSuan){
    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var guidStr = "'" + _self.guid + "'" + jieSuan.jieSuanTimeSql;
    return {
        query:"update pos_order_caipin "+
        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?,moLingMoney =?, " +
        " zuoFaZheQianTotal = ?, zuoFaShiShouTotal = ?, zuoFaZheKouTotal  = ?, zuoFaFenTanTotal  = ?, zuoFaMoLingTotal  = ?, " +
        " weight =?, jieSuanTime=? "+
        " where guid=" + guidStr,
        params:[_self.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),

            _self.calMoneyTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calShiShouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calZheKouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calFenTanTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calMoLingTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),

            _self.weight(),
            jieSuan.getCreateTime()
        ]
    }


}


//对象持久化到表中所使用的SQL
OrderCaipin.SQL_UPDATE_OCP_TO_ORDER_SCOMB_CAIPIN  = function(_self, operator, jieSuan){
    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var guidStr = "'" + _self.guid + "'" + jieSuan.jieSuanTimeSql;
    return {
        query:"update pos_order_scomb_caipin "+
        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?,moLingMoney =?, " +
        " zuoFaZheQianTotal = ?, zuoFaShiShouTotal = ?, zuoFaZheKouTotal  = ?, zuoFaFenTanTotal  = ?, zuoFaMoLingTotal  = ?, " +
         "  weight =?, jieSuanTime=?" +
        " where guid=" + guidStr,
        params:[_self.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),

            _self.calMoneyTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calShiShouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calZheKouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calFenTanTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calMoLingTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),

            _self.weight(),
            jieSuan.getCreateTime()
            ]
    }

}

//查询参数对象
function OrderCaipinQueryParamBean() {
    this.startTime = null;
    this.endTime = null;
    this.canBieId = null;
    this.dishTypeParentId = null;
    this.dishTypeChildId = null;
    this.cashierId = null;
    this.showUnJieSuan = false; //是否查询未结算账单,默认不查询
}




