/**
 * Created by peter.shang on 2016-03-09.
 *
 *
 */

function PosUser(){

    var _self = this;
    this.groupCode = null;
    this.groupId = null;
    this.groupIdType = null;
    this.id = null;
    this.code = null;//用户编码、工号
    this.name = null;//用户名字
    this.mdId = null; //门店ID
    this.banCiHao = null; //可能是上一次未结班的班次号或者当前班次号, 即：【当前用户最近一次，未结班的班次号】
    this.banCiStart = null; //格式形如：2016-03-07 10:55:52
    this.banCiEnd = null;

    this.HotelName = null;
    this.HotelTel = null;
    this.HotelAddress = null;

    this.device= null;
    this.ip = null;

    /**
     * 餐别组
     * @type {null}
     * @private
     */
    var _canBieGroup = new CanBieGroup();


    this.getCanBieGroup = function(){
        return _canBieGroup;
    }


    //是否需要新开班
    this.getNeedKaiBan = function(){
        if(_self.banCiHao == null)
            return true;

        return false;
    }

    //是否允许结算
    this.jieSuanRiAllowed = function(time){
        var range = _canBieGroup.getCanBieTimeRange(_self.banCiStart);
        var end = range["endTime"];
        //要结算的账单的【落单时间】 > 当前班次的【开班时间】所在的餐别日的【结束时间】 ， 那么return false.

        var ld =   new Date(Date.parse(time.replace(/-/g,"/"))).getTime();
        var end =   new Date(Date.parse(end.replace(/-/g,"/"))).getTime();

        if(ld > end )
            return false;

        return true;
    }


    this.json4common = function(data){
		// 该方法数据使用还不够严谨，现在所需的一些数据，应该是实际请求发送过来的信息（可能是主机本身发送，也有可能是分机发送的）
		// TODO: 需要修改
        if(! CONSTANTS.PRODUCTION) {
            data.groupCode = "ZGF";
            data.groupId = "14827bc4-14eb-429d-8f49-ee486f11d806";
            data.groupIdType = "2";
            data.addGroupId = "14827bc4-14eb-429d-8f49-ee486f11d806";
            data.addGroupIdType = "2";
            data.addUserId = "337ec3df-bfa5-4ed3-aa7d-142a09508374-null";
            data.addUser = "独墅湖店长";
            data.modUserId = "337ec3df-bfa5-4ed3-aa7d-142a09508374-null";
            data.modUser = "独墅湖店长";
            data.orgid = "df185746-8a12-43a3-adb0-8cd56f6b266f";
            data.mdId = "df185746-8a12-43a3-adb0-8cd56f6b266f";
            data.banci = BIZCONSTANT.POSUSER.banCiHao;
			data.terminalNumber = BIZCONSTANT.POSUSER.device;//交易终端号
			data.tradeAddress = "";//交易地址
        } else{
			if(BIZCONSTANT.POSUSER == null || BIZCONSTANT.POSUSER.id == null) { // 未登录状态
				data.groupCode = CONSTANTS.SystemConfigs['GroupCode'].systemConfigValue;
				data.groupId = CONSTANTS.SystemConfigs['GroupID'].systemConfigValue;
				data.groupIdType = CONSTANTS.SystemConfigs['GroupType'].systemConfigValue;
				data.addGroupId = CONSTANTS.SystemConfigs['GroupID'].systemConfigValue;
				data.addGroupIdType = CONSTANTS.SystemConfigs['GroupType'].systemConfigValue;
				data.orgid = CONSTANTS.SystemConfigs['MD_ID'].systemConfigValue;
				data.mdId = CONSTANTS.SystemConfigs['MD_ID'].systemConfigValue;
			}
			else{
				data.groupCode = BIZCONSTANT.POSUSER.groupCode;
				data.groupId = BIZCONSTANT.POSUSER.groupId;
				data.groupIdType = BIZCONSTANT.POSUSER.groupIdType;
				data.addGroupId = BIZCONSTANT.POSUSER.groupId;
				data.addGroupIdType = BIZCONSTANT.POSUSER.groupIdType;
				data.addUserId = BIZCONSTANT.POSUSER.id;
				data.addUser = BIZCONSTANT.POSUSER.name;
				data.modUserId = BIZCONSTANT.POSUSER.id;
				data.modUser = BIZCONSTANT.POSUSER.name;
				data.orgid = BIZCONSTANT.POSUSER.mdId;
				data.mdId = BIZCONSTANT.POSUSER.mdId;
				data.banci = BIZCONSTANT.POSUSER.banCiHao;
				data.terminalNumber = BIZCONSTANT.POSUSER.device;//交易终端号
				data.tradeAddress = CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue;//交易地址
			}
			
        }
        return data;

    }




}