﻿
function printCaipin() {
    this.caipinId = null;
    this.caipinCode = null;
    this.printSchemeId = null;
    this.caipinTypeId = null;
    this.printid = null;
}

//打印方案
function printReceipt(code) {
    this.id = null;
    this.printName = null;
    this.printId = null;
    this.code = null;
    this.number = 1;
    this.size = 80;
    this.template = null;
    this.zouzhi = 4;//走纸行数 默认4
    this.printTemplate = null;

    //根据菜品ID和打印类型code获取打印方案
    this.culReceipt = function (caipinid, invocecode) {
        var printidarr = [];
        for (var i in BIZCONSTANT.ALLPRINTCAIPIN) {
            var cp = BIZCONSTANT.ALLPRINTCAIPIN[i];
            if (cp.caipinId == caipinid)
                printidarr.push(cp.printid);
        }
        var receiptarr = [];
        for (var j in BIZCONSTANT.ALLPRINTRECEIPT) {
            var receipt = BIZCONSTANT.ALLPRINTRECEIPT[j];
            if (receipt.code == invocecode && printidarr.indexOf(receipt.printId) > -1) {
                for (var t in BIZCONSTANT.ALLPRINTTEMPLATE)
                {
                    if (BIZCONSTANT.ALLPRINTTEMPLATE[t].code == invocecode)
                        receipt.printTemplate = BIZCONSTANT.ALLPRINTTEMPLATE[t];
                }
                receiptarr.push(receipt);
            }
        }
        return receiptarr;
    }


    this.getPrintersByCaipins = function (caipins, invcode) {
        var huadanarr = { printids: [] };
        for (var i in caipins) {
            var cp = caipins[i];

            if (cp.isScomb == '1' || cp.isScomb == 'true') {
                for (var j in cp.scombCaipins) {
                    var lcp = cp.scombCaipins[j];
                    lcp.scombParent = cp;
                    var receiptarr = this.culReceipt(lcp.caipinId, invcode);
                    for (var j in receiptarr) {
                        var receipt = receiptarr[j];
                        if (huadanarr.printids.indexOf(receipt.printId) > -1) {

                            huadanarr[receipt.printId].receipt = receipt;
                            huadanarr[receipt.printId].caipins.push(lcp);
                        } else {
                            huadanarr.printids.push(receipt.printId);
                            huadanarr[receipt.printId] = { receipt: receipt, caipins: [lcp] };
                        }
                    }
                }
            } else {
                var receiptarr = (new printReceipt()).culReceipt(cp.caipinId, invcode);
                for (var j in receiptarr) {
                    var receipt = receiptarr[j];
                    if (huadanarr.printids.indexOf(receipt.printId) > -1) {

                        huadanarr[receipt.printId].receipt = receipt;
                        huadanarr[receipt.printId].caipins.push(cp);
                    } else {
                        huadanarr.printids.push(receipt.printId);
                        huadanarr[receipt.printId] = { receipt: receipt, caipins: [cp] };
                    }
                }
            }
        }
        return huadanarr;
    }


    this.getPrinterCaipins4Test = function (caipins, invcode) {
        var huadanarr = { printids: [] };
        for (var i in caipins) {
            var cp = caipins[i];

            if (cp.isScomb != '1' && cp.isScomb != 'true') {
                var receiptarr = (new printReceipt()).culReceipt(cp.guid, invcode);
                for (var j in receiptarr) {
                    var receipt = receiptarr[j];
                    if (huadanarr.printids.indexOf(receipt.printId) > -1) {

                        huadanarr[receipt.printId].receipt = receipt;
                        huadanarr[receipt.printId].caipins.push(cp);
                    } else {
                        huadanarr.printids.push(receipt.printId);
                        huadanarr[receipt.printId] = { receipt: receipt, caipins: [cp] };
                    }
                }
            }
        }
        return huadanarr;
    }


    if (!isNaN(code) || parseInt(code)===0)//只要code是数字类型 使用的就是小票打印机
    {
        this.printId = '11';
        this.code = code;
        this.size = Utils.m(CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS ? getLocalSystemConfig('dayinSize', '80').replaceAll('mm', '') : getSystemConfigForLandPos('dayinSize', '58').replaceAll('mm', ''));
        this.number = Utils.m(getLocalSystemConfig('dayinZhangshu', '1'));//  CONSTANTS.SystemConfigs['dayinZhangshu'].SystemConfigValue;
        this.zouzhi = Utils.m(getLocalSystemConfig('zouziHangshu', '4'));//todo 实际使用时，从系统缓存取配置
        for (var t in BIZCONSTANT.ALLPRINTTEMPLATE) {
            if (BIZCONSTANT.ALLPRINTTEMPLATE[t].code == code)
                this.printTemplate = BIZCONSTANT.ALLPRINTTEMPLATE[t];
        }
    }
    if (!isNaN(code) && parseInt(code / 100) == 1)// code 介于 100-199 就是会员票据的打印，其打印份数使用 会员小票打印份数配置
    {
        this.number = Utils.m(CAT_PAR.LOCAL.HYPJDY);//Utils.m(getSystemConfig('huiyuanDayinFenshu', '1'));
    }
    if (this.code == null)
        this.code = code;
}

//取本地系统配置，不存在的话返回给定的默认值
function getLocalSystemConfig(key, defultvalue) {
    var rtvalue = defultvalue;
    var posPrintSystemConfigs = {};
    var localconfig = localStorage.getItem('xiaopiao');
    if (localconfig && localconfig != '')
        posPrintSystemConfigs = JSON.parse(localconfig);
    if (posPrintSystemConfigs[key])
        rtvalue = posPrintSystemConfigs[key];
    //if (CONSTANTS.SystemConfigs[key] && CONSTANTS.SystemConfigs[key].systemConfigValue)
    //    rtvalue = CONSTANTS.SystemConfigs[key].systemConfigValue;
    return rtvalue;
}

//取系统配置，不存在的话返回给定的默认值
function getSystemConfig(key, defultvalue) {
    var rtvalue = defultvalue;
    if (CONSTANTS.SystemConfigs[key] && CONSTANTS.SystemConfigs[key].systemConfigValue)
        rtvalue = CONSTANTS.SystemConfigs[key].systemConfigValue;
    return rtvalue;
}

// 取得横屏POS--Android or iOS 的打印设置，这一部分信息是保存在local storage 里的，并没有走datbase，也不参加同步
function getSystemConfigForLandPos(key, defaultValue) {
    return  window.localStorage[key] || defaultValue;
}


var _workingPrinter = {};

function tickPrinter(job, callback) {
    var me = this;

    this.configs = null;
    this.iconv = null;
    try {
        if (typeof (require) != 'undefined') {
            this.iconv = require("iconv-lite");
        }
    } catch (e) {
        return callback(e.message);
    }
    this._getPrinter = function (config) {
        if (config.type == "network") {
            return { printer: HardWareManager.get(CONSTANTS.HardWareConstants.NET_PRINTER).newInstance(), cfg: { port: config.port, host: config.host } };
        }
        else if (config.type == "system") {
            return { printer: HardWareManager.get(CONSTANTS.HardWareConstants.PRINTER).newInstance(), cfg: { printer: config.printerName } };
        }
        else if (config.type == "serialport") {
            return { printer: HardWareManager.get(CONSTANTS.HardWareConstants.POS_PRINTER).newInstance(), cfg: { path: config.path, baudrate: config.baudrate } };
        }

        // 针对横屏Pos －－－－Android or iOS
        else if (config.type == "webprint") {
            return { printer: HardWareManager.get(CONSTANTS.HardWareConstants.NET_PRINTER).newInstance(), cfg: { port: config.port, host: config.host } };
        }
        else if (config.type == "buildInprint" || config.type == "bluetoothprint") {
            return { printer: HardWareManager.get(CONSTANTS.HardWareConstants.POS_PRINTER).newInstance(), cfg: { path: config.path, baudrate: config.baudrate } };
        }
    };

    this._doSelfPrint = function (job, callback) {
        var config;
        //此处是Android或者IOS端处理打印的方法
        if(CONTEXT.env == CONSTANTS.EnvConstants.ANDROID || CONTEXT.env == CONSTANTS.EnvConstants.IOS){
            //如果是Android手持端，取本地保存的记录，对于横屏Pos端，为空
            var selectPrintType = localStorage.getItem("SELECT_PRINT");
            if(Utils.isEmpty(selectPrintType)){
                // 横屏Android版 走这里
                // 横屏Pos端默认不设置打印方案
                config = { type: getSystemConfigForLandPos('dayinType', ''), host: getSystemConfigForLandPos('wangluo_DayinjiIP', '0.0.0.0'), port: getSystemConfigForLandPos('wangluo_Port', '9100'), printerName: getSystemConfigForLandPos('qudong_DayinjiQudong', ''), path: getSystemConfigForLandPos('usb_Port', ''), baudrate: getSystemConfigForLandPos('usb_Botelv', '') };
            }else{
                var printValue = JSON.parse(selectPrintType);
                if(printValue.val==true||printValue.val=='true'){
                    //网络打印机
                    config = { type: 'network', host: getSystemConfigForLandPos('wangluo_DayinjiIP', '0.0.0.0'), port: getSystemConfigForLandPos('wangluo_Port', '9100'), printerName: getSystemConfigForLandPos('qudong_DayinjiQudong', '系统打印机'), path: getSystemConfigForLandPos('usb_Port', ''), baudrate: getSystemConfigForLandPos('usb_Botelv', '') };
                }else{
                    config = { type: 'system', host: getSystemConfigForLandPos('wangluo_DayinjiIP', '0.0.0.0'), port: getSystemConfigForLandPos('wangluo_Port', '9100'), printerName: getSystemConfigForLandPos('qudong_DayinjiQudong', '系统打印机'), path: getSystemConfigForLandPos('usb_Port', ''), baudrate: getSystemConfigForLandPos('usb_Botelv', '') };
                }
            }
        }else{
            config = { type: getLocalSystemConfig('dayinType', ''), host: getLocalSystemConfig('wangluo_DayinjiIP', '0.0.0.0'), port: getLocalSystemConfig('wangluo_Port', '9100'), printerName: getLocalSystemConfig('qudong_DayinjiQudong', ''), path: getLocalSystemConfig('usb_Port', ''), baudrate: getLocalSystemConfig('usb_Botelv', '') };
        }
        if (config.type == '')
            return callback('请配置打印机');
        if (config.type === 'network'&&config.host==='0.0.0.0')
            return callback('请配置网络打印机IP');
        if (config.type === 'system' && config.printerName === '')
            return callback('请配置系统打印机名称');
        if (config.type === 'serialport' && config.path === '')
            return callback('请正确配置串口打印机');

        // 仅针对 横屏Pos 端
        if (config.type === 'webprint'&&config.host==='0.0.0.0')
            return callback('请配置网络打印机IP');
        // buildInprint
        // bluetoothprint


        if (_workingPrinter[config.host] != null && _workingPrinter[config.host]) {
			window.setTimeout(function(){
				me._doSelfPrint(job, callback);
			}, 500);
			return;
		}
		_workingPrinter[config.host] = true;
        var printer = me._getPrinter(config);
        var netPrinter = printer.printer;
        netPrinter.connect(printer.cfg, function () {
            job.printTime = new Date();
            var formattedText = PrinterTemplate.fillJobInfo(job.content, job);//+ PrinterCommand.CMD_PageGO(4) + PrinterCommand.CMD_Enter() + PrinterCommand.CMD_CutPage() + PrinterCommand.CMD_Enter();
            var buffer;
            if(CONTEXT.env == CONSTANTS.EnvConstants.ANDROID || CONTEXT.env == CONSTANTS.EnvConstants.IOS){
                if(job.name=='打开钱箱'){
                    buffer="打开钱箱";
                }else{
                    buffer = Utils.encodeBuffer(formattedText, 'gbk');
                }

                netPrinter.print(buffer, function () {
                    _workingPrinter[config.host] = false;
                    callback(null);
                },  function (error) {
                    _workingPrinter[config.host] = false;
                    callback(error);
                });
            }else{
                 buffer = Utils.encodeBuffer(formattedText, 'gbk');
                 netPrinter.print(buffer, function () {
                    _workingPrinter[config.host] = false;
                    callback(null);
                 });
            }

            netPrinter.flush();
            netPrinter.disconnect();
        }, function (err) {
            var message = err.message;
            if (message.indexOf('TIMEDOUT') >= 0)
                message = "打印机 " + message.replaceAll("connect ETIMEDOUT", "") + " 连接超时，请检查打印机状态和网络连接";
			_workingPrinter[config.host] = false;
			callback(message);
        }, function (err) {
            netPrinter.disconnect();
			_workingPrinter[config.host] = false;
            callback("无法连接打印机");
        });
    };

    this._doSelfPrint(job, callback);
}




