app.config(['$routeProvider', function ($routeProvider) {
    $routeProvider.when('/zhuotai', {
        templateUrl: 'app/views/zuotai.html',
        controller: 'ZhuotaiCtrl',
        resolve: {
            auth: ["$q", "AuthService", function ($q, AuthService) {
                var userInfo = AuthService.getUserInfo();
                if (userInfo) {
                    return $q.when(userInfo);
                }
                else {
                    return $q.reject({authenticated: false});
                }
            }]
        }
    })

        .when('/unlockDesk', {
            templateUrl: 'app/views/unlockDesk.html',
            controller: 'unlockController',
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when('/zhuotaijiesuan', {
            templateUrl: 'app/views/zuotaijiesuan.html',
            controller: 'ZhuotaiJieSuan',
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        }).when('/diancaipos', {
            templateUrl: 'app/views/diancai.html',
            controller: 'DiancaiPosCtrl',
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when('/unlockDesk', {
            templateUrl: 'app/views/unlockDesk.html',
            controller: 'unlockController',
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when('/jiesuan', {
            templateUrl: 'app/views/jiezhang_njys.html',
            controller: 'JiesuanCtrl',
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        }).when("/jieban", {
            templateUrl: "app/views/jieban.html",
            controller: "JiebanController",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when("/huiyuancard", {
            templateUrl: "app/views/chongzhi.html",
            controller: "HuiYuanCard",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when("/card", {
            templateUrl: "app/views/huiyuanxinxi.html",
            controller: "CardCtrl",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .when("/chongzhi", {
            templateUrl: "app/views/chongzhi.html",
            controller: "ChongZhiCtrl",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        }).when("/chexiao", {
            templateUrl: "app/views/chexiao.html",
            controller: "CheXiaoController",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        }).when("/login", {
            templateUrl: "app/views/login-nj.html",
            controller: "LoginController"
        }).when("/index", {
            templateUrl: "app/views/index-nj.html",
            controller: "IndexController"
        })
        .when("/install", {
            templateUrl: "app/views/install.html",
            controller: "InstallController"
        }).when("/setting", {
            templateUrl: "app/views/shezhi.html",
            controller: "SettingController"
        })
        .when("/about", {
            templateUrl: "app/views/about.html",
            controller: "AboutCtrl"
        })
        .when("/main", {
            templateUrl: "app/views/main-nj.html",
            controller: "MainController",
            resolve: {
                auth: ["$q", "AuthService", function ($q, AuthService) {
                    var userInfo = AuthService.getUserInfo();
                    if (userInfo) {
                        return $q.when(userInfo);
                    }
                    else {
                        return $q.reject({authenticated: false});
                    }
                }]
            }
        })
        .otherwise({redirectTo: '/login'});
}])
;