app.factory('cardInfoServer', ['$q', 'database', 'UniqueIDService', 'AjaxLogger', function ($q, database, UniqueIDService, AjaxLogger) {

    crmsdk.AjaxLogger = AjaxLogger;

    var cardInfoServer = {};

    //获取卡查询结果
    cardInfoServer.getCardInfos = function (undojifenObj, callback, errorcallback){
        crmsdk.post(MEMBERURL.CARD_INFO, undojifenObj, function (result) {
            callback(result);
        }, errorcallback);
    }

    //转账
    cardInfoServer.getTransInfos = function (undojifenObj, callback, errorcallback){
        crmsdk.post(MEMBERURL.CARD_ZHUANZHANG, undojifenObj, function (result) {
            callback(result);
        }, errorcallback);
    }


    //交易明细
    cardInfoServer.getTransDetail = function (undojifenObj, callback, errorcallback){
        crmsdk.post(MEMBERURL.CARD_DETAIL, undojifenObj, function (result) {
            callback(result);
        }, errorcallback);
    }

    return cardInfoServer;
}]);