﻿app.factory("OperatorService", ["$q", "database", "DiancaiService", function ($q, database) {
    var OperatorService = {};


    var operatorDao = new DatabaseFuncDelegate($q, database, 'pos_person');


    OperatorService.getAll = function (cb) {
        operatorDao.all()
            .then(function (result) {
                return cb(null, result);
            }, function (err) {
                return cb(err);
            })
    };

    OperatorService.getByCodeorGuid = function (code, cb) {
        console.info('OPService->Code:' + code);
        operatorDao.getById( code,'personNo')
            .then(function (result) {
                console.info('OPService->BYCode');
                var op = result;
                if (op)
                {
                    console.info('OPService->BYCode success');
                    return cb(null, op);
                }
                   

                operatorDao.getById( code,'guid')
                   .then(function (result) {
                       console.info('OPService->BYGuid success');
                       op = result;
                       return cb(null, op);

                   }, function (err) {
                       return cb(err);
                   });

            }, function (err) {
                return cb(err);
            });
    };


    return OperatorService;
}])