﻿app.factory("OrderCaipinZuofaService", ["$q", "database", function ($q, database) {
    var OrderCaipinZuofaService = {};

    var orderCaipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zuofa');

      
    OrderCaipinZuofaService.updateOrderCaipinZuofas = function (orderCaipin, orderCaipinZuofas, cb) {
        var queries = [];

        var orderScombCaipinId = null == orderCaipin.isScomb ? null : "true" == orderCaipin.isScomb ? orderCaipin.guid : null;
        var orderCaipinId;

        if (orderCaipin.isScombCaipin()) {
            orderCaipinId = orderCaipin.orderCaipinId;
        } else {
            orderCaipinId = orderCaipin.guid;
        }

        var deleteSql = "delete from pos_order_caipin_zuofa ";
        if (orderScombCaipinId != null) {
            deleteSql = deleteSql + " where orderScombCaipinId='" + orderCaipin.guid + "'";
        } else {
            deleteSql = deleteSql + " where orderCaipinId='" + orderCaipin.guid + "'";
        }
        queries.push({ query: deleteSql }); 
        for (var idx in orderCaipinZuofas) {
            orderCaipinZuofas[idx].guid = orderCaipinZuofas[idx].guid == null ? orderCaipinZuofaDao.guid() : orderCaipinZuofas[idx].guid;
            queries.push({
                query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime,isScomb,orderScombCaipinId)" +
                " values(?, ?, ?, ?, ?, ?,?,?,?,?,?)",
                params: [orderCaipinZuofas[idx].guid, orderCaipinId, orderCaipinZuofas[idx].zuofaId, orderCaipinZuofas[idx].name,
                orderCaipinZuofas[idx].typeId, orderCaipinZuofas[idx].price, orderCaipinZuofas[idx].jiajiaType, orderCaipinZuofas[idx].operator,
                orderCaipinZuofas[idx].modTime, orderCaipin.isScomb, orderScombCaipinId]
            });
        }
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinZuofas);
        }, function (err) {
            cb(err);
        });
    };

    return OrderCaipinZuofaService;
}])