app.factory('PosSystemConfigService', ['$q', 'database', function ($q,database) {
    var PosSystemConfigService = {};

    var systemConfigDao = new DatabaseFuncDelegate($q, database, 'pos_system_config');

    PosSystemConfigService.getAllConfigsByValueType = function (cb, valueType) {
        var para = "";
        if (!Utils.isEmpty(valueType)) {
            para = " valueType='" + valueType + "' ";
        }
        systemConfigDao.all(para).then(function (result) {
            return cb(null, result);
        }, function (err) {
            return cb(err)
        });
    };
    
    PosSystemConfigService.addOrModSystemconfig = function (possystemconfig, cb) {
        var sql = "select * from pos_system_config where SystemConfigName='" + possystemconfig.systmConfigName + "'";
        var curSystemConfig = null;
        systemConfigDao.query(sql).then(function (result) {
            curSystemConfig = result.detail;
        }, function (err) {
            return cb(err);
        }).then(function (o) {
            if (Utils.isEmpty( curSystemConfig)) {
                sql = "INSERT INTO pos_system_config (guid, systemConfigName, systemConfigAlias, systemConfigValue, valueType, mdId,  operatorTime, operatorId, operatorCode, operatorName,mac,isDeleted)" +
                    " VALUES ('" + systemConfigDao.guid() + "', '" + possystemconfig.systmConfigName + "', '" + possystemconfig.systemConfigAlias +
                    "', '" + possystemconfig.systemConfigValue + "', '" + possystemconfig.valueType + "', '" + possystemconfig.mdId + "', '" + possystemconfig.operatorTime +
                    "', '" + possystemconfig.operatorId + "', '" + possystemconfig.operatorCode + "', '" + possystemconfig.operatorName + "','" + possystemconfig .mac+ "', '0')";
            }
            else {
                sql = "update pos_system_config set SystemConfigValue='" + possystemconfig.systemConfigValue + "',operatorTime='" + possystemconfig.operatorTime + "'," +
                    "operatorId='" + possystemconfig.operatorId + "',operatorCode='" + possystemconfig.operatorCode + "',operatorName='" + possystemconfig.operatorName +
                    "',mac='" + possystemconfig.mac + "' where SystemConfigName='" + possystemconfig.systmConfigName + "'";
            }
            systemConfigDao.query(sql).then(function (result) {
                //每次更新完了，CONSTANTS.SystemConfigs重新获取
                if (result != null)
                    CONSTANTS.SystemConfigs[possystemconfig.systmConfigName] = possystemconfig;

                return cb(null, possystemconfig);
            }, function (err) {
                return cb(err);
            });
        })
    }
    
    //云端修改工号密码
    PosSystemConfigService.changePsw = function (userInfo, callback, errorcallback) {
        crmsdk.post(SETPSW.CHANGEPSW, userInfo, function (result) {
            callback(result);
        }, errorcallback,1);
    }
    
    //本地修改工号密码
    PosSystemConfigService.changeLocalPsw = function (userInfo, callback) {
        var sql = "update pos_person set password = '"+ userInfo.newPsd + "' where guid='" + userInfo.guid + "'";
        systemConfigDao.query(sql).then(function (result) {
            callback()
        }, function (err) {
        })
        
    }
    
    //查看原密码是否设置真确
    PosSystemConfigService.seepassword = function (userInfo, userPsw, cb) {
        var sql = "select * from pos_person where guid='" + userInfo.guid  + "'";
        systemConfigDao.query(sql).then(function (result) {
            if(result.detail[0].password == userPsw) {
              return cb()
            } else {
                Utils.showFailureInfo("输入的原密码不正确.");
            }
        })
        
    }
    
    return PosSystemConfigService;
}]);