/**
 * Created by peter.shang on 2016-01-14.
 */


app.factory("SettingService", ['$q', 'database',
    function($q, database){

        var SettingService = {};
        var settingDAO = new DatabaseFuncDelegate($q, database, 'pos_setting');

        SettingService.save = function(storeinfo,cb){

            settingDAO.insert(
                {
                    guid: settingDAO.guid(),
                    serverIp: storeinfo.serverIp,
                    storeAccount:storeinfo.storeAccount ,
                    storePassword:storeinfo.storePassword ,
                    storePattern :storeinfo.storePattern
                }
            ).then(function(result){
                    cb(null, result);
                },function(err){
                console.log(err);
                cb({ message: '保存失败.' });
            }
            )
        }
        return SettingService;

    }]);