/**
 * Created by peter.shang on 2016-03-02.
 *
 * 对外公开的服务的路由表
 *
 *
 * {
 *   "key":"LIU_SHUI_HAO",  --用于路由
 *   "body":{               --真正的业务参数，在请求体中
 *          "a":"av",
 *          "b":"bv"
 *          }
 *
 *  }
 *
*/

/**
 *
 * @param jsonStr 请求体中的JSON字符串
 * @param response 响应对象
 */
function wsrouter(jsonStr, response) {
   
    var j = JSON.parse(jsonStr);
    //console.log('转换后实体：' );
    //console.log(j);
    //获取流水号
    if(j.key == "LIU_SHUI_HAO"){
        nextSeq(j.body, response);
    }
    //peer sync
    else if(j.key == BIZCONSTANT.SYNC){
        syncPeer(j.body, response);
    } else if(j.key == BIZCONSTANT.SQL){
        sqlExe(j.body, response);
    } 
    else if (j.key == "WX_COMMAND") { // 无线点菜
        //console.log(Utils.now());
        console.log('http原始字符串：' + jsonStr);
		wxProcessor(j.body, response);
	}
	else if(j.key == "DEMOLOAD"){//仅仅为演示用。
        demo(j.body, response);
    }else{
        noProccessor(j.body, response);
    }



}
