var __globalLoaded = false;
var ieasyModule = null;
var appid = "pos";
var appsecret = "cMVS0MoqTCnp2ngcwoRrz3A3UPsygiOt";
var app = angular.module('ieasy360', [
    'ngResource',
    'ngSanitize',
    'ngRoute',
    'pascalprecht.translate'
])
    .provider({
        $rootElement: function () {
            this.$get = function () {
                return angular.element($("#_rootElement"));
            };
        }
    })
    .config(['$translateProvider', function ($translateProvider) {
        var language = navigator.language ? navigator.language : navigator.browserLanguage;
        var selectJson;
        if (language.indexOf("en") != -1) {
            selectJson = "string_en_us.json";
                     } else if (language.indexOf("zh") != -1) {
                         if (language.indexOf("tw") != -1) {
                             //繁体
                             selectJson = "string_zh_tw.json";
                         } else {
                             selectJson = "string_zh_cn.json";
                         }
        }
        htmlobj = $.ajax({url: selectJson, async: false});
        var jsonString = htmlobj.responseText;
        //console.log("test---"+jsonString);
        var json = eval('(' + jsonString + ')');
        //console.log("json-test---"+json);
        $translateProvider.translations(language, json);
        $translateProvider.preferredLanguage(language);
        LANGUAGECACHE = json;
    }], function ($compileProvider) {
        $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
    });
// 系统常量配置
app.constant('CONSTANTS', CONSTANTS).constant('BIZ', BIZCONSTANT).constant('BUSINESS', BUSINESS);

// 所有 module 加载完之后，在$rootScope 上面绑一些公共方法。
app.run(function ($rootScope) {
    // 针对Android 设备上的back 按键的点击做出处理
    $rootScope.handleBackKeyPress = function () {
        if (($(".modal").data('bs.modal') || {isShown: false}).isShown) {
            // alert("modal");
            // 暂时不做任何事
        } else {
            if ($("#editCaiPin").is(':visible') || $("#zengsongReasonDialog").is(':visible') || $("#tuicaiReasonDialog").is(':visible')) {
                return;
            }
            var locationUrl = location.hash.replaceAll('#', '');
            if (locationUrl == "/diancaipos") {
                if ($("#editCaiPin").is(':visible') || $("#zengsongReasonDialog").is(':visible') || $("#tuicaiReasonDialog").is(':visible')) {
                    return;
                }
                // 如何已点菜品页面是显示的则返回到前面的点菜页面
                if ($("#YiDianView").is(':visible')) {
                    var scope = angular.element('#YiDianView').scope();
                    scope.$apply(function () {
                        scope.clickDianCaiTab();
                    });
                } else {
                    // todo 如果在点菜界面，有已点菜品
                    var scope = angular.element('#DianCaiCtlView').scope();
                    scope.gotoZhuotai();
                }
            } else if (locationUrl == "/jiesuan") {
                if ($("#ZhekouView").is(':visible')) {
                    var scope = angular.element('#ZhekouView').scope();
                    scope.$apply(function () {
                        scope.backZheKou();
                    });
                } else if ($("#XianJinView").is(':visible')) {
                    var scope = angular.element('#XianJinView').scope();
                    scope.$apply(function () {
                        scope.backJieSuan();
                    });
                } else {
                    $rootScope.$broadcast('openLockZhuoTai', 'open');
                    //$rootScope.$broadcast('refreshZT', 'true');
                    window.yunshan.browserGoBackToPreviousPage();
                }
            } else if (locationUrl == "/zhuotaijiesuan") {
                var scope = angular.element('#zhuotaijiesuan').scope();
                scope.$apply(function () {
                    scope.gotoBack();
                });
            }
            else if (location.href.match("main$") || location.href.match("login$") || location.href.match("index$")) {
                // 在主界面的话，弹出 exit app dialog.
                window.yunshan.showExitAppDialogInNative();
            } else {
                // 其他页面则进行一般路由导航
                window.yunshan.browserGoBackToPreviousPage();
            }
        }
    }
    $rootScope.selectKeyboard = false;
    $rootScope.clearUserInfo = function(){
        var scope = angular.element('#mainCtl').scope();
        window.localStorage.setItem("isinit",false);
        if(location.href.match("login$")||location.href.match("index$")){
            window.yunshan.loginoutApp();
        }else{
            scope.$apply(function(){
                scope.clearUserLoginInfo();
            });
        }
    }
});

app.directive('poskeyboard', function () {
    return {
        restrict: 'E',
        template: '<div class="ys-pos-keyboard keyboard_pos"><span ng-click="clickKey(\'0\')">0</span><span ng-click="clickKey(\'1\')">1</span>' +
        '<span ng-click="clickKey(\'2\')">2</span><span ng-click="clickKey(\'3\')">3</span><span ng-click="clickKey(\'4\')">4</span>' +
        '<span ng-click="clickKey(\'5\')">5</span><span ng-click="clickKey(\'6\')">6</span><span ng-click="clickKey(\'7\')">7</span>' +
        '<span ng-click="clickKey(\'8\')">8</span><span ng-click="clickKey(\'9\')">9</span><span ng-click="clickKey(\'q\')">q</span>' +
        '<span ng-click="clickKey(\'w\')">w</span><span ng-click="clickKey(\'e\')">e</span><span ng-click="clickKey(\'r\')">r</span>' +
        '<span ng-click="clickKey(\'t\')">t</span><span ng-click="clickKey(\'y\')">y</span><span ng-click="clickKey(\'u\')">u</span>' +
        '<span ng-click="clickKey(\'i\')">i</span><span ng-click="clickKey(\'o\')">o</span><span ng-click="clickKey(\'p\')">p</span>' +
        '<span ng-click="clickKey(\'a\')">a</span><span ng-click="clickKey(\'s\')">s</span><span ng-click="clickKey(\'d\')">d</span>' +
        '<span ng-click="clickKey(\'f\')">f</span><span ng-click="clickKey(\'g\')">g</span><span ng-click="clickKey(\'h\')">h</span>' +
        '<span ng-click="clickKey(\'j\')">j</span><span ng-click="clickKey(\'k\')">k</span><span ng-click="clickKey(\'l\')">l</span>' +
        '<span ng-click="clickKey(\'DELETE\')">删除</span><span ng-click="clickKey(\'z\')">z</span><span ng-click="clickKey(\'x\')">x</span>' +
        '<span ng-click="clickKey(\'c\')">c</span><span ng-click="clickKey(\'v\')">v</span><span ng-click="clickKey(\'b\')">b</span>' +
        '<span ng-click="clickKey(\'n\')">n</span><span ng-click="clickKey(\'m\')">m</span><span ng-click="clickKey(\'.\')">.</span>' +
        '<span ng-click="clearValur()">清空</span><span ng-click="clickKey(\'HIDE\')">隐藏</span></div>',
        replace: true,
        link: function ($scope) {
        }
    };
});

window.onerror = function(msg,url,line,col,error){
    Utils.hideLoading();
    //没有URL不上报！上报也不知道错误
    if (msg != "Script error." && !url){
        return true;
    }
    //采用异步的方式
    setTimeout(function(){
        var data = {};
        //不一定所有浏览器都支持col参数
        col = col || (window.event && window.event.errorCharacter) || 0;

        data.url = url;
        data.line = line;
        data.col = col;
        if (!!error && !!error.stack){
            //如果浏览器有堆栈信息
            //直接使用
            data.msg = error.stack.toString();
        }else if (!!arguments.callee){
            //尝试通过callee拿堆栈信息
            var ext = [];
            var f = arguments.callee.caller, c = 3;
            //这里只拿三层堆栈信息
            while (f && (--c>0)) {
                ext.push(f.toString());
                if (f  === f.caller) {
                    break;//如果有环
                }
                f = f.caller;
            }
            ext = ext.join(",");
            data.msg = ext;
        }
        //把data上报到后台！
        console.log("错误日志"+data.msg);
    },0);

    return true;
};

//window.onerror = function(a,b,c) {
//    console.log("错误记录"+a+b+c);
//    Utils.hideLoading();
//}


//处理 angular 中未处理的异常
app.factory('$exceptionHandler', ['$log', function ($log) {
    return function (exception, cause) {
        $log.warn(exception, cause);
        Utils.winLog('ANGULAR_EXCEPTION: ', exception, exception.stack, cause);
    };
}]);

app.factory('_', function () {
    return window._; // assumes lodash has already been loaded on the page
});

app.filter('myDateFormat', function myDateFormat($filter) {
    return function (text) {
        if (Utils.isEmpty(text)) {
            return "";
        }
        var tempdate = new Date(text.replace(/-/g, "/"));
        return $filter('date')(tempdate, "HH:mm:ss");
    }
});

app.filter('checkmark', function () {
    return function (input) {
        return input == 1 ? '\u2713' : '\u2718';
    }
});

app.directive('ysfooter', function () {
    var show_day = new Array('星期一', '星期二', '星期三', '星期四', '星期五', '星期六', '星期日');
    var yunTagCss = YUN_CONNECT.CONNECT;
    return {
        restrict: 'E',
        template: '<div class="navbar-fixed-bottom ys-footer text-center">' +
        '<span class="col-xs-2 pull-left" style="text-align:left;"><i>' + BIZCONSTANT.POSUSER.HotelName + '</i>  <i>&nbsp;用户 &nbsp;{{curUser.name}}</i></span>' + '<span class="col-md-6 col-xs-6">' +
        '<span class="shortcuts pull-left" data-toggle="modal" data-target="#mdshortcuts">快捷键</span>' +
        '<i class="ys-info icon-wifi " ng-class="{\'icon-wifi-active\':PEER_CONNECTION_STATU}">网络状态</i>' +
        '<i class="ys-info icon-cloud" ng-class="{\'icon-cloud-active\':YUN_CONNECTION_STATU}">云连接</i>' +
        '<i class="ys-info icon-printer" ng-click="printreport()" ng-class="{\'icon-printer-active\':PRINTERSTATUS}">打印机</i>' +
        '</span>' +
        '<span id="footertime" class="col-md-3 col-xs-3 pull-right" style="text-align:right;">' + (new Date()).format('yyyy-MM-dd hh:mm:ss') + ' ' + show_day[(new Date()).getDay() - 1] + '</span>' +

        '</div>',
        replace: true
    };
});


app.directive('keyboard', function () {
    return {
        restrict: 'E',
        template: '<div class="ys-login-keyboard keyboard"><span ng-click="clickKey(\'0\')">0</span><span ng-click="clickKey(\'1\')">1</span>' +
        '<span ng-click="clickKey(\'2\')">2</span><span ng-click="clickKey(\'3\')">3</span><span ng-click="clickKey(\'4\')">4</span>' +
        '<span ng-click="clickKey(\'5\')">5</span><span ng-click="clickKey(\'6\')">6</span><span ng-click="clickKey(\'7\')">7</span>' +
        '<span ng-click="clickKey(\'8\')">8</span><span ng-click="clickKey(\'9\')">9</span><span ng-click="clickKey(\'q\')">q</span>' +
        '<span ng-click="clickKey(\'w\')">w</span><span ng-click="clickKey(\'e\')">e</span><span ng-click="clickKey(\'r\')">r</span>' +
        '<span ng-click="clickKey(\'t\')">t</span><span ng-click="clickKey(\'y\')">y</span><span ng-click="clickKey(\'u\')">u</span>' +
        '<span ng-click="clickKey(\'i\')">i</span><span ng-click="clickKey(\'o\')">o</span><span ng-click="clickKey(\'p\')">p</span>' +
        '<span ng-click="clickKey(\'a\')">a</span><span ng-click="clickKey(\'s\')">s</span><span ng-click="clickKey(\'d\')">d</span>' +
        '<span ng-click="clickKey(\'f\')">f</span><span ng-click="clickKey(\'g\')">g</span><span ng-click="clickKey(\'h\')">h</span>' +
        '<span ng-click="clickKey(\'j\')">j</span><span ng-click="clickKey(\'k\')">k</span><span ng-click="clickKey(\'l\')">l</span>' +
        '<span ng-click="clickKey(\'DELETE\')">删除</span><span ng-click="clickKey(\'z\')">z</span><span ng-click="clickKey(\'x\')">x</span>' +
        '<span ng-click="clickKey(\'c\')">c</span><span ng-click="clickKey(\'v\')">v</span><span ng-click="clickKey(\'b\')">b</span>' +
        '<span ng-click="clickKey(\'n\')">n</span><span ng-click="clickKey(\'m\')">m</span><span ng-click="clickKey(\'.\')">.</span>' +
        '<span ng-click="clickKey(\'ENTER\')">回车</span><span ng-click="clearValur()">清空</span></div>',
        replace: true,
        link: function ($scope) {

        }

    };


});


function callAjax(url, callback, data, method, errorFunc) {
    jQuery.ajax({
        type: method == null ? "POST" : method,
        url: url,
        data: data,
        dataType: "json",
        contentType: "application/json",
        success: callback,
        error: errorFunc == null ? function (error, data) {
            $.maskLoader("hide");
            console.log("请求出错。url::" + url + ";原因：：" + JSON.stringify(error));
        } : errorFunc
    });
}


$.ajaxSetup({
    beforeSend: function (xhrhttp, req) {

        var url = req.url;
        if (url.indexOf("file:") == 0)
            return;
        //验证是否是需要加token的地址    
        var TokenHost = null;
        for (var key in VALIDATE_TOKEN_HOST) {
            if (url.indexOf(VALIDATE_TOKEN_HOST[key].HOST_BASIC) > 0) {
                TokenHost = VALIDATE_TOKEN_HOST[key];
                break;
            }
        }
        if (TokenHost == null)
            return;

        ////获取参数数组
        //var arrayParam = getParams(req.url);
        //if (url.indexOf("?") > 0) {
        //    url = req.url.substring(0, req.url.indexOf("?"));
        //}
        if (TokenHost.TYPE == TOKEN_HOST_TYPE.POS) {
            req.url = handlePosUrl(req.url);
        } else if (TokenHost.TYPE == TOKEN_HOST_TYPE.WEIXIN) {
            req.url = handleWeixinUrl(req.url);
        }
    }
})


/* handle pos url  start */
function handlePosUrl(url) {
    var _url = url;
    //获取参数数组
    var arrayParam = getParams(url);
    if (_url.indexOf("?") > 0) {
        _url = url.substring(0, url.indexOf("?"));
    }
    //var tempUrl = _url + "?" + getParamStrByArrayParams(arrayParam) + "&signature=" + requestToken(req.url, arrayParam);
    return _url + "?" + getParamStrByArrayParams(arrayParam) + "&signature=" + requestToken(url, arrayParam);
}
function requestToken(url, params) {
    var urlStr = "";
    if (url.indexOf("?") > 0) {
        urlStr = url.substring(0, url.indexOf("?"));
    } else {
        urlStr = url;
    }
    var fullurl = urlStr + appsecret + buildQueryString(params);
    //TODO MD5处理
    return hex_md5(fullurl).toUpperCase();
}
//获取param的字符串
function buildQueryString(params) {
    var queryStr = "";

    params.sort(function (a, b) {
        return a.name > b.name;
    });

    return getParamStrByArrayParams(params);
}
/*
 *获取地址中的参数
 * url   初始地址
 * 返回格式  [{name:'xxx',value:'xxx'},{name:'xxx',value:'xxx'}]
 */
function getParams(url) {
    var timestamp = new Date().getTime();
    var params = [{name: 't', value: timestamp}, {name: 'token', value: timestamp}, {name: 'appid', value: appid}];
    if (url.indexOf("?") > 0) {
        var paramStr = url.substring(url.indexOf("?") + 1);
        var arrayParam = paramStr.split("&");
        for (var idx in arrayParam) {
            var singleParam = arrayParam[idx].split("=");
            if (singleParam[0].toLowerCase() != "t" && singleParam[0].toLowerCase() != "token" && singleParam[0].toLowerCase() != 'appid')
                params.push({name: singleParam[0], value: singleParam[1]});
        }
    }
    return params;
}
//根据参数数组获取参数字符串
function getParamStrByArrayParams(params) {
    var queryStr = "";
    for (var idx in params) {
        queryStr = queryStr + params[idx].name + "=" + params[idx].value + "&";
    }
    queryStr = queryStr.substring(0, queryStr.length - 1);
    return queryStr;
}
/* handle pos url  end */

/* handle weixin url  start */
function handleWeixinUrl(url) {
    var _url = url;
    //获取参数数组
    var arrayParam = getPosParams(url);
    if (_url.indexOf("?") > 0) {
        _url = url.substring(0, url.indexOf("?"));
    }
    arrayParam.push({name: "token", value: generateRequestToken(_url, arrayParam)});

    //var tempUrl = _url + "?" + getParamStrByArrayParams(arrayParam) + "&signature=" + requestToken(req.url, arrayParam);
    return _url + "?" + getParamStrByArrayParams(arrayParam);
}


function getPosParams(url) {
    var timestamp = new Date().getTime();
    var params = [{name: 't', value: timestamp}];
    if (url.indexOf("?") > 0) {
        var paramStr = url.substring(url.indexOf("?") + 1);
        var arrayParam = paramStr.split("&");
        for (var idx in arrayParam) {
            var singleParam = arrayParam[idx].split("=");
            if (singleParam[0].toLowerCase() != "t" && singleParam[0].toLowerCase() != "token")
                params.push({name: singleParam[0], value: singleParam[1]});
        }
    }
    return params;
}
function generateRequestToken(url, parameters) {
    var fullurl = url + getParamStrByArrayParams(parameters) + WEIXIN.API_KEY;
    return hex_md5(fullurl);
}


/* handle weixin url  end */

app.factory('keyboardManager', ['$window', '$timeout', function ($window, $timeout) {
    var keyboardManagerService = {};

    var defaultOpt = {
        'type': 'keydown',
        'propagate': false,
        'inputDisabled': false,
        'target': $window.document,
        'keyCode': false
    };
    // Store all keyboard combination shortcuts
    keyboardManagerService.keyboardEvent = {}
    // Add a new keyboard combination shortcut
    keyboardManagerService.bind = function (label, callback, opt) {
        var fct, elt, code, k;
        // Initialize opt object
        opt = angular.extend({}, defaultOpt, opt);
        label = label.toLowerCase();
        elt = opt.target;
        if (typeof opt.target == 'string') elt = document.getElementById(opt.target);

        fct = function (e) {
            e = e || $window.event;

            // Disable event handler when focus input and textarea
            if (opt['inputDisabled']) {
                var elt;
                if (e.target) elt = e.target;
                else if (e.srcElement) elt = e.srcElement;
                if (elt.nodeType == 3) elt = elt.parentNode;
                if (elt.tagName == 'INPUT' || elt.tagName == 'TEXTAREA') return;
            }

            // Find out which key is pressed
            if (e.keyCode) code = e.keyCode;
            else if (e.which) code = e.which;
            var character = String.fromCharCode(code).toLowerCase();

            if (code == 188) character = ","; // If the user presses , when the type is onkeydown
            if (code == 190) character = "."; // If the user presses , when the type is onkeydown

            var keys = label.split("+");
            // Key Pressed - counts the number of valid keypresses - if it is same as the number of keys, the shortcut function is invoked
            var kp = 0;
            // Work around for stupid Shift key bug created by using lowercase - as a result the shift+num combination was broken
            var shift_nums = {
                "`": "~",
                "1": "!",
                "2": "@",
                "3": "#",
                "4": "$",
                "5": "%",
                "6": "^",
                "7": "&",
                "8": "*",
                "9": "(",
                "0": ")",
                "-": "_",
                "=": "+",
                ";": ":",
                "'": "\"",
                ",": "<",
                ".": ">",
                "/": "?",
                "\\": "|"
            };
            // Special Keys - and their codes
            var special_keys = {
                'esc': 27,
                'escape': 27,
                'tab': 9,
                'space': 32,
                'return': 13,
                'enter': 13,
                'backspace': 8,

                'scrolllock': 145,
                'scroll_lock': 145,
                'scroll': 145,
                'capslock': 20,
                'caps_lock': 20,
                'caps': 20,
                'numlock': 144,
                'num_lock': 144,
                'num': 144,

                'pause': 19,
                'break': 19,

                'insert': 45,
                'home': 36,
                'delete': 46,
                'end': 35,

                'pageup': 33,
                'page_up': 33,
                'pu': 33,

                'pagedown': 34,
                'page_down': 34,
                'pd': 34,

                'left': 37,
                'up': 38,
                'right': 39,
                'down': 40,

                'numpadadd': 107,
                'numpadsubtract': 109,

                'f1': 112,
                'f2': 113,
                'f3': 114,
                'f4': 115,
                'f5': 116,
                'f6': 117,
                'f7': 118,
                'f8': 119,
                'f9': 120,
                'f10': 121,
                'f11': 122,
                'f12': 123
            };
            // Some modifiers key
            var modifiers = {
                shift: {
                    wanted: false,
                    pressed: e.shiftKey ? true : false
                },
                ctrl: {
                    wanted: false,
                    pressed: e.ctrlKey ? true : false
                },
                alt: {
                    wanted: false,
                    pressed: e.altKey ? true : false
                },
                meta: { //Meta is Mac specific
                    wanted: false,
                    pressed: e.metaKey ? true : false
                }
            };
            // Foreach keys in label (split on +)
            for (var i = 0, l = keys.length; k = keys[i], i < l; i++) {
                switch (k) {
                    case 'ctrl':
                    case 'control':
                        kp++;
                        modifiers.ctrl.wanted = true;
                        break;
                    case 'shift':
                    case 'alt':
                    case 'meta':
                        kp++;
                        modifiers[k].wanted = true;
                        break;
                }
                //debugger;
                if (k.length > 1) { // If it is a special key
                    if (special_keys[k] == code) kp++;
                } else if (opt['keyCode']) { // If a specific key is set into the config
                    if (opt['keyCode'] == code) kp++;
                } else { // The special keys did not match
                    if (character == k) kp++;
                    else {
                        if (shift_nums[character] && e.shiftKey) { // Stupid Shift key bug created by using lowercase
                            character = shift_nums[character];
                            if (character == k) kp++;
                        }
                    }
                }
            }

            if (kp == keys.length &&
                modifiers.ctrl.pressed == modifiers.ctrl.wanted &&
                modifiers.shift.pressed == modifiers.shift.wanted &&
                modifiers.alt.pressed == modifiers.alt.wanted &&
                modifiers.meta.pressed == modifiers.meta.wanted) {
                if (document.activeElement.nodeName == 'INPUT' && (!$(document.activeElement).attr('type') || $(document.activeElement).attr('type') == '' || $(document.activeElement).attr('type').indexOf('text') >= 0))
                    return false;
                $timeout(function () {
                    e.label = label;
                    callback(e);
                }, 1);

                if (!opt['propagate']) { // Stop the event
                    // e.cancelBubble is supported by IE - this will kill the bubbling process.
                    e.cancelBubble = true;
                    e.returnValue = false;

                    // e.stopPropagation works in Firefox.
                    if (e.stopPropagation) {
                        e.stopPropagation();
                        e.preventDefault();
                    }
                    return false;
                }
            }

        };
        // Store shortcut
        keyboardManagerService.keyboardEvent[label] = {
            'callback': fct,
            'target': elt,
            'event': opt['type']
        };
        //Attach the function with the event
        if (elt.addEventListener) elt.addEventListener(opt['type'], fct, false);
        else if (elt.attachEvent) elt.attachEvent('on' + opt['type'], fct);
        else elt['on' + opt['type']] = fct;
    };
    // Remove the shortcut - just specify the shortcut and I will remove the binding
    keyboardManagerService.unbind = function (label) {
        label = label.toLowerCase();
        var binding = keyboardManagerService.keyboardEvent[label];
        delete (keyboardManagerService.keyboardEvent[label])
        if (!binding) return;
        var type = binding['event'],
            elt = binding['target'],
            callback = binding['callback'];
        if (elt.detachEvent) elt.detachEvent('on' + type, callback);
        else if (elt.removeEventListener) elt.removeEventListener(type, callback, false);
        else elt['on' + type] = false;
    };
    //
    return keyboardManagerService;
}]);
