﻿app.controller("CheXiaoController", ["$scope", "$timeout", "$location", 'auth', 'AuthService', '$rootScope', 'UniqueIDService', 'CardService',
    function ($scope, $timeout, $location, auth, AuthService, $rootScope, UniqueIDService, CardService) {

        $scope.member = new Member();
        $scope.datalist = [];


        $scope.init = function () {

            $('#cardnoinput')[0].focus();
            
        };


        /**
        * 回车
        **/
        $scope.cardnoin = function (event) {
            if (event.keyCode == 13) {
                //debugger;
                var cardno = event.currentTarget.value;
                if (cardno && cardno != '')
                    duka(cardno);
            }
        }

        /**
        *读卡
        */
        function duka(cardno) {
            $.maskLoader('show');
            CardService.GetCardInfo(cardno, function (result) {
                
                if (result.status == 'failed') {
                    $.maskLoader('hide');
                    $scope.member = new Member();
                    return Utils.showFailureInfo(result.errorDetails[0].desc);
                }
                var card = result.data;
                if (card) {
                    $scope.member._cardNum = card.cardCode;
                    $scope.member._name = card.crmMemberInfo.hyName;
                    $scope.member.setCZ(parseFloat(card.crmCardAccountInfo.prepaidBalance));
                    $scope.member.setZS(parseFloat(card.crmCardAccountInfo.presentBalance));
                    $scope.member._ye = card.crmCardAccountInfo.totalAmount;
                    $scope.member._phone = card.crmMemberInfo.hyMobile;
                    $scope.member._dob = Utils.formatDate(card.crmMemberInfo.hyBirthday, 'yyyy-MM-dd');
                    $scope.member._address = card.crmMemberInfo.hyAddress;
                    $scope.member._remark = card.crmMemberInfo.hyDesc;

                    $scope.member.crmLevelRuleInfos = card.crmCardLevelInfo.crmLevelRuleInfos;

                    loaddatalist(card.cardCode);

                   

                } else {
                    $.maskLoader('hide');
                    $scope.member = new Member();
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_weichaxundaocika"]);
                }

            }, function () { $.maskLoader('hide'); $scope.member = new Member(); Utils.showFailureInfo(LANGUAGECACHE["str_tip_dukashibai"]); });

        }

        function loaddatalist(cardcode)
        {
            CardService.CardBanciTrade(cardcode, function (res) {
                $.maskLoader('hide');
                if (res.status == 'success') {

                    var list = [];
                    for (var i in res.dataList) {
                        var item = res.dataList[i];
                        var rec = {};
                        rec.tradeCredentialNumber = item.tradeCredentialNumber;
                        rec.addUser = item.addUser;
                        rec.tradeMoney = item.tradeMoney;
                        rec.tradePresentMoney = item.tradePresentMoney;
                        rec.tradePresentPoint = item.tradePresentPoint;
                        rec.addTime = Utils.formatDate(item.addTime, 'MM-dd hh:mm');
                        list.push(rec);
                    }
                    $scope.datalist = list;
                }
                else
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_lajilufail"]);
            }, function () {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_lajilufailrepetition"]);
            });
        }

        $scope.save = function ()
        {
            var tcnum = $("input[name='tcnum']:checked").val();
            if(!tcnum)
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_chooserevokezhangdan"]);

            var note = $('#cxnote').val();
            if(!note||note=='')
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputrevokereason"]);
            $.maskLoader('show');
            CardService.CancelRechardTrade(tcnum, note, function (res) {
                $.maskLoader('hide');
                if (res.status == 'success') {
                    Utils.showSuccessInfo(LANGUAGECACHE["str_tip_revokesuccess"]);
                    duka($scope.member._cardNum);
                    //$scope.gotoZhuotai();
                    $('#cxnote').val('');
                }
                else
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_revokefail"]);
            }, function () {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_revokefail"]);
            });
        }

        /**
        * 数字键盘
        */
        $scope.ReadCard = function () {

            var cardno = $('#cardnoinput').val();
            if (!cardno || cardno == '')
                CardService.ReadCard(function (result) {
                    if (result.error != '')
                        return Utils.showFailureInfo(result.error);

                    if (result.card_no == '')
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_weichaxundaocika"]);

                    $('#cardnoinput').val(result.card_no);
                    duka(result.card_no);
                }, function (error) {
                    Utils.showFailureInfo(error);
                });
            if (cardno && cardno != '')
                return duka(cardno);
           
        }

        $scope.gotoZhuotai = function () {
            $('#msj').modal('hide');
            $location.url("/zhuotai");
        }


        $scope.gotochongzhi = function () {
            $('#msj').modal('hide');
            $location.url("/chongzhi");
        }

        $scope.gotocard = function () {
            $('#msj').modal('hide');
            $location.url("/card");
        }

    }]);