﻿app.controller("JiebanController", ["$scope", "$timeout", "$location", "auth", "AuthService",
    "$rootScope", "CanbieService", "JiebanService", "UniqueIDService", "CardService", "ZhangdanQueryService", "UploadService","JieSuanService",
    function ($scope, $timeout, $location, auth, AuthService, $rootScope, CanbieService,
              JiebanService, UniqueIDService, CardService, ZhangdanQueryService, UploadService,JieSuanService) {

        $scope.currentOperator = $rootScope.curUser;

        $scope.isResponseHuiyuanChuzhi = true;

        $scope.zhangdans = {
            total: 0,
            pages: 0,
            rows: 20,
            currentPage: 1,
            zhangdanSumMoney: getZhangdanSumMoney,
            items: []
        };
        $scope.banciZhangdans = new pagination({rows: [], size: 1});//当前班次账单,分页
        //$scope.banciZhangdans.culsize($(".zhangdan").height()-41-102,41);


        function getZhangdanSumMoney() {
            var sumMoney = 0;
            _.each($scope.zhangdans.items, function (zhangdans) {
                sumMoney += parseFloat(zhangdans.shiShou);
            })
            return sumMoney.toFixed(2);
        }

        $scope.fuKuanFangShis = {
            total: 0,
            pages: 0,
            rows: 50,
            currentPage: 1,
            FuKuanFangShiSumMoney: getFuKuanFangShiSumMoney,
            items: []
        };
        $scope.banciFuKuanFangShis = new pagination({rows: [], size: 8});//当前班次账单,分页
        $scope.banciFuKuanFangShis.culsize($(".zhangdan").height() - 41 - 102, 41);

        function getFuKuanFangShiSumMoney() {
            var sumMoney = 0;
            _.each($scope.fuKuanFangShis.items, function (fukuanfangshi) {
                sumMoney += parseFloat(fukuanfangshi.sumMoney);
            })
            return sumMoney.toFixed(2);
        }

        $scope.caipinTypes = {
            total: 0,
            pages: 0,
            rows: 20,
            currentPage: 1,
            items: [],
            caipinTypesSumMoney: getCaipinTypesSumMoney,
        };

        $scope.banciCaipinTypes = new pagination({rows: [], size: 8});//当前班次账单,分页
        $scope.banciCaipinTypes.culsize($(".zhangdan").height() - 41 - 102, 41);

        function getCaipinTypesSumMoney() {
            var sumMoney = 0;
            _.each($scope.caipinTypes.items, function (caipinType) {
                sumMoney += parseFloat(caipinType.sumMoney);
            })
            return sumMoney.toFixed(2);
        }


        $scope.banciZhangdanHuizong = {};

        $scope.weiJiesuanZhuotaiNames = [];
        $scope.huiyuanChuzhis = [];
        $scope.huiyuanChuzhiMoney = 0;

        $scope.banciNo = $rootScope.curUser.banCiHao;

        $scope.orders = null;
        var curOrder = null;
        $scope.curOrder = curOrder;

        $scope.pagination = new pagination({rows: [], size: 100});

        $scope.banciYingyeYoumian = new pagination({rows: [], size: 80});//当前班次账单,分页

        var queryParamObj = null;
        $scope.queryParamObj = queryParamObj;

        $scope.yingyeYoumian = {
            total: 0,
            pages: 0,
            rows: 20,
            currentPage: 1,
            items: [],
            yingyeYoumianSumMoney: getYingyeYoumianSumMoney,
        };

        function getYingyeYoumianSumMoney() {
            var sumMoney = 0;
            _.each($scope.yingyeYoumian.items, function (yingyeYoumian) {
                sumMoney += parseFloat(yingyeYoumian.sumMoney);
            })
            return sumMoney.toFixed(2);
        }

        $scope.clickOrderCaipin = function (orderId,jieSuanId) {
            ZhangdanQueryService.getZhangdanCaipinByOrderId(orderId, function (err,result) {
                if (err){
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.msg);
                }
                $scope.curCaipins = JieSuanService.mergeLuoDanCaiPin(result);
                $scope.clickOrderBillingdetail(jieSuanId);
            });
        }

        function getOrderDetails(order) {
            $scope.clickOrderCaipin(order.guid,order.jieSuanId);
            //$scope.clickOrderBillingdetail(order.jieSuanId);
        }

        $scope.clickOrderBillingdetail = function (jieSuanId) {
            ZhangdanQueryService.getZhangdanBilldetailByJiesuanNo(jieSuanId, function (err, result) {
                Utils.hideLoading();
                if (err)
                    return Utils.showFailureInfo(err.msg);
                $scope.curBillingdetails = result;
                $scope.printJieZhangDan();
            });
        }

        $scope.printJieZhangDan = function () {

            if (!$scope.curOrder)
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_selectzhangdan"]);
            ZhangdanQueryService.orderBilling($scope.curOrder, function (err, result) {
                var payments = [];
                var youMianPaymentSum = 0;
                var hyzk = 0;
                for (var i in $scope.curBillingdetails) {
                    var o = $scope.curBillingdetails[i];
                    var pm  =null;
                    if(o.type == "PAY"){
                        pm = new PaymentMethod();
                        pm.caiWuShuXing = o.caiWuShuXing;
                        pm.name = o.bizDesc;
                        pm.addMoney(o.amount);
                        payments.push(pm);
                        if(pm.isYouMian()){
                            youMianPaymentSum = Utils.m(youMianPaymentSum) + Utils.m(o.amount);
                        }
                    }
                    if(o.type == "ZK" && o.bizCode == BIZCONSTANT.ZHE_KOU_HY_PRICE)
                        hyzk = o.bizAmount;
                }
                var ret = {
                    total: 0, //消费合计
                    ofZheKouName: result.moneyZhengDanBiLiName, //折扣率的名字
                    ofZheKouMoney: Utils.m(result.moneyZhengDanBiLi), //折扣掉的金额
                    youMian: Utils.m(result.moneyDingE),//定额
                    free: result.moneyZengSong, //赠送
                    payment: [],
                    yishou:Utils.m(result.shiShou),
                    yingShou:Utils.m(result.shiShou), //结算后账单，实收应当等于应收,
                    youMianPayment:youMianPaymentSum,
                    zhaoLing:0,
                    danPinSum:Utils.m(result.moneyDanPin),
                    hyJiaYouHui: hyzk,
                    moLingSum: Utils.m(result.moLing)
                };

                ret.total = Utils.m(result.zhangDanTotal);
                ret.payment = payments;

                var jiesuan = {};
                jiesuan.order = $scope.curOrder;
                jiesuan.payMethodList = payments;
                jiesuan.yiShou = Utils.m(result.shiShou);

                printhelp.printJieZhangDan(jiesuan, $scope.curCaipins, $scope.curOrder.zhuotaiName, ret,false,function(e){
                    if(!Utils.isEmpty(e)){
                        Utils.confirm(e,function(){});
                    }
                });

            });
        }

        $scope.showReprintDialog = function(){
            if($scope.curOrder==null){
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_selectzhangdan"]);
                return;
            }
            $("#mjb_reprint_zd").modal("show");
        }

        $scope.reprintZD = function(){
            if($scope.curOrder==null){
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_selectzhangdan"]);
                return;
            }
            $("#mjb_reprint_zd").modal("hide");
            Utils.showLoading(LANGUAGECACHE["str_tip_reprint"]);
            getOrderDetails($scope.curOrder);
        }

        $scope.selectorder = function(order){
            $scope.curOrder = order;
        }

        $scope.showSelect = function(orderNo){
            if($scope.curOrder==null){
                return false;
            }
            if($scope.curOrder.orderNo==orderNo){
                return true;
            }else {
                return false;
            }
        }


        /*  加载数据 开始 */
        $scope.init = function () {
            Utils.showLoading();
            queryParamObj = new ZhangdanQuery();
            queryParamObj.bcNo = $scope.banciNo;
            loadHuiyuanChuzhi();
            loadBanciZhangdanHuizong();
            loadBanciZhangdan();
            loadFuKuanFangShi();
            loadAllOrderInfo();
            loadYingyeYoumian();
            loadCaipinType();
        };

        function loadBanciZhangdan() {
            JiebanService.getZhangdanInfo($scope.banciNo, function (err, result) {
                if (err){
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.message);
                }
                $scope.zhangdans.items = result;
                $scope.banciZhangdans.Init({rows: result});
            });
        };
        function loadBanciZhangdanHuizong() {
            JiebanService.getBanciZhangdanHuizong($scope.banciNo, function (err, result) {
                if (err){
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.message);
                }
                $scope.banciZhangdanHuizong = result;
            });
        };
        function loadFuKuanFangShi() {
            JiebanService.getFuKuanFangShi($scope.banciNo, function (err, result) {
                Utils.hideLoading();
                if (err)
                    return Utils.showFailureInfo(err.message);

                $scope.fuKuanFangShis.items = result;

                $scope.banciFuKuanFangShis.Init({rows: $scope.fuKuanFangShis.items});
            });
        };
        function loadCaipinType() {
            JiebanService.getCaipinType($scope.banciNo, function (err, result) {
                if (err){
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.message);
                }
                $scope.caipinTypes.items = result;
                $scope.banciCaipinTypes.Init({rows: $scope.caipinTypes.items});
            });
        }

        function loadHuiyuanChuzhi() {
            CardService.getHuiyuanChuzhiByBanci(function (result) {
                if ("success" != result.status) {
                    for (var idx in result.errorDetails) {
                        console.log(result.errorDetails[idx]);
                    }
                    $scope.isResponseHuiyuanChuzhi = false;
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_gethuiyuaninfofail"]);
                }
                $scope.huiyuanChuzhis = result.dataList;

                for (var idx in $scope.huiyuanChuzhis) {
                    $scope.huiyuanChuzhiMoney += Utils.m($scope.huiyuanChuzhis[idx].tradeMoney);
                }

            }, function (err) {
                $scope.isResponseHuiyuanChuzhi = false;
                Utils.hideLoading();
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_gethuiyuaninfofail"]);
                //$location.url("/zhuotai");
            })
        }

        function loadYingyeYoumian() {
            JiebanService.getYoumian($scope.banciNo, function (err, result) {
                if (err){
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err.message);
                }


                $scope.yingyeYoumian.items = result;

                $scope.banciYingyeYoumian.Init({rows: $scope.yingyeYoumian.items});
            });
        }

        $scope.sumyingyeyoumian = function () {
            return (Utils.m($scope.yingyeYoumian.yingyeYoumianSumMoney()) + Utils.m($scope.banciZhangdanHuizong.moneyMoLing) + Utils.m($scope.banciZhangdanHuizong.moneyZengSong) + Utils.m($scope.banciZhangdanHuizong.moneyZheKou) + Utils.m($scope.banciZhangdanHuizong.moneyHYZK) + Utils.m($scope.banciZhangdanHuizong.moneyHYYH)).ToString('C')
                ;
        }


        /*  加载数据 结束 */

        /* 按钮事件  */
        //改为不管结班单打印成功，都让结班
        //$scope.Jieban = function () {
        //    $.maskLoader('show','正在打印...');
        //    JiebanService.saveJieban($scope.banciNo, function (err, result) {
        //        $("#mjb").modal("hide");
        //        if (err)
        //            return Utils.showFailureInfo(err.message);
        //        $rootScope.curUser.banCiHao = null;
        //        Utils.showSuccessInfo("结班成功！");
        //        $location.url("/main");
        //    });
        //    $scope.printJieBan(function (err) {
        //        $.maskLoader('hide');
        //        if (err != null)
        //            return Utils.showFailureInfo("打印失败："+err);
        //    });
        //};
        $scope.sureJieban = function () {
            $("#mjb_print_error").modal("hide");
            realjieban();
        }
        $scope.Jieban = function () {
            Utils.showLoading();
            $scope.printJieBan(function (err) {
                Utils.hideLoading();
                if (err != null) {
                    $("#mjb_print_error").modal("show");
                } else {
                    realjieban();
                }
            });
        };

        function realjieban() {
            JiebanService.saveJieban($scope.banciNo, function (err, result) {
                $("#mjb").modal("hide");
                if (err)
                    return Utils.showFailureInfo(err.message);

                $rootScope.curUser.banCiHao = null;

                Utils.showSuccessInfo(LANGUAGECACHE["str_tip_jiebansuccess"]);
                //结班上传数据
                JiebanService.uploadJieban(function (e, res) {
                    if (!e) {
                        UploadService.syncJieban(res, function () {
                            JiebanService.lastSaveJieban($scope.banciNo)
                        })
                    }
                })
                $location.url("/main");
            });
        }

        $scope.gotoJieban = function () {
            JiebanService.validateJieban(function (err, result) {
                if (err)
                    return Utils.showFailureInfo(err.message);

                $scope.weiJiesuanZhuotaiNames = result;

                $("#mjb").modal("show");
            });

        };

        $scope.gotoBack = function () {
            $location.url("/main");
        }

        $scope.printJieBan = function (cb) {

            var jiebanobj = new JieBanDanObject();
            jiebanobj.taxMoney = $scope.banciZhangdanHuizong.getFaPiaoMoney();
            jiebanobj.shouyinyuan = BIZCONSTANT.POSUSER.name;
            jiebanobj.banciNo = BIZCONSTANT.POSUSER.banCiHao;
            jiebanobj.startTime = BIZCONSTANT.POSUSER.banCiStart;
            jiebanobj.endTime = new Date().format('yyyy-MM-dd hh:mm');
            jiebanobj.totalrs = $scope.banciZhangdanHuizong.renshu == null ? 0 : $scope.banciZhangdanHuizong.renshu;
            jiebanobj.totalzhuotai = $scope.banciZhangdanHuizong.jiaoyiCount;

            jiebanobj.orders = [];
            for (var i in $scope.zhangdans.items) {
                var zd = $scope.zhangdans.items[i];
                var order = {};
                order.orderNo = zd.orderNo;
                order.rateMoney = Utils.m(zd.shiShou);

                jiebanobj.orders.push(order);
            }


            jiebanobj.cplx = [];
            for (var i in $scope.caipinTypes.items) {
                var cp = $scope.caipinTypes.items[i];
                var cplx = {};
                cplx.name = cp.name;
                cplx.money = Utils.m(cp.sumMoney);

                jiebanobj.cplx.push(cplx);
            }

            jiebanobj.cwkm = [];
            for (var i in $scope.fuKuanFangShis.items) {
                var cp = $scope.fuKuanFangShis.items[i];
                var cwkm = {};
                cwkm.name = cp.name;
                cwkm.money = Utils.m(cp.sumMoney);

                jiebanobj.cwkm.push(cwkm);
            }

            jiebanobj.zhekous = [];
            for (var i in $scope.banciYingyeYoumian.allitems) {
                var cp = $scope.banciYingyeYoumian.allitems[i];
                var zk = {};
                zk.name = cp.name;
                zk.money = Utils.m(cp.sumMoney);

                jiebanobj.zhekous.push(zk);
            }
            if ($scope.banciZhangdanHuizong.moneyZheKou > 0)
                jiebanobj.zhekous.push({id: "", name: LANGUAGECACHE["str_tip_discountheji"], money: $scope.banciZhangdanHuizong.moneyZheKou});

            if ($scope.banciZhangdanHuizong.moneyHYZK > 0)
                jiebanobj.zhekous.push({id: "", name: LANGUAGECACHE["str_tip_huiyuandiscount"], money: $scope.banciZhangdanHuizong.moneyHYZK});

            if ($scope.banciZhangdanHuizong.moneyHYYH > 0)
                jiebanobj.zhekous.push({id: "", name: LANGUAGECACHE["str_tip_huiyuanyouhui"], money: $scope.banciZhangdanHuizong.moneyHYYH});

            if ($scope.banciZhangdanHuizong.moneyZengSong > 0)
                jiebanobj.zhekous.push({id: "", name: LANGUAGECACHE["str_btn_zengsong"], money: $scope.banciZhangdanHuizong.moneyZengSong});

            if ($scope.banciZhangdanHuizong.moneyMoLing != 0)
                jiebanobj.zhekous.push({id: "", name: LANGUAGECACHE["str_item_moling"], money: $scope.banciZhangdanHuizong.moneyMoLing});

            jiebanobj.chongzhis = [];
            for (var i in $scope.huiyuanChuzhis) {
                var cp = $scope.huiyuanChuzhis[i];
                var cwkm = {};
                cwkm.id = cp.payType;
                cwkm.name = cp.payTypeName;
                if (!cwkm.name)
                    cwkm.name = '';
                cwkm.money = Utils.m(cp.tradeMoney);


                jiebanobj.chongzhis.push(cwkm);
            }


            jiebanobj.getTotalCwkm = function () {
                return $scope.fuKuanFangShis.FuKuanFangShiSumMoney();
            };

            jiebanobj.getTotalCplx = function () {
                return $scope.caipinTypes.caipinTypesSumMoney();
            }

            jiebanobj.getTotalZK = function () {
                return $scope.sumyingyeyoumian();
            }

            var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.JIEBANDAN);
            var printtext = printhelp.printtext(jiebanobj, receipt);

            var printjob = new PrinterJob();
            printjob.name = LANGUAGECACHE["str_tip_jiebandan"];
            printjob.mPrinterId = '';
            printjob.status = 0;
            printjob.errorCount = 0;
            printjob.content = printtext;
            printjob.createTime = null;
            printjob.processing = 0;
            printjob.invoiceCode = receipt.code;
            printjob.ref = null;
            printjob.orderId = '';
            printjob.jobNo = null;
            printjob.printTime = null;
            printjob.printCount = 0;
            tickPrinter(printjob, cb);
        }

        //$scope.printJieBan = function (cb) {
        //    var jiebanobj = new JieBanDanObject();
        //    jiebanobj.taxMoney = $scope.banciZhangdanHuizong.getFaPiaoMoney();
        //    jiebanobj.shouyinyuan = BIZCONSTANT.POSUSER.name;
        //    jiebanobj.banciNo = BIZCONSTANT.POSUSER.banCiHao;
        //    jiebanobj.startTime = BIZCONSTANT.POSUSER.banCiStart;
        //    jiebanobj.endTime = new Date().format('yyyy-MM-dd hh:mm');
        //    jiebanobj.totalrs = $scope.banciZhangdanHuizong.renshu == null ? 0 : $scope.banciZhangdanHuizong.renshu;
        //    jiebanobj.totalzhuotai = $scope.banciZhangdanHuizong.jiaoyiCount;
        //
        //    jiebanobj.orders = [];
        //    for (var i in $scope.zhangdans.items)
        //    {
        //        var zd = $scope.zhangdans.items[i];
        //        var order = {};
        //        order.orderNo = zd.orderNo;
        //        order.rateMoney = Utils.m(zd.shiShou);
        //
        //        jiebanobj.orders.push(order);
        //    }
        //
        //
        //    jiebanobj.cplx = [];
        //    for (var i in $scope.caipinTypes.items) {
        //        var cp = $scope.caipinTypes.items[i];
        //        var cplx = {};
        //        cplx.name = cp.name;
        //        cplx.money = Utils.m(cp.sumMoney);
        //
        //        jiebanobj.cplx.push(cplx);
        //    }
        //
        //    jiebanobj.cwkm = [];
        //    for (var i in $scope.fuKuanFangShis.items) {
        //        var cp = $scope.fuKuanFangShis.items[i];
        //        var cwkm = {};
        //        cwkm.name = cp.name;
        //        cwkm.money = Utils.m(cp.sumMoney);
        //
        //        jiebanobj.cwkm.push(cwkm);
        //    }
        //
        //    jiebanobj.chongzhis = [];
        //    for (var i in $scope.huiyuanChuzhis) {
        //        var cp = $scope.huiyuanChuzhis[i];
        //        var cwkm = {};
        //        cwkm.id = cp.payType;
        //        cwkm.name = cp.payTypeName;
        //        if (!cwkm.name)
        //            cwkm.name = '';
        //        cwkm.money = Utils.m(cp.tradeMoney);
        //
        //
        //        jiebanobj.chongzhis.push(cwkm);
        //    }
        //
        //
        //    jiebanobj.getTotalCwkm = function () {
        //        return $scope.fuKuanFangShis.FuKuanFangShiSumMoney();
        //    };
        //
        //    jiebanobj.getTotalCplx = function ()
        //    {
        //        return $scope.caipinTypes.caipinTypesSumMoney();
        //    }
        //
        //    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.JIEBANDAN);
        //    var printtext = printhelp.printtext(jiebanobj, receipt);
        //
        //
        //    var printjob = new PrinterJob();
        //    printjob.name = "结班单";
        //    printjob.mPrinterId = '';
        //    printjob.status = 0;
        //    printjob.errorCount = 0;
        //    printjob.content = printtext;
        //    printjob.createTime = null;
        //    printjob.processing = 0;
        //    printjob.invoiceCode = receipt.code;
        //    printjob.ref = null;
        //    printjob.orderId = '';
        //    printjob.jobNo = null;
        //    printjob.printTime = null;
        //    printjob.printCount = 0;
        //
        //    tickPrinter(printjob, cb);
        //
        //    //$scope.zhangdans;
        //    //$scope.fuKuanFangShis;
        //    //$scope.caipinTypes;
        //    //$scope.huiyuanChuzhis = [];
        //}


        function loadAllOrderInfo() {
            ZhangdanQueryService.getZhangdanByParam(queryParamObj, function (err, result) {
                if (err)
                    return Utils.showFailureInfo(err.message);
                $scope.orders = result;
                $scope.orders.code = result.orderNo;
                $scope.pagination.Init({rows: $scope.orders});
                curOrder = result[0];
            })
        }

        function pageNext() {
            pagination.next();
        }

    }])