/**
 * peter.shang
 *
 */
app.controller("JiesuanCtrl", ["_", "$scope", "$location", '$rootScope','$timeout',
    'auth', 'AuthService', 'UniqueIDService', 'OrderMenuService', 'CanbieService', 'JieSuanService', 'DiancaiService', 'CardService', 'ZhuotaiService',
    function (_, $scope, $location, $rootScope,$timeout, auth, AuthService, UniqueIDService, OrderMenuService, CanbieService, JieSuanService, DiancaiService, CardService, ZhuotaiService) {

        var dlg = {
            zk: null //用户选中的折扣模板
        };
        var jieSuan = new JieSuan();
        $scope.moneyJieSuan = 0;
        jieSuan.setIgnoreXuShou(true);
        var zheKouList = null;
        var paymentMethodList = null;
        //结算页面的金额计算器
        var calculator = jieSuan.calculator;
        var zheKouCal = {zhekou: ""}
        //临时保存输入框
        var tempinput = null;
        var member = new Member();

        //待撤销的支付方式（只有即时支付类才有意义）
        var toBeRemovedPm = null;
        $scope.ISFANJIESUAN = false;

        $scope.dlg = dlg;
        $scope.jieSuan = jieSuan;
        $scope.zheKouList = zheKouList;
        $scope.pmList = paymentMethodList;
        $scope._ = _;
        $scope.calculator = calculator;
        $scope.zheKouCal = zheKouCal;
        $scope.luodanOrderCaipins = null;

        $scope.luodancppagination = new pagination({rows: [], size: 20});
        $scope.luodancppagination.culsize($('.order-content-wrap').height(), 42);

        $scope.ZFFSpagination = new pagination({rows: [], size: 20});

        $scope.filterZFFSpagination = new pagination({rows:[],size:20});

        //折扣列表
        $scope.ZheKouList = new pagination({rows:[],size:20});


        $scope.member = member;
        jieSuan.calculator = calculator;

        $scope.ISFANJIESUAN = false;

        $scope.jiesuanstep = 0;

        $scope.huiyuanCardNo = "";
        $scope.huiyuanCardPayMoney = 0; //输入的付款金额
        $scope.huiyuanCardWeiFuMoney = 0; //会员卡支付时候的未付金额 = 当前金额-优惠金额
        //默认读IC卡
        $scope.clickCardType = 0;

        var emittedObject = {};
        var emittedJiesuanInfo = function (jiesuan, caipins, isFinishedJiesuan) {
            isFinishedJiesuan = isFinishedJiesuan == null ? false : isFinishedJiesuan;
            if (jiesuan) {
                emittedObject.jiesuan = jiesuan;
            }
            if (caipins) {
                emittedObject.caipins = caipins;
            }
            if (!isFinishedJiesuan && emittedObject.jiesuan != null && emittedObject.caipins != null) {
                return $rootScope.$broadcast("orderChanged", emittedObject);
            }
            if (isFinishedJiesuan) {
                return $rootScope.$broadcast("orderChanged", null);
            }
        };

        $rootScope.$on('openLockZhuoTai', function (d, data) {
            ZhuotaiService.openLockZhuoTai($scope.currentZhuotai.guid);
        });

        $scope.init = function () {
            Utils.showLoading();
            //debugger;
            jieSuan.setPagination($scope.ZFFSpagination);
            if ($rootScope.currentOrder == null) {
                Utils.hideLoading();
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_cantfindzhangdan"]);
                return;
            }
            $scope.showXianJin = false;
            $scope.showZheKou = false;
            $scope.showJieSuan = true;

            //结算单号
            loadAllZheKouInfo();
            //所有支付方式
            loadAllPayMethod();

            var raw = $rootScope.currentOrder;

            //读取账单信息
            JieSuanService.loadByOrderId(raw, jieSuan, function (err, model) {
                Utils.hideLoading();
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.moneyJieSuan = jieSuan.order.getYingShou();
            });
            //TODO,
            DiancaiService.getOrderCaipinsByLuodan(raw.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, seq) {

                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                var mergedCaiPins = JieSuanService.mergeLuoDanCaiPin(seq);
                $scope.luodanOrderCaipins = mergedCaiPins;
                //$scope.luodanOrderCaipins = seq;
                $scope.luodancppagination.Init({rows: $scope.luodanOrderCaipins});
            });

        };
        /**
         *
         * @param zk  ZheKou
         */
        $scope.selectZheKou = function (zk) {
            //如果是内置的，则调用对话框
            if (zk.isBuiltIn()) {
                dlg.zk = zk;
                //$("#zkAmount").val(zk.zheKouAmount);
                //内置折扣要么为定额折扣，要么为自定义折扣，其折扣数量默认为空
                zheKouCal.zhekou = "";
                $("#zheKouDialog").modal("show");
                return;
            } else {
                jieSuan.addZheKou(zk);
                $scope.moneyJieSuan = jieSuan.order.getYingShou();
                closeZheKou();
            }
        }

        //解除折扣
        $scope.removeZheKou = function (zk) {
            jieSuan.removeZheKou(zk);
            $scope.moneyJieSuan = jieSuan.order.getYingShou();
        }

        //解除支付方式
        $scope.removePaymentMethod = function (pm) {

            //1.如果是反结算，并且支付方式是会员支付，那么禁止直接删除。必须通过反值操作
            if (pm.isPayFirst() && pm.ext1 != null) {
                //TODO. 显示反值界面
                // TODO, 校验的时候，需要得到上一次支付的时候 会员卡号 ， 可以通过： pm.getMemberNo();
                // TODO, 点读卡后，得到到的会员对象需要设定 member.isFanZhi = true;
                //TODO, 输入反值金额并确定后，需要 member.setPayAmount(2)
                if (pm.isMember()) {
                    $scope.chexiaostyle = LANGUAGECACHE["str_tip_cexiaochuzhixiaofei"];

                } else if (pm.isJiFen()) {
                    $scope.chexiaostyle = LANGUAGECACHE["str_tip_cexiaojifenxiaofei"];
                }
                alert("请使用电脑客户端撤销");
                //tempinput = $('#cardnoinput')[0];
                //InitMember();
                //$("#mcxjfxf").modal("show");
                //$("#mcxjfxf").data('pm', pm);
                //$('#yfinput').val(pm.pmMoney());
                //$('#kahao').focus();
                //$scope.ISFANJIESUAN = false;
                //toBeRemovedPm = pm;
                //TODO,撤销交易后，执行 ：confirmCheXiaoJiaoYi(toBeRemovedPm);
                return;
            }
            $scope.pm = pm;
            $("#delzffs").modal("show");
        }

        $scope.deletePm = function () {
            $("#delzffs").modal("hide");
            if ($scope.pm.name == LANGUAGECACHE["str_tip_weixin"]) {
                window.yunshan.showCancelTransDialog(LANGUAGECACHE["str_tip_weixincexiao"]);
            } else if ($scope.pm.name == LANGUAGECACHE["str_tip_card"]) {
                if (!Utils.isMobile()) {
                    window.yunshan.showCancelTransDialog(LANGUAGECACHE["str_tip_yinhangkacexiao"]);
                }else {
                    jieSuan.removePM($scope.pm);
                }
            } else if($scope.pm.name==LANGUAGECACHE["str_tip_alipay"]){
                window.yunshan.showCancelTransDialog(LANGUAGECACHE["str_tip_zhifubaocexiao"]);
            } else {
                jieSuan.removePM($scope.pm);
            }
        }

        $scope.confirmCheXiaoJiaoYi = function (pm) {
            $.maskLoader("show", LANGUAGECACHE["str_tip_cexiaoing"]);
            var curUser = $rootScope.curUser;
            JieSuanService.removeImmmediatePay(pm, curUser, jieSuan, function (err, model) {
                if (err) {
                    $.maskLoader("hide");
                    return Utils.showFailureInfo(err.message);
                }

                $.maskLoader("hide");
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_revokesuccess"]);
                //$scope.printJieZhangDan(jieSuan);
            });
        }

        //确认的折扣（对话框)
        $scope.confirmZheKou = function (flag) {
            //确定
            if (flag) {
                if (Utils.isEmpty($scope.zheKouCal.zhekou)) {
                    zheKouCal.zhekou = "";
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_discountcantzero"]);
                }

                if (_.isNaN(parseFloat($scope.zheKouCal.zhekou)) || !_.isNumber(parseFloat($scope.zheKouCal.zhekou))) {
                    zheKouCal.zhekou = "";
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_discountmustnumber"]);
                }

                if ($scope.zheKouCal.zhekou <= 0) {
                    zheKouCal.zhekou = "";
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_discountcantlesszero"]);
                }

                //是内置的定额折扣
                if (dlg.zk.isDingE()) {
                    var exist = jieSuan.getZkDingE();
                    //最新的定额折扣 》 已有的定额折扣  + 当前的应收
                    if (parseFloat(zheKouCal.zhekou) > parseFloat(exist) + parseFloat(jieSuan.order.getYingShou())) {
                        zheKouCal.zhekou = "";
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_discountcantmoreyingshoujine"]);
                    }
                }
                //是内置的比例折扣
                if (dlg.zk.isBili()) {
                    // 无约束
                }
                dlg.zk.zheKouAmount = $scope.zheKouCal.zhekou;
                jieSuan.addZheKou(dlg.zk);
                $scope.moneyJieSuan = jieSuan.order.getYingShou();
            }
            $("#zheKouDialog").modal("hide");
            closeZheKou();
        }
        $scope.clearZhenKou = function () {
            zheKouCal.zhekou = "";
            //$("#zkAmount").val("");
        }


        /* 验证折扣的输入  开始*/
        $scope.changeInput = function (value) {
            var result = valiedateInput(value);
            zheKouCal.zhekou = result;
        }
        function valiedateInput(value) {
            var id = "";
            if (dlg.zk.isBili())
                id = "biliZhekou";
            else
                id = "jineZhekou";

            var result = value;
            _.each(BIZCONSTANT.REG_NUMBERS, function (item) {
                if (item.IDS.indexOf(id) >= 0) {
                    if (!item.REG_TEXT.test(value)) {
                        result = value.substring(0, value.length - 1);
                    }
                }
            });
            return result;
        }

        /* 验证折扣的输入 结束*/


        //增加支付方式
        $scope.addPaymentMethod = function (pm) {

            var yings = $scope.jieSuan.order.getYingShou();
            var yis = $scope.jieSuan.yiShou;
            if (pm.name != LANGUAGECACHE["str_tip_money"]) {
                if ((yings - yis) < calculator.money)
                    calculator.money = (yings - yis);
            }

            //TODO, 查看是否是会员卡
            //if (pm.name == '会员卡') {
            //    // 1.显示会员卡界面
            //    // 2. 点击界面上的确定后，生成一个会员对象和结算对象建立关联
            //    // 3。
            //
            //    $('#cardnoinput')[0].focus();
            //    tempinput = $('#cardnoinput')[0];
            //    $("#mhykjs").modal("show");
            //    $('#yfinput').val($scope.jieSuan.calculator.money);
            //    $scope.ISFANJIESUAN = false;
            //    //var m = new Member();
            //    //m.setZheKou(80);
            //    //jieSuan.setMember(m);
            //    return;
            //}
            var money = calculator.money;
            money = Utils.m(money);

            //只能输入正数
            if (!_.isFinite(money))
                return;
            if (money < 0)
                return;
            pm.addMoney(money);
            jieSuan.addPM(pm);
            //todo ceshiyong
            //JieSuanService.jieSuanSnapshot(curUser, jieSuan, function (err, model) {
            //    if (err) {
            //        return Utils.showFailureInfo(err.message);
            //    }
            //});
            closeXianJin();
        }

        //结算
        $scope.save = function () {
            if (!Utils.roleAble(ROLE_POWER.JZ)){
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_donthaveroot"]);
                return;
            }
            var curUser = $rootScope.curUser;

            if (curUser.getNeedKaiBan()) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstkaibanthatjiesuan"]);
                return;
            }

            //查看当前账单的落单时间是否是和班次匹配
            if (!curUser.jieSuanRiAllowed(jieSuan.order.luoDanTime)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_banciwei"]+"【" + curUser.banCiHao + "】"+ LANGUAGECACHE["str_tip_jiebanandjiesuan"]);
                return;
            }
            JieSuanService.seeJiedanTime(jieSuan.order.guid, function (res) {
                if (res.detail[0].jieSuanTime) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_otherhasjiedan"]);
                    return;
                }
                //3. 如果没有任何支付方式， 则禁止提交。
                if (!jieSuan.existPayments()) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_weizhifucantjiesuan"]);
                    return;
                }
                //4.校验支付金额是否满足应付。 已收必须大于等于应收
                var ys = jieSuan.yiShou; //已收
                var expected = jieSuan.order.getYingShou();//应收

                if (_.toNumber(expected) < 0) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_yingshoucantlessone"]);
                    return;
                }
                if (ys == null || expected == null || ys === '' || expected === '') {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_interiorerror"]);
                    return;
                }
                try {
                    ys = _.toNumber(ys);
                    expected = _.toNumber(expected);
                } catch (e) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_interiorerrorbecausenumber"]);
                }
                if (ys < expected) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_payjineless"]);
                    return;
                }

                var xianJin = 0;
                _.each(paymentMethodList, function (pm) {
                    if (pm.isXianJian()) {
                        xianJin = pm.pmMoney();
                    }
                });

                if (xianJin < jieSuan.zhaoLing) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_xianjinbuzu"]);
                    return;
                }

                $.maskLoader("show", LANGUAGECACHE["str_tip_jiesuaning"]);
                jieSuan.saving = true;

                saveIfAvailable(curUser);
                //switchOn();
                //JieSuanService.save(curUser, jieSuan, function (err, model) {
                //    if (err) {
                //        jieSuan.setIgnoreXuShou(true);
                //        jieSuan.reCalAll();
                //        jieSuan.saving = false;
                //        $.maskLoader("hide");
                //        return Utils.showFailureInfo(err.message);
                //    }
                //    $.maskLoader("hide");
                //    $scope.printJieZhangDan(jieSuan);
                //    Utils.showFailureInfo("结算成功.");
                //    jieSuan.setIgnoreXuShou(true);
                //    jieSuan.saving = false;
                //    $scope.gotoZhuotai();
                //
                //});
            });
        }
        function switchOn() {
            jieSuan.setIgnoreXuShou(false);
            jieSuan.reCalAll();
        }

        /**
         * 递归确认下是否可以直接进行保存。
         * 如果有autosnapshot正在运行，则等待期保存结束后，再进行结算
         *
         * @param curUser
         */
        function saveIfAvailable(curUser){
            if(! running){
                doSave(curUser);
            }
            else  {//如果这个时候snapshot正在运行,应该等待运行结束后在做
                $timeout(function(){
                    saveIfAvailable(curUser);
                }, 500)
            }
        }

        function doSave(curUser){
            switchOn()
            $scope.jiesuanwancheng();
            JieSuanService.save(curUser, jieSuan, function (err, model) {
                if (err) {
                    jieSuan.setIgnoreXuShou(true);
                    jieSuan.reCalAll();
                    jieSuan.saving = false;
                    $.maskLoader("hide");
                    return Utils.showFailureInfo(err.message);
                }
                $scope.printJieZhangDan(jieSuan);
                $.maskLoader("hide");


                //国际化录入到此处
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_jiesuansuccess"]);
                ZhuotaiService.openLockZhuoTai($scope.currentZhuotai.guid);
                jieSuan.setIgnoreXuShou(true);
                jieSuan.saving = false;

                //每各5秒通知一次，最多三次
                var orderSource = jieSuan.order.getOrderSource();
                var countObj = {};
                countObj.count = 0;
                if(orderSource && orderSource == ORDERSOURCE.WEIXIN) {
                    var requestObj = {};
                    requestObj.orderNo = jieSuan.order.thirdOrderNo;
                    requestObj.groupCode = BIZCONSTANT.POSUSER.groupCode;
                    requestObj.groupId = BIZCONSTANT.POSUSER.groupId;
                    requestObj.orgId = BIZCONSTANT.POSUSER.mdId;
                    var requestStr = JSON.stringify(requestObj);
                    notifyThirdPlatformAfterJieZhang(requestStr, countObj);
                }
                BUSINESS.CURRENT_ZHUOTAI = null;
                $scope.gotoZhuotai();
            });
        }


        var timer_time = 5000; //5s
        var timer = null;

        var successStr = "success";
        var failureStr = "failure";
        var weixinConfirmUrl = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.WEINXIN_ORDER_CONFIRM_URL;
        //如果订单来源是第三方，结账之后需要通知第三方平台
        function notifyThirdPlatformAfterJieZhang(requestStr, countObj) {
            // weixinConfirmUrl = "http://192.168.3.15:8080/yunshan-weixin-api" + WEIXIN.WEINXIN_ORDER_CONFIRM_URL; //for test
            try{
                callAjax(weixinConfirmUrl, function (response) {
                    if(response.status == successStr) {
                        console.info("jiesuan.js.notifyThirdPlatformAfterJieZhang()通知成功！");
                        return;
                    }else {
                        countObj.count = countObj.count+1;
                        console.info("jiesuan.js.notifyThirdPlatformAfterJieZhang()通知失败！:" + JSON.stringify(response) + ", countObj.count:" + countObj.count);
                        if(countObj.count >= 3) return;
                        notifyThirdPlatformAfterJieZhang(requestStr, countObj);
                        /*if(countObj.count >= 3) {
                         if(timer)
                         clearInterval(timer);
                         }*/
                    }
                }, requestStr, null, function (err, data) {
                    countObj.count = countObj.count+1;
                    console.info("jiesuan.js.notifyThirdPlatformAfterJieZhang()通知失败！:" + err + ", countObj.count:" + countObj.count);
                    if(countObj.count >= 3) return;
                    notifyThirdPlatformAfterJieZhang(requestStr, countObj);
                    /*if(countObj.count >= 3) {
                     if(timer)
                     clearInterval(timer);
                     }*/
                })
            }catch (e) {
                console.info("jiesuan.js.notifyThirdPlatformAfterJieZhang()抛出异常！:" + e);
            }
        }

        /* 
         *打印结账单 zyy
         */
        $scope.printJieZhangDan = function () {

            printhelp.printJieZhangDan(jieSuan, $scope.luodanOrderCaipins, $rootScope.currentZhuotai.name,jieSuan.asDuiZhangDanView(),false, function(){
            })
        }


        /*
         *打印对账 zyy
         */
        $scope.printDuiZhangDan = function () {
            if (!Utils.roleAble(ROLE_POWER.DZD)){
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_donthaveroot"]);
                return;
            }
            $.maskLoader("show", LANGUAGECACHE["str_tip_dzdprint"]);
            switchOn();
            printhelp.printNewDuiZhangDan(jieSuan, $scope.luodanOrderCaipins,  function (e) {
                $.maskLoader("hide");
                jieSuan.setIgnoreXuShou(true);
                jieSuan.reCalAll();
                DiancaiService.orderYuJie($scope.jieSuan.order.guid, function (err) {
                    if (err != null)
                        return;
                });
            });
        }


        //结算界面用于数据金钱的计算器
        $scope.compute = function (v) {
            if (_.isNumber(v)) {
                var n = _.toNumber(v);

                var yings = $scope.jieSuan.order.getYingShou();
                var yis = $scope.jieSuan.yiShou;
                if ((yings - yis) == calculator.money)
                    return calculator.money = n;

                if (n >= 0 && n <= 9)
                    calculator.money = calculator.money + "" + n;
                if (20 == n || 50 == n || 100 == n)
                    calculator.money = Utils.m(calculator.money) + n;

            }
            if (!_.isNumber(v)) {
                if ("." == v)
                    calculator.money = calculator.money + "" + v;

                else if ("00" == v)
                    calculator.money = calculator.money + "" + v;
                //清除
                else if ("C" == v)
                    calculator.money = "";

                else if ("D" == v) {
                    var ar = _.toArray(calculator.money + "");


                    ar = _.slice(ar, 0, ar.length - 1);
                    calculator.money = _.join(ar, '');
                }
            }
            validateMoney();
        }

        /*2016-03-22 JP
         验证结算录入金额是否合法
         */
        $scope.validateInputMoney = function () {
            validateMoney();
        }

        function validateMoney() {
            if(!!calculator.money){
                if (isNaN(calculator.money))
                    return calculator.money = 0;
                if (!BIZCONSTANT.REG_NUMBER_TEXT.test(calculator.money)) {
                    calculator.money = calculator.money.substring(0, calculator.money.length - 1);
                }
            }

        }


        //结算界面的用于输入折扣的界面
        $scope.computeZheKou = function (v) {
            /*2016-03-06 
             JP
             新的折扣验证方式*/
            if ("D" == v) {
                var ar = _.toArray(zheKouCal.zhekou + "");
                ar = _.slice(ar, 0, ar.length - 1);
                zheKouCal.zhekou = _.join(ar, '');
            } else {
                zheKouCal.zhekou = valiedateInput(zheKouCal.zhekou + "" + v);
            }
        }


        /**
         * 折扣信息
         */
        function loadAllZheKouInfo() {
            JieSuanService.getAllZheKou(function (err, model) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                zheKouList = model;
                $scope.zheKouList = model;
            });
        }

        /**
         * 支付方式
         */
        function loadAllPayMethod() {

            paymentMethodList = BIZCONSTANT.ALLPMs;

            /* JP 2016-04-22
             * 重新构造了 支付方式的数据源 为了前端的显示用
             */
            $scope.pmList = [];
            paymentMethodList.sort(function (a, b) {
                return a.code - b.code;
            });

            $scope.pmList = paymentMethodList;

            _.each(paymentMethodList, function (e) {
                e.reset();
            });
        }


        function getPMbyCode(code) {
            for (var idx in paymentMethodList) {
                if (paymentMethodList[idx].code == code)
                    return paymentMethodList[idx];
            }
            return null;
        }

        function getZKbyCode(code) {
            //console.log(code);
            for (var idx in zheKouList) {
                //console.log(zheKouList[idx]);
                if (zheKouList[idx].zheKouCode == code)
                    return zheKouList[idx];
            }
            return null;
        }

        $scope.gotoZhuotai = function () {
            ZhuotaiService.openLockZhuoTai($scope.currentZhuotai.guid);
            $location.url("/zhuotaijiesuan");
        }

        $scope.gotoDiancai = function () {
            var curUser = $rootScope.curUser;
            JieSuanService.jieSuanSnapshot(curUser, jieSuan, function (err, model) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $location.url("/diancai");
            });
        }

        $scope.saverHandler = null;
        var running = false;
        //如果结算对象的模型发生变化，那么自动保存
        $scope.$watch('jieSuan.stateChangeVer', function (newValue, oldValue) {

            //如果正在进行结算，则不触发自动保存
            if(jieSuan.saving || jieSuan.saved){
                clearTimeout( $scope.saverHandler);
                return;
            }

            //
            if ($scope.saverHandler == null) {
                running = true;
                $scope.saverHandler = window.setTimeout(autoSnapShot, 500);
                return;
            }

            //如果正在保存
            if (running) {
                $scope.saverHandler = window.setTimeout(autoSnapShot, 1000);
                return;
            }

            clearTimeout($scope.saverHandler);
            running = true;
            $scope.saverHandler = window.setTimeout(autoSnapShot, 500);


        });

        var autoSnapShot = function () {
            var curUser = $rootScope.curUser;
            running = true;
            console.log("auto saving....")
            jieSuan.setIgnoreXuShou(false);
            JieSuanService.jieSuanSnapshot(curUser, jieSuan, function (err, model) {
                running = false;
                if (err) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_zidongbaocun"] + err.message);
                }
                jieSuan.setIgnoreXuShou(true);
                console.log("auto saving...done.")
            });
        }


        $scope.openQX = function () {
            if (!Utils.roleAble(ROLE_POWER.DKQX)){
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_donthaveroot"]);
                return;
            }
            printhelp.openQianXiang();
        }


        /**
         * 显示 “优惠折扣”
         */

        $scope.displayYouHuiZheKou = function () {
            $("#myhzk").modal("show");
        }
        /**
         * 确认 “优惠折扣”
         */
        $scope.confirmYouHuiZheKou = function () {
            jieSuan.getMember().setCandidateZheKouRule(BIZCONSTANT.HY_ZK_RULE_LV);
            $('#yfinput').val($scope.jieSuan.calculator.money - $scope.member.mZheKouLv);
            $("#myhzk").modal("hide");
        }
        /**
         * 确认会员价
         */
        $scope.confirmHuiYuanJia = function () {
            jieSuan.getMember().setCandidateZheKouRule(BIZCONSTANT.HY_ZK_RULE_PRICE);
            $('#yfinput').val($scope.jieSuan.calculator.money - $scope.member.mHuiYuanJia);
            $("#mhyj").modal("hide");
        }

        $scope.inputfocus = function (event) {
            tempinput = event.currentTarget;
        }

        $scope.removeMember = function () {
            $("#mhyj").modal("hide");
            $("#myhzk").modal("hide");
        }

        //会员DLG取消事件
        $scope.cancelHy = function () {
            //会员对象存在，则revert。  如果会员对象存在，那么getCardNo()一定不为空。
            if ($scope.member.getCardNo() != null) {
                $scope.member.revertZheKouRule();
            }
        }
        //会员卡消费提交
        $scope.submitCardPay = function () {
            hyksave();
        }

        //会员卡消费验证保存
        function hyksave() {
            var ysmoney = Utils.m($scope.huiyuanCardWeiFuMoney);
            var money = Utils.m($scope.huiyuanCardPayMoney);
            var jfxfMoney = 0; //积分消费的钱
            money = Utils.m(money);

            //只能输入正数
            if (!_.isFinite(money) || money < 0)
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputrightjine"]);

            if (!$scope.ISFANJIESUAN) {
                if (money > ysmoney)
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_otherpaycanthuiyuan"]);
                //return Utils.showFailureInfo('卡余额不足');

                if (money > $scope.member.getYe())
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_kayueless"]);

                $scope.member.confirmZheKouRule();
                jieSuan.getMember().setPayAmount(money); //储值消费
                jieSuan.getMember().setJfPayAmount(jfxfMoney); //积分消费
                //只要使用了“即时扣款”类支付方式，比如（会员卡），那么需要“即时”执行动作
                if (money > 0 || jfxfMoney > 0) {
                    var curUser = $rootScope.curUser;
                    $.maskLoader("show", LANGUAGECACHE["str_tip_huiyuanjiaohuing"]);
                    JieSuanService.payImmmediate(curUser, jieSuan, function (err, model) {
                        if (err) {
                            $.maskLoader("hide");
                            return Utils.showFailureInfo(err.message);
                        }

                        $.maskLoader("hide");
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_koukuansuccess"]);
                        $scope.jiesuanstep = 0;
                    });
                }
            } else { //反结算
                if (money > ysmoney)
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_backjinecantmorehuiyuanzhifujine"]);
                jieSuan.setMember($scope.member);
                jieSuan.getMember().setPayAmount(money);
            }
        }

        $scope.gotoBack = function () {
            //$location.url("/zhuotaijiesuan");
            if ($rootScope.source != LANGUAGECACHE["str_tip_diancai"]) {
                if ($rootScope.currentZhuotai != null) {
                    ZhuotaiService.openLockZhuoTai($rootScope.currentZhuotai.guid);
                }
            }
            curUser = $rootScope.curUser;
            JieSuanService.jieSuanSnapshot(curUser, jieSuan, function (err, model) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                window.history.back(1);
            });
        }

        $scope.gotoXianJin = function () {
            $scope.jiesuanstep = 1;
        }

        $scope.backJieSuan = function () {
            //$scope.jiesuanstep = 0;
            $scope.jiesuanstep=1;
        }

        $scope.backZheKou = function () {
            $scope.jiesuanstep = 0;
        }

        $scope.backToCard = function () {
            $scope.jiesuanstep = 3;
            $scope.cancelHy();
        }

        $scope.showXianJin = function () {
            $scope.jiesuanstep = 1;
        }

        function closeZheKou() {
            $scope.jiesuanstep = 0;
        }

        function closeXianJin() {
            //$scope.jiesuanstep = 0;
            $scope.jiesuanstep=1;
        }

        function openXianJin() {
            //$scope.jiesuanstep = 1;
              $scope.jiesuanstep = 5;
        }

        $scope.clickDianCai = function () {
            curUser = $rootScope.curUser;
            JieSuanService.jieSuanSnapshot(curUser, jieSuan, function (err, model) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $location.url("/diancaipos");
            });
        }

        $scope.clickXianJinSure = function () {
            if ($('#input_money').val() == '') {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_jinecantzero"]);
                return;
            }
            var tempmoney = Utils.m($('#input_money').val());
            var yings = $scope.jieSuan.order.getYingShou();
            var yis = $scope.jieSuan.yiShou;
            if ($scope.pm.name != LANGUAGECACHE["str_tip_money"] && $scope.pm.name != LANGUAGECACHE["str_tip_huiyuanka"]) {
                if((Utils.m(yings-yis))<tempmoney){
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputjinelessweishoujine"]);
                    return;
                }
            }

            if ($scope.pm.name == LANGUAGECACHE["str_tip_card"]) {
                if ($('#input_money').val() == '' || $('#input_money').val() == 0) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_jinecantzero"]);
                    return;
                }
                 var tempmoney = $('#input_money').val();
                     if(!Utils.isMobile()) {
                         window.yunshan.transBankCard(Utils.m(parseFloat(tempmoney)), jieSuan.order.guid);
                     }else{
                         $scope.addPaymentMethod($scope.pm);
                     }
            } else if ($scope.pm.name == LANGUAGECACHE["str_tip_weixin"]) {
                if ($('#input_money').val() == '' || $('#input_money').val() == 0) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_jinecantzero"]);
                    return;
                }
                tempmoney = $('#input_money').val();
                window.yunshan.transWeiXin(Utils.m(parseFloat(tempmoney)));
            } else if ($scope.pm.name == LANGUAGECACHE["str_tip_alipay"]) {
                if ($('#input_money').val() == '' || $('#input_money').val() == 0) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_jinecantzero"]);
                    return;
                }
                tempmoney = $('#input_money').val();
                window.yunshan.transAliPay(Utils.m(parseFloat(tempmoney)));
            } else {
                $scope.addPaymentMethod($scope.pm);
            }
        }

        // 删除会员卡支付钱数
        $scope.clearHyCardMoeny = function () {
            $scope.huiyuanCardPayMoney = "";
        }

        $scope.readCardNext = function () {
            $scope.readCard();
        }

        /**
         * 撤销交易后删除支付方式
         */
        $scope.cancelTransCallBack = function () {
            jieSuan.removePM($scope.pm);
            $scope.$apply();
        }
        /**
         * 第三方支付成功后添加支付方式
         */
        $scope.jsCallBack = function () {
            $scope.addPaymentMethod($scope.pm);
            $scope.$apply();
        }

        $scope.clickPayMethod = function (pm) {
            var yings = $scope.jieSuan.order.getYingShou();
            var yis = $scope.jieSuan.yiShou;
            $scope.pm = pm;
            //调试暂时用名字，后期都要判断code
            switch (pm.name) {
                case LANGUAGECACHE["str_tip_money"]:
                    openXianJin();
                    break;
                //测试用
                case LANGUAGECACHE["str_tip_company"] :
                    openXianJin();
                    break;

                case LANGUAGECACHE["str_tip_card"]:
                    if (window.yunshan.isMobilePhone()) {
                        window.yunshan.showTipDialog(LANGUAGECACHE["str_tip_payment_unavailable_on_cellphone"])
                        return;
                    }

                    if (jieSuan.hasAlreadyPaid(LANGUAGECACHE["str_tip_card"])) {
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_rejiesuanbeforeyinhangka"])
                        return;
                    }
                    openXianJin();
                    break;

                case LANGUAGECACHE["str_tip_weixin"]:
                    if (window.yunshan.isMobilePhone()) {
                        window.yunshan.showTipDialog(LANGUAGECACHE["str_tip_payment_unavailable_on_cellphone"])
                        return;
                    }

                    if (jieSuan.hasAlreadyPaid(LANGUAGECACHE["str_tip_weixin"])) {
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_rejiesuanbeforweixinpay"])
                    }
                    openXianJin();
                    break;

                case LANGUAGECACHE["str_tip_alipay"]:
                    if (window.yunshan.isMobilePhone()) {
                        window.yunshan.showTipDialog(LANGUAGECACHE["str_tip_payment_unavailable_on_cellphone"])
                        return;
                    }

                    if(jieSuan.hasAlreadyPaid(LANGUAGECACHE["str_tip_alipay"])){
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_rejiesuanbeforalipay"])
                    }
                    openXianJin();
                    break;
                case LANGUAGECACHE["str_tip_huiyuanka"]:
                    if (window.yunshan.isMobilePhone()) {
                        window.yunshan.showTipDialog(LANGUAGECACHE["str_tip_payment_unavailable_on_cellphone"])
                        return;
                    }

                    //Utils.showFailureInfo("请先刷会员卡");
                    if (jieSuan.hasMemberPaid()) {
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_rejiesuanbeforhuiyuanka"])
                        return;
                    }
                    InitMember();
                    $scope.jiesuanstep = 3;
                    break;

                default:
                    openXianJin();
                    break;
            }
            //switch (pm.code) {
            //    //现金
            //    case "01":
            //        $scope.showXianJin = true;
            //        break;
            //    //银行卡
            //    case "02":
            //        window.yunshan.transBankCard(yings-yis);
            //        break;
            //    //会员卡
            //    case "03":

            //        break;

            //    default:
            //        break;
            //}
        }

        $scope.readCard = function () {
            if (!Utils.isEmpty($scope.huiyuanCardNo)) {
                duka($scope.huiyuanCardNo);
            } else {
                //调用读卡器或者系统读卡，代替键盘输入
                CardService.ReadCard(function (result) {
                    debugger;
                    if (result.error != '')
                        return Utils.showFailureInfo(result.error);

                    if (result.card_no == '')
                        return Utils.showFailureInfo(LANGUAGECACHE['str_tip_qingxianfaka']);
                    duka(result.card_no);
                }, function (error) {
                    Utils.showFailureInfo(error);
                });
            }
        }

        /**
         * 会员卡
         */

        $scope.clickIcCard = function () {
            $scope.clickCardType = 0;
        }

        $scope.clickM1Card = function () {
            $scope.clickCardType = 1;
        }

        $scope.showSelectCardType = function (cardType) {
            return $scope.clickCardType == cardType;
        }

        function duka(cardno) {
            if (!cardno || cardno == '')
                return Utils.showFailureInfo(LANGUAGECACHE['str_tip_inputkahao']);
            if ($scope.ISFANJIESUAN) {
                var pm = $("#mhykjs").data('pm');
                if (pm.getMemberNo() != cardno)
                    return Utils.showFailureInfo(LANGUAGECACHE['str_tip_backhuiyuanka']+'【' + cardno + '】'+LANGUAGECACHE['str_tip_andzhifuhuiyuanka']+'【' + pm.getMemberNo() + '】'+ LANGUAGECACHE['str_tip_doublecardhasdifferenc']);
            }
            Utils.showLoading();
            CardService.GetCardInfo(cardno, function (result) {
                Utils.hideLoading();
                if (result.status == 'failed') {
                    $scope.member = new Member();
                    return Utils.showFailureInfo(result.errorDetails[0].desc);
                }
                var card = result.data;
                if (!card) {
                    $scope.member = new Member();
                    return Utils.showFailureInfo(LANGUAGECACHE['str_tip_weichaxundaocika']);
                }
                if (card.cardStatus != 1) {
                    $scope.member = new Member();
                    switch (card.cardStatus) {
                        case 2:
                            return Utils.showFailureInfo(LANGUAGECACHE['str_tip_cardlost']);
                        case 3:
                            return Utils.showFailureInfo(LANGUAGECACHE['str_tip_carddongjie']);
                        case 4:
                            return Utils.showFailureInfo(LANGUAGECACHE['str_tip_cardzuofei']);
                    }
                }
                $scope.jiesuanstep = 4;
                populateMember(card);
            }, function () {
                $scope.member = new Member();
                Utils.showFailureInfo(LANGUAGECACHE['str_tip_dukashibai']);
            });
        }

        function getMopoints(res) {
            var arr = res.crmCardLevelInfo.crmLevelRuleInfos;
            var ret = 0;
            for (var i in arr) {
                if (arr[i].ruleSubType == 61 && arr[i].ruleType == 6) {
                    ret = arr[i].ruleResultValue
                }
            }
            return ret;
        }

        function populateMember(card) {
            $scope.member.setCardNo(card.cardCode);
            $scope.member.setName(card.crmMemberInfo.hyName);
            $scope.member.setCZ(parseFloat(card.crmCardAccountInfo.prepaidBalance));
            $scope.member.setZS(parseFloat(card.crmCardAccountInfo.presentBalance));
            $scope.member._ye = card.crmCardAccountInfo.totalAmount;
            $scope.member._integral = card.crmCardAccountInfo.points;//积分
            $scope.member._mopoints = getMopoints(card) * $scope.member._integral;
            $scope.member.setPhone(card.crmMemberInfo.hyMobile);
            $scope.member.setBirth(Utils.formatDate(card.crmMemberInfo.hyBirthday, 'yyyy-MM-dd'));
            $scope.member.setAddress(card.crmMemberInfo.hyAddress);
            $scope.member.setRemark(card.crmMemberInfo.hyDesc);
            $scope.member.carStyle = card.crmCardTypeInfo.cardTypeName;
            $scope.member.setCardLevelIsPrice(card.crmCardLevelInfo.cardLevelIsPrice);
            $rootScope.currentOrder.khmc = $scope.member.getName();
            dukabur = $scope.member;
            if ($scope.ISFANJIESUAN) {
                //jieSuan.setMember($scope.member);
                $scope.member.isFanZhi = true
                $('#xfinput')[0].focus();
                return;
            }
            $scope.member.crmLevelRuleInfos = card.crmCardLevelInfo.crmLevelRuleInfos;
            var rerules = [];
            var czrules = [];
            if ($scope.member.crmLevelRuleInfos && $scope.member.crmLevelRuleInfos.length > 0) {
                var tmp = null;
                for (var i in $scope.member.crmLevelRuleInfos) {
                    tmp = $scope.member.crmLevelRuleInfos[i];
                    if (tmp.ruleType == 1)
                        rerules.push(tmp);
                    if (tmp.ruleType == 4)
                        czrules.push(tmp);
                    //消费积分奖励：大类为 2， 子类为22
                    if (tmp.ruleType == 2 && tmp.ruleSubType == 22) {
                        $scope.member.ruleType = 2;
                        $scope.member.ruleSubType = 22;
                        $scope.member.ruleConditionValue = tmp.ruleConditionValue;
                        $scope.member.ruleResultValue = tmp.ruleResultValue;
                    }
                }
            }
            //折扣规则
            if (rerules.length > 0) {
                $scope.member.setZheKou(rerules[0].ruleResultValue);
                $scope.member.setZheKouName(rerules[0].ruleDesc);
            } else {
                $scope.member.setZheKou(100);
                $scope.member.setZheKouName(LANGUAGECACHE['str_tip_nodiscount']);
            }
            //储值结算规则
            if (czrules.length > 0) {
                $scope.member.setRule(czrules[0].ruleResultValue);
            }
            jieSuan.setMember($scope.member);
            $scope.huiyuanCardPayMoney = Utils.m($scope.jieSuan.calculator.money - $scope.member.mZheKouLv);
            $scope.huiyuanCardWeiFuMoney = Utils.m($scope.jieSuan.calculator.money - $scope.member.mZheKouLv);
            //会员卡折扣
            jieSuan.getMember().setCandidateZheKouRule(BIZCONSTANT.HY_ZK_RULE_LV);
        }

        //初始化会员卡号信息
        function InitMember() {
            $scope.member = new Member();
            dukabur = null;
            $scope.kahao = null;
            $scope.pingjuHao = null;
            $scope.jiaoyiStyle = null;
            $scope.jiaoyiEr = null;
            $scope.jiaoyiTime = null;
            $scope.chaozuoRen = null;
        }

        /*------------- -----------------*/
        //银商新界面增加的方法

        $scope.clicksk = function(){
            $scope.jiesuanstep = 1;
            $("#wancheng").attr("src","css/images/icon-step3.png");
            $("#shoukuan").attr("src","css/images/icon-step2-active.png");
            $("#jinerqueren").attr("src","css/images/icon-step1.png");
        }

        $scope.jiesuanwancheng = function(){
            $scope.jiesuanstep =2;
            $("#wancheng").attr("src","css/images/icon-step3-active.png");
            $("#shoukuan").attr("src","css/images/icon-step2.png");
            $("#jinerqueren").attr("src","css/images/icon-step1.png");
        }

        $scope.jinerqueren = function(){
            $scope.jiesuanstep = 0;
            $("#jinerqueren").attr("src","css/images/icon-step1-active.png");
            $("#wancheng").attr("src","css/images/icon-step3.png");
            $("#shoukuan").attr("src","css/images/icon-step2.png");
        }

        $scope.clickZheKouYinShang = function(){
            $scope.jiesuanstep = 4;
        }

        $scope.clickZheKou = function () {
            $scope.jiesuanstep = 2;
        }

        $scope.hidejiesuanContainerView = function(){
            if($scope.jiesuanstep==4||$scope.jiesuanstep==5){
                return true;
            }
        }

        $scope.filterPm = function(){
            $scope.filterZFFSpagination = new pagination({rows:[],size:20});
            for(Pm in ZFFSpagination.items){
                if(!Pm.iszk||Pm.name==LANGUAGECACHE['str_item_moling']){
                    $scope.filterZFFSpagination.push(Pm);
                }
            }
        }

        $scope.setPmsrc = function(pm){
            var resultsrc = "";
            if (pm.name == '现金') {
                resultsrc = "css/images/icon-xianjin.png"
            } else if(pm.name == '银行卡') {
                resultsrc = "css/images/icon-bank.png"
            } else if(pm.name == '支付宝') {
                resultsrc= "css/images/icon-zfb.png"
            } else if(pm.name == '微信') {
                resultsrc = "css/images/icon-wx.png"
            } else {
                resultsrc = "css/images/icon-xianjin.png"
            }
            $("#"+pm.code).attr("src",resultsrc);
        }

        $scope.getPmNameI18n = function (name){
                    if (name == '现金') {
                        return LANGUAGECACHE['str_item_content_money'];
                    } else if(name == '银行卡') {
                        return LANGUAGECACHE['str_item_content_card'];
                    } else if(name == '支付宝') {
                        return LANGUAGECACHE['str_item_content_alipay']
                    } else if(name == '微信') {
                        return LANGUAGECACHE['str_item_content_weichatpay'];
                    } else if (name == '外卖支付') {
                        return LANGUAGECACHE['str_item_content_waimai'];
                    } else if (name == '优惠券') {
                        return LANGUAGECACHE['str_item_content_youhuiquan'];
                    } else {
                        return name;
                    }
                }
         $scope.loadZheKouInfoI180n = function (name) {
                     if(name == '定额折扣') {
                         return LANGUAGECACHE['str_tip_dingezhekou'];
                     }else if(name == '比例折扣') {
                         return LANGUAGECACHE['str_label_bilizhekou'];
                     }else {
                         return name;
                     }

                 }
        $scope.getYouMianMoney = function(){

        }

        $scope.showTest = function(pm){
            if(pm.iszk||pm.name==LANGUAGECACHE['str_item_moling']){
                return false;
            }else {
                return true;
            }
        }

        $scope.showYiShouText = function(){
            if($("#yfje").length==0){
                return true;
            }else{
                return false;
            }
        }

    }]);