function EventHookFactory(){
	
	this.cache = {};
	
	this.register = function(deviceClass){
		if(deviceClass != null){
			if(this.cache[deviceClass.getEnv()] == null){
				this.cache[deviceClass.getEnv()] = {};
			}
			this.cache[deviceClass.getEnv()] = deviceClass;
		}
	};
	
	this.get = function(){
		return this.cache[CONTEXT.env];
	};
	
};

function EventHook(){
	this.beforeLogin = function(){};
	this.afterLogin = function(userinfo){};
	this.beforeLogout = function(userinfo){};
	this.afterLogout = function(){};
	// TODO: ¼ӿ	
};

window.EventHooks = new EventHookFactory();