/**
 * Created by peter.shang on 2016-03-10.
 *
 * 餐别组， 会对应多个餐别
 */

function CanBieGroup() {

    //one-to-many<CanbieInfo>
 
    this.listCanBie = [];
}

CanBieGroup.prototype = {
    /**
     * 根据时间来获得所属餐别
     * @param t
     */
    getCanBieByTime: function (t) {
        return Utils.getCanbieByTime(this.listCanBie, t);
    },
    /**
     * 根据时间得到所属餐别日的时间范围
     */
    getCanBieTimeRange: function (t) {
        var curCanbie= Utils.getCanbieByTime(this.listCanBie, t);

       var tempCanbie= this.listCanBie.sort(function (a, b) {
            return a.code - b.code;
        });
        //获取日期
        var date=new Date(curCanbie.formatStarttime).format("yyyy-MM-dd");

        var startTime = date + " " + this.listCanBie[0].formatStarttime;

       var endTime = new Date(startTime).AddTime(0,0,1,0,0,-1).format("yyyy-MM-dd hh:mm:ss");
        
       return {startTime:startTime,endTime:endTime};
    },
    /**
     * 是否是多餐别
     */
    isDuoCanBie: function () {
        if (listCanBie.length > 1)
            return true;

        return false;
    },
    setCanbieList: function (canbieGroups) {
        this.listCanBie = canbieGroups;
    },
    getCanbieList: function () {
        return this.listCanBie;
    }
}


