/**
 * Created by peter.shang on 2016-02-25.
 */



function Member() {
    var _self = this;
    //基本信息
    var _guid; //会员ID
    var _name;
    var _phone;
    var _dob; //生日
    var _address;//地址
    var _remark;

    //卡信息
    var _mChongZhi = 0;//现金余额
    var _mZengSong = 0; //赠送余额
    var _cardNum;//卡号
    var _jiFen; //积分
    var _zheKou = 100; //折扣,会员折扣

    var _zheKouRule = null;//折扣规则， 默认无任何折扣。，可以使用会员折扣率 以及 会员价 两种
    this.mZheKouLv = 0; //应用会员折扣率后的 折扣金额
    this.mHuiYuanJia = 0;//应用会员价后的    折扣金额
    var _orignalBlZk = null;

    //上一步会员的优惠状态，主要用于回滚
    var _zheKouRulePrev = null;
    var _zheKouRuleCandidate= null;//备用的折扣


    var _zhekouname = '';

    var _rule = BIZCONSTANT.MEMBER_RULE_BILI; //储值结算规则, 默认为是按比例
    var _jieSuan; //结算

    var _payAmount = 0.00; //本次支付金额
    var _jfPayAmount = 0.00; //本次积分所消费的金额
    this._hytype = '0';//会员类型
    this._sex = "0";
    this._email = "";;
    this._zipcode = "";;
    this._company = "";
    this._certifitype = '';
    this._certificode = "";
    this._zhiwu = "";
    this._pwd = null;
    this._haspwd = false;
    this._ye = 0;

    this._kafei = 0;//卡费
    this._kf_fkfs = "";//卡费付款方式

    this.isFanZhi = false; //是否是用于反值的MEMBER.反结算的时候使用。


    var _isDeleted;//是否删除
    this.tradeNumber = null;//服务器端保存的成功结账后，所生成的凭据号
    this.tradeGuid = null;//服务器端保存的交易GUID

    var _cardLevelIsPrice = false; //是否允许使用会员价


    var _huiYuanKa = null;
    var _jfxf = null;
    var _yzxf = null;

    //#交易类型：   储值消费、赠送消费、现金消费,积分消费，会员发卡、储值充值、
    var _trans = [
        new MemberTrans(BIZCONSTANT.MEMBER_TRANS_CHUNZHI), //储值消费
        new MemberTrans(BIZCONSTANT.MEMBER_TRANS_PRESENT), //赠送消费
        new MemberTrans(BIZCONSTANT.MEMBER_TRANS_CASH), //现金消费
        new MemberTrans(BIZCONSTANT.MEMBER_TRANS_JIFEN) //积分消费
    ];


    //积分兑换的相关设置
    this.ruleType = null;
    this.ruleSubType = null;
    this.ruleConditionValue = null;
    this.ruleResultValue = null;

    _.each(_trans, function (e) {
        e.setParent(_self);
    })


    this.fakeZheKouRule = function(o){
        _zheKouRule = o;
    }
    //设置会员使用的折扣， 会员价 或者 折扣率
    this.setZheKouRule = function(o){
        //保存上一次状态快照
        snapShot();
        _zheKouRule = o;

        var azk = asZheKou();
        _jieSuan.addZheKou(azk);
        _jieSuan.order.markMaxWeight();
    }

    this.clearZheKouRule = function(){
        //删除原来的折扣
        _zheKouRule = null;
        _zheKouRulePrev = null;
        _zheKouRuleCandidate = null;
    }


    this.setCandidateZheKouRule = function(o){
        _zheKouRuleCandidate = o;
    }
    this.confirmZheKouRule = function(){

        if(_zheKouRuleCandidate == null && _orignalBlZk != null) {
            _jieSuan.addZheKou(_orignalBlZk);
            _jieSuan.order.markMaxWeight();
            return;
        }

        if(_zheKouRuleCandidate == null )
            return;

        _self.setZheKouRule(_zheKouRuleCandidate);
        _zheKouRuleCandidate = null;
    }
    this.revertZheKouRule = function(){
        _zheKouRuleCandidate = null;
        _self.setZheKouRule(_zheKouRulePrev);
    }




    function snapShot(){
        _zheKouRulePrev = _zheKouRule;
       //删除原来的折扣
       var  azk = asZheKou();
        _jieSuan.removeZheKou(azk);

    }


    this.getName = function ()
    {
        if(_name == undefined || _name == "undefined") _name = null;
        return _name;
    }

    this.getPhone = function ()
    {
        return _phone;
    }

    this.setPhone = function (v)
    {
        _phone = v;
    }

    this.getBirth = function ()
    {
        return _dob;
    }

    this.setBirth = function (v)
    {
        _dob = v;
    }

    this.getAddress = function () {
        return _address;
    }

    this.setAddress = function (v) {
        _address = v;
    }

    this.getRemark = function () {
        return _remark;
    }

    this.setRemark = function (v) {
        _remark = v;
    }

    this.getZheKouName = function () {
        return _zhekouname;
    }

    this.setZheKouName = function (v) {
        _zhekouname = v;
    }

    this.getSex = function () {
        return _sex;
    }

    this.getEmail = function () {
        return _email;
    }

    this.getZipCode = function () {
        return _zipcode;
    }

    this.getHyType = function () {
        return _hytype;
    }

    this.getCompany = function () {
        return _company;
    }

    this.getCZ = function () {
        return _mChongZhi;
    }

    this.getZS = function () {
        return _mZengSong;
    }

    this.setCZ = function (cz) {
        if(isNaN(cz)) {
            cz = 0;
        }
        _mChongZhi = cz;
    }

    this.getYe = function ()
    {
        return _mChongZhi + _mZengSong;
    }

    this.setZS = function (zs) {
        if(isNaN(zs)) {
            zs = 0;
        }
        _mZengSong = zs;
    }

    this.getTrans = function () {
        return _trans;
    }


    //得到计算后储值账户金额
    this.calCZ = function () {
        var balance =  _self.getJieSuan().getMoneyPaidByMember();

        //.2.会员储值金额
        var cz = _self.getCZ();
        // 3.会员赠送金额
        var zs = _self.getZS();

        return Utils.m(_self.getCZ() - _self.getPolicy().chongZhi(balance, cz, zs));
    }

    //得到计算后的赠送账户金额
    this.calZS = function () {
        var balance =   _self.getJieSuan().getMoneyPaidByMember();

        //.2.会员储值金额
        var cz = _self.getCZ();
        // 3.会员赠送金额
        var zs = _self.getZS();
        return Utils.m(_self.getZS() - _self.getPolicy().zengSong(balance, cz, zs));
    }

    this.getPayAmount = function () { return _payAmount };
    this.setPayAmount = function (o) {
        if(o <= 0)
            return;
            _payAmount = o;
            _huiYuanKa= PaymentMethod.HYK();
            _huiYuanKa.addMoney(_payAmount);
            _jieSuan.addPM(_huiYuanKa);


    };

    this.setJfPayAmount = function(o){
        if(o<=0)
        return;
        _jfPayAmount = o;
        //创建一个虚拟积分兑换支付方式
        _jfxf = this.asPayment4JFXF();
        _jieSuan.addPM(_jfxf);
    }
    this.getJfPayAmount = function(){
        return _jfPayAmount;
    }

    /**
     * 是否用使用卡里的钱进行支付？
     *
     * @returns {boolean}
     */
    this.usingCreditsInCard = function(){
        if(_jfPayAmount > 0 || _payAmount > 0 )
            return true;

        return false;

    }

    /**
     * 当会员和结算建立关联的时候，
     * 一个是 会员折扣对象
     *
     * @param jieSuan
     */
    this.setJieSuan = function (jieSuan) {
        _jieSuan = jieSuan;
        var preMem = _jieSuan.getPreviousMember();
        var preZhekou =   preMem != null ? preMem.getZheKouRule() : null;
        var original = null;
        /*
         * 当二者关联之后，其会员价优惠，和 折扣优惠金额等应该已经是确定的。
         */

        var hyPrice = null;
        var hyZk = null;
        //1.会员价优惠金额
        if(_self.getCardLevelIsPrice()){ //如果当前等级允许使用会员价
            /**
             * 显示地设置会员价， 以便计算出该会员价的【优惠的金额】
             */
            _zheKouRule = BIZCONSTANT.HY_ZK_RULE_PRICE;
            _self.mHuiYuanJia = _self.getJieSuan().order.getSumOfHuiYuanJiaZheKou();
            hyPrice = asZheKou();
            _jieSuan.removeZheKou(hyPrice);//复位

        } else{
            _self.mHuiYuanJia = 0;
        }
  /**
         * 显示地设置会员折扣率， 以便计算出该折折扣率所的【优惠的金额】
         */
        _zheKouRule = BIZCONSTANT.HY_ZK_RULE_LV;
         hyZk = asZheKou();
        if(hyZk != null) {
            
             original =  _jieSuan.getZkOfBiLi();
            _jieSuan.addZheKou(hyZk); //用于计算值
            _self.mZheKouLv = hyZk.money4Display();
            _jieSuan.removeZheKou(hyZk);//复位
            
            //比例折扣（并非会员的比率），则复位
            if( original !== null && !original.isHuiYuanLV()){
                _jieSuan.addZheKou(original);
            }


        }

        //解决#5012 【前台】点击全单打折，读取会员卡，全单打折不见了
        if(preZhekou == null && original != null && !original.isHuiYuanLV()){
            _orignalBlZk = original;
        }else{
            _orignalBlZk = null;
        }

        //如果上一张会员卡使用的是会员价，则仍然使用会员价
        //若干上一张会员卡使用的是折扣，则仍然使用折扣
        if(preMem != null &&  preMem.getCardNo() == _self.getCardNo() ){
            _jieSuan.removeZheKou(hyPrice);
            _jieSuan.removeZheKou(hyZk);//复位
            console.log(preZhekou);

            _self.setCandidateZheKouRule(preZhekou);
            _self.confirmZheKouRule();
        }else{
            //复位折扣规则
            _zheKouRule = null;
        }






    }





    //当前会员的的设置所衍生出来的折扣对象
    //可以是会员价折扣  或者 会员比例折扣
    //两者只能选其一，具有互斥性
    var asZheKou = function(){

        if(_zheKouRule == BIZCONSTANT.HY_ZK_RULE_PRICE ){
            var zk = BIZCONSTANT.HUIYUANJIAOBJ;
            if(!zk) {
                zk = null;
            } else {
                //折扣名称
                zk.zheKouName = "会员价";
                //折扣编码
                zk.zheKouCode = BIZCONSTANT.ZHE_KOU_HY_PRICE;
                //折扣率(内置折扣模板为空)
                zk.zheKouAmount = _self.mHuiYuanJia;
            }

            if(zk && zk.zheKouAmount && parseFloat(zk.zheKouAmount) > 0) {
                return zk;
            }
            else {
                return null;
            }
        }

        if( (_zheKouRule == BIZCONSTANT.HY_ZK_RULE_LV) && _zheKou != 100 && _zheKou >= 0 ){
            var zk = BIZCONSTANT.HUIYUANZKOBJ;
            if(!zk) {
                zk = null;
            } else {
                zk = zk.cloneZK();
                //折扣名称
                zk.zheKouName = "会员折扣（"+_zheKou+"%）";
                //折扣编码
                zk.zheKouCode = BIZCONSTANT.ZHE_KOU_HY_ZK;

                //折扣率(内置折扣模板为空)
                zk.zheKouAmount = _zheKou;
            }
            return zk;
        }


        return null;

    }

    //当前会员设置所衍生出来的反值对象
    this.asPayment4FanZhi = function(){
        var huiYuanKa = new PaymentMethod();
        huiYuanKa.code = BIZCONSTANT.PM_HUI_YUAN_FAN_ZHI;
        huiYuanKa.name = "会员卡反值";
        huiYuanKa.addMoney( _self.getPayAmount());
        return huiYuanKa;
    }

    //当前会员设置所衍生出来的积分兑换对象
    this.asPayment4JFXF = function(){
        var o = PaymentMethod.JFXF();
        o.addMoney( _self.getJfPayAmount());
        return o;
    }

    //当前会员设置所衍生出来的雅座消费对象
    this.asPayment4YZXF = function(){
        var o = PaymentMethod.YZXF();
        o.addMoney( _self.getYZPayAmount());
        return o;
    }

    //解除当前会员
    this.resetMember = function(){
        if(_jieSuan == null)
            return ;

        _jieSuan.removePM(_huiYuanKa);


    }
    this.getJieSuan = function () {
        return _jieSuan;
    }

    this.getPolicy = function () {
        if (_rule == BIZCONSTANT.MEMBER_RULE_BILI)
            return new BiLi();

        if (_rule == BIZCONSTANT.MEMBER_RULE_CHONGZHI_PREFER)
            return new ChongZhiPrefer();

        if (_rule == BIZCONSTANT.MEMBER_RULE_ZONGSONG_PREFER)
            return new ZongSongPrefer();

        return null;

    }

    this.setRule = function (r) {
        _rule = r;
    }

    this.setZheKou = function (z) {
        _zheKou = z;
    }

    //得到会员ID
    this.getGuid = function(){
        return _guid;
    }

    //得到会员卡号
    this.getCardNo = function(){
        if(_cardNum == undefined || _cardNum == "undefined") _cardNum = null;
        return _cardNum;
    }

    this.setCardNo =function(o){
        _cardNum = o;
    }

    this.setName = function (v)
    {
        _name = v;
    }


    this.setCardLevelIsPrice = function(o){
        _cardLevelIsPrice = o;
    }
    this.getCardLevelIsPrice = function(){
        return _cardLevelIsPrice;
    }
    //是否删除
    this.getisDeleted = function(){
        return _isDeleted;
    }

    this.setGuid = function (guid) {
        _guid=guid;
    }



    this.setisDeleted = function (isDeleted) {
        _isDeleted=isDeleted;
    }




    /**
     *  扣款的时候发送的json
     *
     * @param rb
     * @returns {*}
     */
    this.json4Pay = function(rb){
        var detail = [];

        //储值
        var tmpCZ = {
            tradeType:"R04",	//业务类型：会员卡储值消费
            tradeTotalMoney:"",
            tradeTotalPoint:"",
            cardTradeDetails:[]
        }

        if(_trans[0].getAmount() > 0) {
            tmpCZ.cardTradeDetails.push({
                tradeDetailType : "RD041", //交易流水类型：储值消费
                payMoney: _trans[0].getAmount() ,
                payType: _trans[0].pmGuid(),
                payTypeName:_trans[0].pmDesc(),
                isJifen:_trans[0].huiYuanJiFenDesc()
            });
        }
        if(_trans[1].getAmount() > 0){
            tmpCZ.cardTradeDetails.push({
                tradeDetailType:"RD042",	//交易流水类型：赠送消费
                payMoney:_trans[1].getAmount(),
                payType:_trans[1].pmGuid(),	//付款方式ID
                payTypeName:_trans[1].pmDesc(),	//付款方式Name
                isJifen:_trans[0].huiYuanJiFenDesc()
            });
        }
        if(tmpCZ.cardTradeDetails.length > 0)
            detail.push(tmpCZ);

        /************************************************************************/
        //会员卡积分消费
        var tmpJF = {
            tradeType:"R05",
            tradeTotalMoney:"",
            tradeTotalPoint:"",
            cardTradeDetails:[]
        }

        if(_trans[3].getAmount() > 0){
            tmpJF.cardTradeDetails.push({
                tradeDetailType:"RD051",	//交易流水类型：积分消费
                payMoney:_trans[3].getAmount(),
                payType:null,	//付款方式ID
                payTypeName:null,
            });
            detail.push(tmpJF);
        }

        rb.cardCode = _self.getCardNo();
        rb.cardTrades = detail;

        return rb;
    }



    /**
     * 判断当前会员是否正在使用 【会员价】
     * @returns {boolean}
     */
    this.isHuiYuanPrice = function(){
        if (_zheKouRule == BIZCONSTANT.HY_ZK_RULE_PRICE)
            return true;
       
        return false;
    }

    /**
     *
     * 判断当前会员是否正在使用”会员折扣“
     *
     * @returns {boolean}
     */
    this.isHuiYuanZheKou = function(){
        if (_zheKouRule == BIZCONSTANT.HY_ZK_RULE_LV)
            return true;

        return false;
    }


    this.getZheKouRule = function(){
        return _zheKouRule;
    }


    /**
     * 清除掉和当前会员相关的各种支付方式
     *
     */
    this.clearAllPayments = function(){
        _jieSuan.removePM(_huiYuanKa);
        _jieSuan.removePM(_jfxf);
    }


}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
