﻿function MPosDisPlay() {

    this.posdisplay = HardWareManager.get(CONSTANTS.HardWareConstants.POS_DISPLAY).newInstance();
    this.config = null;
    var me = this;
    this.display = function (buffer,cb) {
        var cfg = { path: CAT_PAR.LOCAL.KXPZDK, baudrate: CAT_PAR.LOCAL.KXPEBTL };
        me.posdisplay.connect(cfg,buffer, function (err) {
            if (err)
                return Utils.showFailureInfo("客显连接失败：" + err);
            //me.posdisplay.flush();
            //me.posdisplay.disconnect();
            if (cb)
                cb();
        });
    }

    this._getposdisplay = function (config) {
        return  HardWareManager.get(CONSTANTS.HardWareConstants.POS_DISPLAY).newInstance();// cfg: { path: config.path, baudrate: config.baudrate } };
    }

}


var MPosDisPlayHelp = {
    mposdisplay : new MPosDisPlay()
}

//清屏
MPosDisPlayHelp.Init = function (cb) {
    var commond = PrinterCommand.CMD_NORMAL_ENTER();
    MPosDisPlayHelp.mposdisplay.display(commond,cb);
}

//显示模式（1，单价；2，总计；3，收款；4，找零；0，不显示）
MPosDisPlayHelp.mode = function (mode) {
    var commond = PrinterCommand.CMD_POS_DISPLAY(mode);
    MPosDisPlayHelp.mposdisplay.display(commond);
}

//显示数字
MPosDisPlayHelp.number = function (numstr) {
    var commond = PrinterCommand.CMD_POS_DISPLAY_Number(numstr);
    MPosDisPlayHelp.mposdisplay.display(commond);
}