
function Order(){
    var _self = this;
    this.guid = null;
    this.code = null;
    this.mdId = null;
    this.mdCode = null;
    this.zhuotaiId = null;
    this.zhuotaiName = null;
    this.renshu = 0;
    this.status = 0;
    this.name = null;
    this.comments = null;
    this.totalPrice = 0;
    this.totalNum = 0;
    this.isDeleted = "false";
    this.canBieCode = null; //结算餐别
    this.canbieName = null; //结算餐别
    this.serverId = null;
    this.serverName = null;
    this.serverGuid = null;
    this.operator = null;
    this.operatorName = null; //当前操作人的名字
    this.operatorCode = null;//当前操作人的工号
    this.jieSuanOperatorId = null;
    this.jieSuanOperatorCode = null;
    this.jieSuanOperatorName = null;
    this.modTime = null;
    this.kaiTaiTime = null;
    this.luoDanTime = null;
    this.jieSuanTime = null;
    this.isKaifapiao = 'false';
    this.mom = null; //记录翻倍的倍数
    this.serverGuid = null;
    this.disLuodanOrderCaipins = [];
    //表示此账单中的菜品是否需要全部参与分摊。由结算对象设置。默认为非全员分摊。
    this.quanYuanFenTan = false;
    //此账单关联的菜品one-many<OrderCaipin>,added by peter
    this.caiPinList = [];
    //结算完的账单有关联付款方式
    this.billingDetail = [];

    this.jieSuanId = null; //与该账单关联的结算ID
    this.jieSuanNo = null;//与该账单关联的结算号
    this.isFanJieSuan = null; //是否是反结算
    this.fanJieSuanNum = 0; //反结算次数
    this.memberNo = null;//会员卡号，只有当该账单使用会员结算的时候，才会有会员号
    this.tradeNumber = null;//交易流水号
    this.tradeGuid = null;//交易GUID

    this.areaGuid = null;//区域GUID
    this.areaCode = null;//区域CODE
    this.areaName = null;//区域名称
    this.zhuotaiCode = null;//桌台CODE
    this.canbieId = null;//餐别GUID 结算餐别

    this.jieSuanCanBieId = null; //结算餐别GUID
    this.jieSuanCanBieCode = null;
    this.jieSuanCanBieName = null;

    this.merge = null;

    this.thirdOrderNo = null; //第三方订单号，如微信订单号

    this.couponNo = null; //优惠券券号

    this.banciNo = null;

    this.waimaiCustomerName = null;//外卖客户名字
    this.waimaiCustomerPhone = null;//外卖客户电话
    this.waimaiCustomerAddress = null;//外卖客户地址
    this.waimaiDeliveryCharge = null;//外卖递送费
    this.waimaiBoxCharge = null;//外卖餐盒费
    this.waimaiYouhui = null;//外卖平台优惠额
    this.thirdPaymentType = null;

    this.tsAndwm = null;

    var _orderSource = null; //账单来源， 微信，线下，或者其他
    var _jieSuan = null;

    this.setOrderSource = function(o){
         _orderSource = o;
    }

    this.getOrderSource = function() {
        return _orderSource;
    }

    //是否来自第三方订单
    this.isFromThirdOrder = function () {
        if(_self.isWaiMai() == true || _self.isFromWeiXin() == true) {
            return true;
        }
        return false;
    }

    //是否外面订单
    this.isWaiMai = function () {
        if(_self.tsAndwm && _self.tsAndwm == "WM") {
            return true;
        }
        return false;
    }

    this.isFromWeiXin = function(){
        if(_orderSource == ORDERSOURCE.WEIXIN)
        return true;

        return false;
    }

    //得到权重最大的关联菜品。
    this.markMaxWeight = function(){
        var weight = -1;
        var ret = null;
        //遍历菜品，并求得最大权重菜品
       // console.log(_self.caiPinList);
        _.each(_self.caiPinList, function(v){

            //reset to false;
            v.maxWeightInCurrentOrder = false;

            //console.log("v.weight..."+ v.weight());
            if(v.weight() > weight){
                weight = v.weight();
                ret = v;
            }

        });

        if(null!=ret){
            ret.maxWeightInCurrentOrder = true;
        }

        return ret;
    }





    //增加该账单中的菜品
    this.addCaiPin = function(cp){
        _self.caiPinList.push(cp);
        cp.parentOrder = _self;
    }

    //是否全员分摊
    this.isQuanYuanFenTan = function(){
        return this.quanYuanFenTan;
    }






    //得到[非最大权重】的菜品或做法的(普通菜品）的【分摊金额】的合计
    this.getSumFenTanOfCommon = function(){
        var ret = 0.00;


        //菜品
        _.each(_self.caiPinList, function(v){
            //做法
            _.each(v.zuofas, function(w){
                if(w.maxWeightInCurrentOrder)
                    return;
                ret = w.calFenTan() + ret;
            });

            if(v.maxWeightInCurrentOrder)
                return;
            ret = v.calFenTan() + ret;
        });



        return Utils.m(ret);
    }

    //得到该账单的所有分摊（做法参与分摊）
    this.getSumOfFenTan = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            ret = v.calFenTan() + ret;

            //做法
            _.each(v.zuofas, function(w){
                ret = w.calFenTan() + ret;
            });

        });

        return Utils.m(ret);
    }


    //得到该账单关联的菜品的实收的累计 == 折前账单金额-优惠额 == 折前账单金额-(菜品折扣金额+菜品定额折扣+菜品抹零金额)
    this.getYingShou = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            ret = Utils.accAdd(Utils.accAdd(v.calShiShou(), v.calShiShouTotal4ZuoFa()), ret);
            //console.log(v.calShiShou() +":::::" +v.calShiShouTotal4ZuoFa());

        });
        // console.log("==============================" +ret);
        if(_jieSuan !== null && _jieSuan.getIgnoreXuShou())
            _jieSuan.YING_SHOU = Utils.m(ret);
        return  Utils.m(ret);
    }

    //得到【非单品折扣的菜品】的【类比例折扣】的合计(菜品和做法都合计）
    /**
     * 整单折扣金额
     * 1.单品折扣的菜品以及做法不参与
     * 2. 赠送的菜品以及做法不参与
     * @returns {number}
     */
    this.getSumOfNoneDanPinZheKou = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            if(v.existDpZk())
                return;
            ret = v.mZkFromZhengDan() + v.mZkFromZhengDanOfZuoFa() + ret;
        });

        return ret;
    }

    //得到账单的抹零合计
    this.getSumOfMoLing = function(){
        var ret = _self.zhangDanMoLing();

        return new MoLing(ret);
    }



    //计算落单时候的价格 = 得到菜品的折前价格 - 单品折扣掉的价格 - 赠送的部分
    //单品折扣的是在落单之后进行的。
    //这个计算用于在界面上显示
    this.getSum4LuoDan = function(){
        var ret = 0.00;
        var sum = 0.00;
        var zk = 0.00;
        _.each(_self.caiPinList, function(v){
            sum = v.mRaw() + v.calMoneyTotal4ZuoFa() + sum;
            if(v.existDpZk()) {
                zk = zk + v.mZk() + v.calZheKouTotal4ZuoFa();
                // console.log("this.getSum4LuoDan.DpZK : " + zk);
            }
            zk = zk + v.mFree()+ v.calFreeTotal4ZuoFa();
        });
        // console.log("this.getSum4LuoDan.sum : " + sum );
        // console.log("this.getSum4LuoDan.zk : " + zk );
        ret = Utils.m(sum) - Utils.m(zk);
        //
        //console.log(ret);
        //return _.round(ret);
        return ret;
    }

    this.getSumOfZhangDan = function(){

        var sum = 0.00;
        _.each(_self.caiPinList, function(v){
            sum = v.mRaw() + v.calMoneyTotal4ZuoFa() + sum;
        });


        return sum;
    }

    this.getSumOfHuiYuanJiaZheKou = function(){
        var sum = 0.00;
        _.each(_self.caiPinList, function(v){
            sum = v.mZKFromHuiYuanJia() + sum;
        });

        return sum;
    }

    this.getCountOfCaiPin = function(){
        var sum = 0;
        _.each(_self.caiPinList, function(v){
            sum = v.num + sum;
        });

        return sum;

    }

///////////////////////////////////////////////////////////////////////////

    /**
     * 账单金额合计，包括菜品和做法
     */
    this.mZhangDan = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
             ret =  v.mRaw()  + v.mRawOfZuoFa() + ret;
        });

        return ret;

    }
    /**
     * 【参与分摊的】菜品折前金额总计,包括做法
     */
    this.getRawTotalMoney4FenTan = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            if( v.isFenTan() )
                ret =  v.mRaw()  + ret + v.mRawOfZuoFa();
        });

        return Utils.m(ret);
    }

    /**
     * 【参与分摊的】菜品折扣金额总计，包括做法
     */
    this.getRawTotalZheKou4FenTan = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            if( v.isFenTan() )
                ret = v.mZk()  + ret +　v.mZkOfZuoFa();
        });

        return Utils.m(ret);
    }

    /**
     * 菜品和做法的 【整单折扣金额】合计计
     */
    this.money4ZhengDanZheKou = function(){

        var zk = 0.00;
        _.each(_self.caiPinList, function(v){
            zk = zk + v.mZkFromZhengDan() + v.mZkFromZhengDanOfZuoFa();
        });

        return zk;
    }


    /**
     *     菜品折扣金额总计=菜品折扣+【做法折扣】
     *
     *     包含整单折扣 ，但不等同于整单折扣
     */

    this.calAllZheKou = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            ret = v.mZk() + v.mZkOfZuoFa() + ret;
        });

        return Utils.m(ret);
    }


    /**
   * 得到账单中所有退菜菜品的金额累计（实收）
   */
    this.sumOfTuiCai = function () {
        var ret = 0.00;
        _.each(_self.caiPinList, function (v) {
            if (v.num > 0)
                return;
            ret = v.calShiShou() + v.calShiShouTotal4ZuoFa() + ret;
        });

        return ret;
    }

    /**
     * 得到账单中所有 赠送菜品的金额累计
     */
    this.sumOfFree = function () {
        var ret = 0.00;
        _.each(_self.caiPinList, function (v) {
            
            ret = v.mFree() + v.calFreeTotal4ZuoFa() + ret;
        });

        return ret;
    }

    /**
     * 得到账单中所有 菜品的折扣金额的合计!!!!注意，这里是排除掉 赠送的金额!!!!!
     *
     */
    this.sumOfZheKou = function () {
        var ret = 0.00;
        _.each(_self.caiPinList, function (v) {
            ret = v.mZk() + v.mZkOfZuoFa() + ret;
        });

        return ret - this.sumOfFree();
    }


    /**
     * 获得该账单下所有的单品折扣菜品的折扣金额
     */
    this.sumOfDanPin = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            ret = v.mZkFromDanPinBiLi() + v.mZkDanPinOfZuoFa() + ret;
        });

        return Utils.m(ret);
    }


    /**
     * 获得该账单应用整单比例后，所产生的折扣
     */
    this.sumOfZhengDanBiLi = function(){
        var ret = 0.00;
        _.each(_self.caiPinList, function(v){
            ret = v.mZkFromZhengDan() + v.mZkFromZhengDanOfZuoFa() + ret;
        });

        return Utils.m(ret);
    }

    /**
     *进入结算界面的时候，所计算出来的
     * 账单抹零金额
     *
     *
     */
    this.zhangDanMoLing = function(){
        //如果账单是来自第三方订单，那么默认抹零为0，
        if(_self.isFromThirdOrder())
            return 0.00;
        var zhangDan =  _self.mZhangDan();
        var zk = _self.calAllZheKou();
        var beforeRound = zhangDan - zk;
        return Utils.m(beforeRound - Utils.ml(beforeRound));
    }


    /**
     *     得到用于该账单的 分摊的【总金额】
     */
    this.fenTanZongJinE= function(){
        var ret = {zheKouAmount : 0};

        //a. 定额折扣（是优免属性）
        var candidate1 = _self.getJieSuan().getZheKouMap().de ;

        if(candidate1 != null )
            ret.zheKouAmount = Utils.m(ret.zheKouAmount)  + Utils.m(candidate1.zheKouAmount);
        //b.得到财务属性为“优免”的支付方式，他们的金额会作为 分摊金额的一部分
        var ymList =  _self.getJieSuan().getPaymentOfYouMian();
        _.each(ymList, function (item) {
            ret.zheKouAmount =  Utils.m(ret.zheKouAmount) + Utils.m(item.pmMoney());
        });

 
        //c. 抹零(优免属性）
        ret.zheKouAmount =  Utils.m(ret.zheKouAmount) +  Utils.m(_self.zhangDanMoLing());

 
        return  ret;
    }




    this.addBillingDetail = function (billingDetail) {
        this.billingDetail.push(billingDetail);
    }

    /**
     *
     * 根据菜品的GUID来找到目标菜品
     */
    this.findCaiPinByKey = function(pk){

        var ret  = null;
        //遍历菜品，查看是否有套餐的菜品
        _.each(_self.caiPinList, function(v){
            if(v.guid == pk)
                ret = v;
        });

        return ret;

    }

    //设置和账单关联的结算
    this.setJieSuan = function(o){
        _jieSuan  = o;
    }

    this.getJieSuan = function(){
        return _jieSuan;
    }


}
