app.factory("banciQueryService", ["$q", "database", "AjaxLogger", function ($q, database,AjaxLogger) {
    var banciQueryService = {};
    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');
/*
    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');

    var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');

    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');

    var billdetailDao = new DatabaseFuncDelegate($q, database, 'pos_billing_detail');

    var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');

    //获取班次的基本信息
    banciQueryService.getBanciInfo = function ( cb) {
        var sql = "SELECT * FROM pos_banci WHERE status = 1"
        orderDao.query(sql).then(function (resList) {
            return cb(null,resList);
        },function (err) {
            return cb(err);
        })
    }

    //获取指定班次下的所有菜品  数据 banci
    banciQueryService.getCaipinInbanci = function ( banci ) {
       var sql = "SELECT * FROM pos_order_caipin WHERE orderId IN (SELECT guid FROM pos_order WHERE banciNo = '"+ banci +"')";
        orderDao.query(sql).then(function (resList) {
            return cb(null,resList);
        },function (err) {
            return cb(err);
        })
    }

    //获取指定班次下的所有指定菜品子、父类别的菜品  数据 banci 菜品类别 type
    banciQueryService.getCaipinInbanciAndType = function ( banci, typeId, cb ) {

        var typeidcondition='';
        if(typeId && typeId!=''){
            typeidcondition=" where guid='" + typeId + "' OR parentId='" + typeId + "'";
        }
        var  sql = "SELECT * from "+
        " (select * from pos_order_caipin where orderId in (select guid from pos_order where BanciNo='"+banci+"')) a "+
       " left join (SELECT guid as t_guid,dishTypeName as t_name FROM pos_caipin_type where guid in(SELECT guid FROM pos_caipin_type "+typeidcondition+")"+
        ") tb on a.caipinTypeId=tb.t_guid where t_guid is not null ";
        orderDao.query(sql).then(function (resList) {
            return cb(null,resList);
        },function (err) {
            return cb(err);
        })
    }
*/

    //获取所有菜品类型
    banciQueryService.getCaipiType = function (cb) {
        var sql = "select * from pos_caipin_type where guid not in (select parentId from pos_caipin_type where parentId is not null)";
        var returnList = [];
        orderDao.query(sql).then(function (res) {
            if(res && res.detail && res.detail.length > 0) {
                for(var i = 0; i < res.detail.length; i++) {
                    var obj = Utils.clone(res.detail[i]);
                    returnList.push(obj);
                }
            }
            return cb(null, returnList);
        }, function (err) {
            return cb(err);
        })
        /*var sql = "SELECT * FROM pos_caipin_type WHERE parentId is NULL",
            sql2 = "SELECT * FROM pos_caipin_type WHERE parentId is not NULL",
            parenttype = [], childrentype = []; //父类包含子类的合并集合
        orderDao.query(sql).then(function (parentList) {
            orderDao.query(sql2).then(function(childrenList){
                //parenttype = Utils.arrClone(parentList.detail);
                for (var x in parentList.detail){
                    var obj = Utils.clone(parentList.detail[x]);
                    obj.childType = [];
                    parenttype.push(obj);
                }
                childrentype = Utils.arrClone(childrenList.detail);
                for(var i = 0 ; i< parenttype.length ; i++ ) {
                    for (var j = 0 ; j< childrentype.length ; j++ ) {
                        if(parenttype[i].guid ==childrentype[j].parentId) {
                            parenttype[i].childType.push(childrentype[j] )
                        }
                    }
                }
                cb(null, parenttype);
            },function(error){
                cb(error);
            })
        },function (err) {
            return cb(err);
        })*/
    }

   // SELECT *FROM pos_banci WHERE jieBanTime < '2016-07-28 15:48:21' AND kaiBanTime > '2016-07-28 00:00:00'

    //获取班次的基本信息
    //1.开结班时间
    //2.开结班收营员
    //3.班次号查询
    banciQueryService.getBanciInfo = function (kaiban,jiesu ,syy, banci,cb) {
        var  sql;
        if(banci) {
            sql = "SELECT * FROM pos_banci WHERE banCiNo = '" +banci + "' AND status = '1'";
        } else {
            if(!kaiban){
                return Utils.showFailureInfo('请输入开班时间');
            }
            if(!jiesu){
                return  Utils.showFailureInfo('请输入结班时间');
            }
            if(syy){
                sql ="SELECT * FROM pos_banci WHERE kaiBanTime <= '" + jiesu +"' AND kaiBanTime >= '" + kaiban + "' and status = '1' and addOperatorId = '" + syy + "'";
            }else{
                sql ="SELECT * FROM pos_banci WHERE kaiBanTime <= '" + jiesu +"' AND kaiBanTime >= '" + kaiban + "' and status = '1'";
            }
        }

        orderDao.query(sql).then(function (resList) {
            return cb(null,resList);
        },function (err) {
            return cb(err);
        })
    }

    //get snap by banciHao
    banciQueryService.getSnapBybc = function (bc,cb) {
        var sql = "SELECT snap,jieBanTime FROM pos_banci WHERE banCiNo = '" + bc + "'";
        orderDao.query(sql).then(function (r) {
            return cb(null, r.detail[0]);
        },function (err) {
            return cb(err);
        })
    }

    // get all perpson
    banciQueryService.getPerpson =  function (cb){
        var sql = "SELECT guid, personName FROM pos_person";
        orderDao.query(sql).then(function (r) {
            return cb(null, r.detail);
        },function (err) {
            return cb(err);
        })

    }


    return banciQueryService;
}])