app.factory("BillSignService", ["$http", function($http){
    var BillSignService = {};

    //撤销签单
    BillSignService.cancelBillSign = function(orderNo, cb) {
        var url = handlePosUrl(SERVER_HOST.BASE_HOST + API_CONTEXT.BILLSIGN + "/api/v1/billsignOrder/cancelBillSignOrder");
        //var url = handlePosUrl("http://localhost:10003/yunshan-billsign-api/api/v1/billsignOrder/cancelBillSignOrder");
        var data = {};
        data.groupCode = BIZCONSTANT.POSUSER.groupCode;
        data.groupId = BIZCONSTANT.POSUSER.groupId;
        data.modUserId = BIZCONSTANT.POSUSER.id;
        data.modUser = BIZCONSTANT.POSUSER.name;
        data.orgid = BIZCONSTANT.POSUSER.mdId;
        data.orgName = BIZCONSTANT.POSUSER.HotelName;
        data.orderNo = orderNo;

        $http({
            method: 'POST',
            url: url,
            headers: {"Content-Type":"application/json"},
            data: data
        }).success(function(data,header,config,status){
            if(data.status != "success"){
                cb(data.errorMsg);
            } else {
                cb(null,data.data);
            }
        }).error( function(data,header,config,status){
            cb("撤销签单失败，请联系客服或稍后重试");
        } );
    }

    return BillSignService;

}]);