app.factory('ClientWindowSettingsService', ['$q', 'database', '$http', "$window", function ($q, database, $http, $window) {
    var cwsService = {};
	var dao = new DatabaseFuncDelegate($q, database, 'pos_clientwindow_settings');
    

	cwsService.adAll = function (cb) {
	    console.info('clientW  getAll begin');
	    dao.query("select * from pos_clientwindow_settings where is_active=1 order by seq asc").then(function (result) {
	        console.info(result);
	        return cb(null, result.detail);
	    }, function (err) {
	        console.error(err);
	        return cb(err)
	    });
	};

	cwsService.getAll = function (cb) {
	    dao.query("select * from pos_clientwindow_settings order by seq asc").then(function (result) {
	        console.info(result);
            return cb(null, result.detail);
	    }, function (err) {
	        console.error(err);
            return cb(err)
        });
	};

	cwsService.addWaipingSetting = function (waipingsetting, cb) {

	    waipingsetting.data = waipingsetting.data.replaceAll('\\\\', '/');

        var sql = "INSERT INTO pos_clientwindow_settings (guid, type, data, seq, is_active, duration)" +
            " VALUES ('" + dao.guid() + "', '" + waipingsetting.type + "', '" + waipingsetting.data +
            "', '" + waipingsetting.seq + "', '" + waipingsetting.is_active + "', '" + waipingsetting.duration + "')";

        dao.query(sql).then(function (result) {
            return cb(null, waipingsetting);
        }, function (err) {
            return cb(err);
        });
    };

	cwsService.saveWaipingSetting = function (waipingsetting, cb) {
	    waipingsetting.data = waipingsetting.data.replaceAll('\\\\', '/');
        var sql = "select * from pos_clientwindow_settings where guid='" + waipingsetting.guid + "'";
        var curWaipingSetting = null;
        dao.query(sql).then(function (result) {
            curWaipingSetting = result.detail;
        }, function (err) {
            return cb(err);
        }).then(function (o) {
            if (!Utils.isEmpty( curWaipingSetting)) {
               sql = "update pos_clientwindow_settings set is_active='" + waipingsetting.is_active +
                        "' where guid='" + waipingsetting.guid + "'";

                dao.query(sql).then(function (result) {
                    return cb(null, waipingsetting);
                }, function (err) {
                    return cb(err);
                });
            }
        })
    };

    cwsService.delWaipingSetting = function (waipingsetting,cb) {
        var sql = "DELETE FROM pos_clientwindow_settings WHERE guid='"+waipingsetting.guid+"'";

        dao.query(sql).then(function (result) {
            return cb(null, waipingsetting);
        }, function (err) {
            return cb(err);
        });
    };
	
    return cwsService;
}]);