app.factory("JiebanService", ["$q", "database", "CanbieService", function ($q, database, CanbieService) {
    var JiebanService = {};

    var billingDao = new DatabaseFuncDelegate($q, database, "pos_billing");

    var banciDao = new DatabaseFuncDelegate($q, database, "pos_banci");

    var orderDao = new DatabaseFuncDelegate($q, database, "pos_order");

    JiebanService.getZhangdanInfo = function (banciNo, cb) {
        /*包含付款方式*/
        //var sql = "select b.guid as b_guid,b.orderId as b_orderId,b.orderNo as b_orderNo,b.zhangDanTotal as b_zhangDanTotal,b.shiShou as b_shiShou,"+
        //            "b.zhaoLing as b_zhaoLing,b.zheKouTotal as b_zheKouTotal,b.fenTanTotal as b_fenTanTotal,b.moLing as b_moLing,b.jieSuanNo as b_jieSuanNo,"+
        //            "b.banci as b_banci,b.canbieCode as b_canbieCode,b.canBieName as b_canbieName,b.addOperatorId as b_operatorId,b.addOperatorName as b_operatorName,"+
        //            "b.addOperatorCode as b_operatorCode,b.isFanJieSuan as b_isFanJieSuan,b.moneyTuiDan as b_moneyTuiDan,b.moneyZengSong as b_moneyZengSong,b.moneyZheKou as b_moneyZheKou," +
        //            "bd.guid as bd_guid,bd.bizId as bd_bizId,bd.bizCode as bd_bizCode,bd.bizAmount as bd_bizAmount,"+
        //            "bd.bizDesc as bd_bizDesc,bd.type as bd_type,bd.amount as bd_amount,bd.caiWuShuXing as bd_caiWuShuXing,"+
        //            "o.renshu as o_renshu " +
        //            " from pos_banci_order bco " +
        //            " inner join pos_order o on bco.orderId = o.guid " +
        //            " inner join pos_billing b on bco.orderCode=b.orderNo "+
        //            " left join pos_billing_detail bd on b.jieSuanNo=bd.jieSuanNo "+
        //            " where bco.banciNo='"+ banciNo+"'";

        var sql = "select b.guid as b_guid,b.orderId as b_orderId,b.orderNo as b_orderNo,b.zhangDanTotal as b_zhangDanTotal,b.shiShou as b_shiShou," +
            "b.zhaoLing as b_zhaoLing,b.zheKouTotal as b_zheKouTotal,b.fenTanTotal as b_fenTanTotal,b.moLing as b_moLing,b.jieSuanNo as b_jieSuanNo," +
            "b.banci as b_banci,b.canbieCode as b_canbieCode,b.canBieName as b_canbieName,b.addOperatorId as b_operatorId,b.addOperatorName as b_operatorName," +
            "b.addOperatorCode as b_operatorCode,b.isFanJieSuan as b_isFanJieSuan,b.moneyTuiDan as b_moneyTuiDan,b.moneyZengSong as b_moneyZengSong,b.moneyZheKou as b_moneyZheKou," +
            "o.renshu as o_renshu " +
            " from pos_banci_order bco " +
            " inner join pos_order o on bco.orderId = o.guid " +
            " inner join pos_billing b on bco.orderCode=b.orderNo " +
            " where bco.banCiNo='" + banciNo + "'  and b.jieSuanNo is not null "; // 只过滤出已经结算的账单

        billingDao.query(sql).then(function (result) {
                var resultList = [];
                if (result.detail.length > 0) {
                    for (var i = 0; i < result.detail.length; i++) {
                        var row = result.detail[i];

                        var zhangdanInfo = Utils.arrayFind(resultList, row.b_jieSuanNo, "jieSuanNo");
                        if (zhangdanInfo == null) {
                            zhangdanInfo = new ZhangdanInfo();
                            zhangdanInfo.guid = row.b_guid;
                            zhangdanInfo.orderId = row.b_orderId;
                            zhangdanInfo.orderNo = row.b_orderNo;
                            zhangdanInfo.zhangDanTotal = row.b_zhangDanTotal;
                            zhangdanInfo.shiShou = row.b_shiShou;
                            zhangdanInfo.zhaoLing = row.b_zhaoLing;
                            zhangdanInfo.zheKouTotal = row.b_zheKouTotal;
                            zhangdanInfo.fenTanTotal = row.b_fenTanTotal;
                            zhangdanInfo.moLing = row.b_moLing;
                            zhangdanInfo.jieSuanNo = row.b_jieSuanNo;

                            zhangdanInfo.canbieCode = row.b_canbieCode;
                            zhangdanInfo.canBieName = row.b_canBieName;
                            zhangdanInfo.addOperatorId = row.b_operatorId;
                            zhangdanInfo.addOperatorCode = row.b_operatorCode;
                            zhangdanInfo.addOperatorName = row.b_operatorName;

                            zhangdanInfo.isFanJieSuan = Utils.isEmpty(row.b_isFanJieSuan) ? 0 : row.b_isFanJieSuan;
                            zhangdanInfo.moneyTuiDan = Utils.isEmpty(row.b_moneyTuiDan) ? 0 : row.b_moneyTuiDan;
                            zhangdanInfo.moneyZengSong = Utils.isEmpty(row.b_moneyZengSong) ? 0 : row.b_moneyZengSong;
                            zhangdanInfo.moneyZheKou = Utils.isEmpty(row.b_moneyZheKou) ? 0 : row.b_moneyZheKou;

                            zhangdanInfo.renshu = Utils.isEmpty(row.o_renshu) ? 0 : row.o_renshu;


                            if (zhangdanInfo.isFanJieSuan != 1) {
                                resultList.push(zhangdanInfo);
                            }
                        }
                        /*处理付款方式*/
                        //if (row.bd_guid != null) {
                        //    var billingDetail = Utils.arrayFind(zhangdanInfo.zhangdanDetails, row.bd_guid, "bd_guid")
                        //    if (billingDetail == null) {
                        //        billingDetail = new BillingDetail();
                        //        billingDetail.guid = row.bd_guid;
                        //        billingDetail.bizId = row.bd_bizId;
                        //        billingDetail.bizCode = row.bd_bizCode;
                        //        billingDetail.bizAmount = row.bd_bizAmount;
                        //        billingDetail.bizDesc = row.bd_bizDesc;
                        //        billingDetail.type = row.bd_type;
                        //        billingDetail.amount = row.bd_amount;
                        //        billingDetail.caiWuShuXing = row.bd_caiWuShuXing;

                        //        zhangdanInfo.zhangdanDetails.push(billingDetail);
                        //    }
                        //}
                    }
                }
                return cb(null, resultList);
            },
            function (err) {
                return cb(err);
            })
    };

    JiebanService.getBanciZhangdanHuizong = function (banciNo, cb) {
        var sql = "SELECT	" +
            " sum(case when b.isFanJieSuan=0  then b.shiShou else 0 end) AS b_shiShou," +
            " sum(case when b.isFanJieSuan=0  then b.moneyZengSong else 0 end ) AS b_moneyZengSong," +
            " sum(case when b.isFanJieSuan=0  then b.moneyZhengDanBiLi else 0 end  ) AS b_moneyZhengDanBiLi," +
            " sum(case when b.isFanJieSuan=0  then b.moneyDingE else 0 end  ) AS b_moneyDingE," +
            " sum(case when b.isFanJieSuan=0  then b.moneyDanPin else 0 end  ) AS b_moneyDanPin," +
            " sum(case when b.isFanJieSuan=0  then b.moLing else 0 end ) AS b_moneyMoLing," +
            " sum(case when b.isFanJieSuan=0  then o.renshu else 0 end ) AS o_renshu," +
            " count(case when b.isFanJieSuan=1 then b.isFanJieSuan else null end  )as fanJieSuanCount," +
            " count(case when b.isFanJieSuan=0 then b.isFanJieSuan else null end  )as jiaoyiCount, " +
            " sum( case when (b.isFanJieSuan=0 and o.isKaifapiao=1)   then b.shiShou  else 0 end ) as fapiaoMoney   " +
            " FROM 	(select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco " +
            " INNER JOIN pos_order o ON bco.orderId = o.guid " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " WHERE	bco.banCiNo = '" + banciNo + "'   and b.jieSuanNo is not null";

        billingDao.query(sql).then(function (result) {
            var banci_Zhangdans = null;

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    banci_Zhangdans = new Banci_Zhangdans();
                    banci_Zhangdans.yingYeShouRu = Utils.mnan(row.b_shiShou);
                    banci_Zhangdans.renshu = Utils.mnan(row.o_renshu);
                    banci_Zhangdans.jiaoyiCount = Utils.mnan(row.jiaoyiCount);
                    banci_Zhangdans.fanjiesuanCount = Utils.mnan(row.fanJieSuanCount);
                    banci_Zhangdans.moneyZengSong = parseFloat(row.b_moneyZengSong == null? 0: row.b_moneyZengSong).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    var zhengDanBiLi = parseFloat(row.b_moneyZhengDanBiLi == null? 0 : row.b_moneyZhengDanBiLi);
                    var dingE = parseFloat(row.b_moneyDingE == null? 0 : row.b_moneyDingE);
                    var danPin = parseFloat(row.b_moneyDanPin == null? 0 : row.b_moneyDanPin);
                    banci_Zhangdans.moneyZheKou = (zhengDanBiLi + dingE + danPin).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    banci_Zhangdans.moneyMoLing = parseFloat(row.b_moneyMoLing == null? 0 : row.b_moneyMoLing).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    //banci_Zhangdans.moneyHYZK = parseFloat(row.b_moneyHYZK == null? 0 : row.b_moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    //banci_Zhangdans.moneyHYYH = parseFloat(row.b_moneyHYYH == null? 0 : row.b_moneyHYYH).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    banci_Zhangdans.fapiaoMoney = row.fapiaoMoney;
                }

                if(banci_Zhangdans != null) {
                    //优免的付款方式
                    sql = "SELECT	" +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='04' then pbd.amount else 0 end ) AS b_moneyHYZK," +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='03' then pbd.bizAmount else 0 end ) AS b_moneyHYYH, " +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='INTERNAL_HYZSDH' then pbd.amount else 0 end ) AS b_moneyHYZS " +
                        " FROM 	(select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco " +
                        " INNER JOIN pos_order o ON bco.orderId = o.guid " +
                        " INNER JOIN pos_billing b ON bco.orderCode = b.orderNo " +
                        " LEFT JOIN pos_billing_detail pbd ON b.guid = pbd.jieSuanId " +
                        " WHERE	bco.banCiNo = '" + banciNo + "'   and b.jieSuanNo is not null and (pbd.type<>'PAY' or (pbd.type='PAY' and pbd.bizCode='INTERNAL_HYZSDH')) and pbd.caiWuShuXing='优免'";
                    billingDao.query(sql).then(function(res){
                        if (res.detail.length > 0) {
                            var row = res.detail[0];
                            banci_Zhangdans.moneyHYZK = parseFloat(row.b_moneyHYZK == null? 0 : row.b_moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                            banci_Zhangdans.moneyHYYH = parseFloat(row.b_moneyHYYH == null? 0 : row.b_moneyHYYH).toFixed(BIZCONSTANT.MONEY_PRECISE);
                            banci_Zhangdans.moneyZheKou = (banci_Zhangdans.moneyZheKou - banci_Zhangdans.moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                            banci_Zhangdans.yingYeShouRu = Utils.mnan(banci_Zhangdans.yingYeShouRu) + parseFloat(row.b_moneyHYZS == null ? 0 : row.b_moneyHYZS);
                        }
                        //套餐折前退款
                        sql = "select sum(zheQianMoney) as tdMoney from pos_order_scomb_caipin where CAST(num as float)<0 and orderCaipinId IN " +
                            "(select guid from pos_order_caipin where orderId IN(select bo.orderId from pos_banci_order bo,pos_billing b " +
                            "where bo.orderId=b.orderId and bo.banciNo='" + banciNo + "' and b.jieSuanNo is not null))"
                        billingDao.query(sql).then(function(ret){
                            var scombTuiD = 0;
                            if(ret.detail.length > 0) {
                                var row = ret.detail[0];
                                //套餐退单
                                scombTuiD = row.tdMoney;
                                if(!scombTuiD) scombTuiD = 0;
                            }
                            //非套餐退单
                            sql = "select sum(zheQianMoney+zuoFaZheQianTotal) tdMoney1 from pos_order_caipin where CAST(num as float)<0 and orderId in (select guid from pos_order where banciNo='" + banciNo + "')"
                            billingDao.query(sql).then(function(ret1){
                                var tuiD = 0;
                                if(ret1.detail.length > 0) {
                                    var row = ret1.detail[0];
                                    tuiD = row.tdMoney1;
                                    if(!tuiD) tuiD = 0;
                                }
                                banci_Zhangdans.moneyTuiDan = scombTuiD + tuiD;
                                return cb(null, banci_Zhangdans);
                            })
                        })
                    })

                }
            }
        }, function (err) {
            return cb(err);
        });
    };

    JiebanService.getFuKuanFangShi = function (banciNo, cb) {

        //var sql = "select name,sum(amount)   as sumMoney " +
        //        " from (select name,amount  ,max(createTime) " +
        //        " from ( SELECT bco.orderCode , bco.createTime ,bd.bizDesc as name,bd.amount as amount " +
        //        " FROM pos_banci_order bco " +
        //        " INNER JOIN pos_order o ON bco.orderId = o.guid  " +
        //        " INNER JOIN pos_billing b ON bco.orderCode = b.orderNo " +
        //        " LEFT JOIN pos_billing_detail bd ON b.guid = bd.jieSuanId  " +
        //        " WHERE  bco.banCiNo = '" + banciNo + "' " +
        //        " and bd.type='PAY' and b.isFanJieSuan=0 )  group by orderCode) group by name";
        var sql = " SELECT bd.bizDesc as name,sum(bd.amount) as sumMoney, bd.bizCode as code " +
            " FROM (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco  " +
            " INNER JOIN pos_order o ON bco.orderId = o.guid   " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " LEFT JOIN pos_billing_detail bd ON b.guid = bd.jieSuanId  " +
            " WHERE  bco.banCiNo = '" + banciNo + "' and bd.type='PAY' and b.isFanJieSuan=0 " +
            " and b.jieSuanNo is not null and cast(bd.amount as float)>0 and (bd.caiWuShuXing<>'优免' or (bd.caiWuShuXing='优免' and bd.bizCode='INTERNAL_HYZSDH')) " +
            " group by bd.bizDesc";


        billingDao.query(sql).then(function (result) {
            var resultList = [];
            var pms = [];
            var memPM = null;
            var memZSPM = null;
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    if(row.code == BIZCONSTANT.PM_HUI_YUAN) {
                        memPM = row;
                    }else if(row.code == BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE) {
                        memZSPM = row;
                    }else {
                        pms.push(row);
                    }
                }
                if(memPM && memZSPM) {
                    memPM = _.cloneDeep(memPM);
                    memPM.sumMoney = Utils.m(parseFloat(memPM.sumMoney) + parseFloat(memZSPM.sumMoney));
                }
                if(memPM) {
                    pms.push(memPM);
                }
            }
            if (pms.length > 0) {
                for (var i = 0; i < pms.length; i++) {
                    var row = pms[i];
                    var banci_FuKuanFangShi = new Banci_FuKuanFangShi();
                    banci_FuKuanFangShi.name = row.name;
                    banci_FuKuanFangShi.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_FuKuanFangShi);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return  cb(err);
        });
    };

    JiebanService.getCaipinType = function (banciNo, cb) {

        var sql = "select dishtypeName,sum(zheQianMoney+zfm) as sumMoney" +
            " from ( select dishtypeName,sum(zfShishouMoeny) as zfm,guid,sum(zheQianMoney)/count(guid) as zheQianMoney " +
            " from  ( SELECT  ocp.guid, ocp.zheQianMoney,ocp.price price, ocp.num num, " +
            " case when cptp.dishTypeName is NOT NULL then cptp.dishTypeName else cpt.dishTypeName end  as dishtypeName ," +
            " case when ( cpzf.zheQianMoney  is NULL or cpzf.orderScombCaipinId is NOT NULL) then 0 else cpzf.zheQianMoney end as zfShishouMoeny " +
            " FROM  pos_order_caipin ocp " +
            " INNER JOIN (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco on ocp.orderId=bco.orderId " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId   " +
            " INNER JOIN pos_caipin cp on ocp.caipinId=cp.guid " +
            " inner join pos_caipin_type as cpt on cp.typeId=cpt.guid " +
            " LEFT JOIN pos_caipin_type as cptp on cpt.parentId=cptp.guid  " +
            " left join pos_order_caipin_zuofa as cpzf on ocp.guid=cpzf.orderCaipinId " +
            " where bco.banCiNo='" + banciNo + "' and b.isFanJieSuan=0    and b.jieSuanNo is not null  ) t " +
            "  group by dishtypeName,guid) group by dishtypeName ";


        billingDao.query(sql).then(function (result) {
            var resultList = [];

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    var banci_CaipinType = new Banci_CaipinType();
                    banci_CaipinType.name = row.dishtypeName;
                    banci_CaipinType.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_CaipinType);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };

    /// #region 为收银报表服务

    JiebanService.getCaipinType4ShouYinReport = function (param, cb) {

        var condition = '';
        if (param)
        {
            condition += param.currentOperatorid ? ("b.addOperatorId='" + param.currentOperatorid + "' AND ") : "";
            condition += param.startTime ? ("b.createTime>='" + param.startTime + "' AND ") : "";
            condition += param.endTime ? ("b.createTime<='" + param.endTime + "' AND ") : "";
        }

        var sql = "select dishtypeName,sum(zheQianMoney+zfm) as sumMoney" +
            " from ( select dishtypeName,sum(zfShishouMoeny) as zfm,guid,sum(zheQianMoney)/count(guid) as zheQianMoney " +
            " from  ( SELECT  ocp.guid, ocp.zheQianMoney," +
            " case when cptp.dishTypeName is NOT NULL then cptp.dishTypeName else cpt.dishTypeName end  as dishtypeName ," +
            " case when ( cpzf.zheQianMoney  is NULL or cpzf.orderScombCaipinId is NOT NULL) then 0 else cpzf.zheQianMoney end as zfShishouMoeny " +
            " FROM  pos_order_caipin ocp " +
            " INNER JOIN (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco on ocp.orderId=bco.orderId " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId   " +
            " INNER JOIN pos_caipin cp on ocp.caipinId=cp.guid " +
            " inner join pos_caipin_type as cpt on cp.typeId=cpt.guid " +
            " LEFT JOIN pos_caipin_type as cptp on cpt.parentId=cptp.guid  " +
            " left join pos_order_caipin_zuofa as cpzf on ocp.guid=cpzf.orderCaipinId " +
            " where " + condition + " b.isFanJieSuan=0    and b.jieSuanNo is not null  ) t " +
            "  group by dishtypeName,guid) group by dishtypeName ";


        billingDao.query(sql).then(function (result) {
            var resultList = [];

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    var banci_CaipinType = new Banci_CaipinType();
                    banci_CaipinType.name = row.dishtypeName;
                    banci_CaipinType.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_CaipinType);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };

    JiebanService.getFuKuanFangShi4ShouYinReport = function (param, cb) {

        var condition = '';
        if (param) {
            condition += param.currentOperatorid ? ("b.addOperatorId='" + param.currentOperatorid + "' AND ") : "";
            condition += param.startTime ? ("b.createTime>='" + param.startTime + "' AND ") : "";
            condition += param.endTime ? ("b.createTime<='" + param.endTime + "' AND ") : "";
        }
        var sql = " SELECT bd.bizDesc as name,sum(bd.amount) as sumMoney, bd.bizCode as code " +
            " FROM (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco  " +
            " INNER JOIN pos_order o ON bco.orderId = o.guid   " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " LEFT JOIN pos_billing_detail bd ON b.guid = bd.jieSuanId  " +
            " WHERE  " + condition + " bd.type='PAY' and b.isFanJieSuan=0 " +
            " and b.jieSuanNo is not null and cast(bd.amount as float)>0 and (bd.caiWuShuXing<>'优免' or (bd.caiWuShuXing='优免' and bd.bizCode='INTERNAL_HYZSDH'))" +
            " group by bd.bizDesc";


        billingDao.query(sql).then(function (result) {
            var resultList = [];
            var pms = [];
            var memPM = null;
            var memZSPM = null;
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    if(row.code == BIZCONSTANT.PM_HUI_YUAN) {
                        memPM = row;
                    }else if(row.code == BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE) {
                        memZSPM = row;
                    }else {
                        pms.push(row);
                    }
                }
                if(memPM && memZSPM) {
                    memPM = _.cloneDeep(memPM);
                    memPM.sumMoney = Utils.m(parseFloat(memPM.sumMoney) + parseFloat(memZSPM.sumMoney));
                }
                if(memPM){
                    pms.push(memPM);
                }
            }
            if (pms.length > 0) {
                for (var i = 0; i < pms.length; i++) {
                    var row = pms[i];
                    var banci_FuKuanFangShi = new Banci_FuKuanFangShi();
                    banci_FuKuanFangShi.name = row.name;
                    banci_FuKuanFangShi.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_FuKuanFangShi);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };

    JiebanService.getYoumian4ShouYinReport = function (param, cb) {
        var condition = '';
        if (param) {
            condition += param.currentOperatorid ? ("b.addOperatorId='" + param.currentOperatorid + "' AND ") : "";
            condition += param.startTime ? ("b.createTime>='" + param.startTime + "' AND ") : "";
            condition += param.endTime ? ("b.createTime<='" + param.endTime + "' AND ") : "";
        }

        var sql = "select bd.bizDesc typeName,sum(bd.amount) as sumMoney " +
            " from  (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc   group by orderCode) bco " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " left join pos_billing_detail bd on  b.guid = bd.jieSuanId " +
            " where " + condition + " type='PAY' and bd.caiWuShuXing='优免' and cast(bd.amount as float)>0 AND b.isFanJieSuan=0 and bd.bizCode<>'INTERNAL_HYZSDH' group by bizDesc";

        billingDao.query(sql).then(function (result) {
            var resultList = [];

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    var banci_YoumianItem = new Banci_JiebanItem();
                    banci_YoumianItem.name = row.typeName;
                    banci_YoumianItem.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_YoumianItem);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    }

    JiebanService.getBanciZhangdanHuizong4ShouYinReport = function (param, cb) {
        var condition = '';
        if (param) {
            condition += param.currentOperatorid ? ("b.addOperatorId='" + param.currentOperatorid + "' AND ") : "";
            condition += param.startTime ? ("b.createTime>='" + param.startTime + "' AND ") : "";
            condition += param.endTime ? ("b.createTime<='" + param.endTime + "' AND ") : "";
        }

        var sql = "SELECT	" +
            " sum(case when b.isFanJieSuan=0  then (b.shiShou+b.hykZSMoney) else 0 end) AS b_shiShou," +
            " sum(case when b.isFanJieSuan=0  then b.moneyZengSong else 0 end ) AS b_moneyZengSong," +
            " sum(case when b.isFanJieSuan=0  then b.moneyZhengDanBiLi else 0 end  ) AS b_moneyZhengDanBiLi," +
            " sum(case when b.isFanJieSuan=0  then b.moneyDingE else 0 end  ) AS b_moneyDingE," +
            " sum(case when b.isFanJieSuan=0  then b.moneyDanPin else 0 end  ) AS b_moneyDanPin," +
            " sum(case when b.isFanJieSuan=0  then b.moLing else 0 end ) AS b_moneyMoLing," +
            " sum(case when b.isFanJieSuan=0  then o.renshu else 0 end ) AS o_renshu," +
            " count(case when b.isFanJieSuan=1 then b.isFanJieSuan else null end  )as fanJieSuanCount," +
            " count(case when b.isFanJieSuan=0 then b.isFanJieSuan else null end  )as jiaoyiCount, " +
            " sum( case when (b.isFanJieSuan=0 and o.isKaifapiao=1)   then b.shiShou  else 0 end ) as fapiaoMoney   " +
            " FROM 	(select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco " +
            " INNER JOIN pos_order o ON bco.orderId = o.guid " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " WHERE	" + condition + " b.jieSuanNo is not null";

        billingDao.query(sql).then(function (result) {
            var banci_Zhangdans = null;

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    banci_Zhangdans = new Banci_Zhangdans();
                    banci_Zhangdans.yingYeShouRu = row.b_shiShou;
                    banci_Zhangdans.renshu = row.o_renshu;
                    banci_Zhangdans.jiaoyiCount = row.jiaoyiCount;
                    banci_Zhangdans.fanjiesuanCount = row.fanJieSuanCount;
                    banci_Zhangdans.moneyZengSong = parseFloat(row.b_moneyZengSong == null ? 0 : row.b_moneyZengSong).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    var zhengDanBiLi = parseFloat(row.b_moneyZhengDanBiLi == null ? 0 : row.b_moneyZhengDanBiLi);
                    var dingE = parseFloat(row.b_moneyDingE == null ? 0 : row.b_moneyDingE);
                    var danPin = parseFloat(row.b_moneyDanPin == null ? 0 : row.b_moneyDanPin);
                    banci_Zhangdans.moneyZheKou = (zhengDanBiLi + dingE + danPin).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    banci_Zhangdans.moneyMoLing = parseFloat(row.b_moneyMoLing == null ? 0 : row.b_moneyMoLing).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    //banci_Zhangdans.moneyHYZK = parseFloat(row.b_moneyHYZK == null? 0 : row.b_moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                    //banci_Zhangdans.moneyHYYH = parseFloat(row.b_moneyHYYH == null? 0 : row.b_moneyHYYH).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    banci_Zhangdans.fapiaoMoney = row.fapiaoMoney;
                }

                if (banci_Zhangdans != null) {
                    //优免的付款方式
                    sql = "SELECT	" +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='04' then pbd.amount else 0 end ) AS b_moneyHYZK," +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='03' then pbd.bizAmount else 0 end ) AS b_moneyHYYH, " +
                        " sum(case when b.isFanJieSuan=0 and pbd.bizCode='INTERNAL_HYZSDH' then pbd.amount else 0 end ) AS b_moneyHYZS " +
                        " FROM 	(select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc group by orderCode) bco " +
                        " INNER JOIN pos_order o ON bco.orderId = o.guid " +
                        " INNER JOIN pos_billing b ON bco.orderCode = b.orderNo " +
                        " LEFT JOIN pos_billing_detail pbd ON b.guid = pbd.jieSuanId " +
                        " WHERE	" + condition + " b.jieSuanNo is not null and pbd.type<>'PAY' and pbd.caiWuShuXing='优免'";
                    billingDao.query(sql).then(function (res) {
                        if (res.detail.length > 0) {
                            var row = res.detail[0];
                            banci_Zhangdans.moneyHYZK = parseFloat(row.b_moneyHYZK == null ? 0 : row.b_moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                            banci_Zhangdans.moneyHYYH = parseFloat(row.b_moneyHYYH == null ? 0 : row.b_moneyHYYH).toFixed(BIZCONSTANT.MONEY_PRECISE);
                            banci_Zhangdans.moneyZheKou = (banci_Zhangdans.moneyZheKou - banci_Zhangdans.moneyHYZK).toFixed(BIZCONSTANT.MONEY_PRECISE);
                        }
                        //套餐折前退款
                        sql = "select sum(zheQianMoney) as tdMoney from pos_order_scomb_caipin where CAST(num as float)<0 and orderCaipinId IN " +
                            "(select guid from pos_order_caipin where orderId IN(select bo.orderId from pos_banci_order bo,pos_billing b " +
                            "where bo.orderId=b.orderId and " + condition + " b.jieSuanNo is not null))"
                        billingDao.query(sql).then(function (ret) {
                            var scombTuiD = 0;
                            if (ret.detail.length > 0) {
                                var row = ret.detail[0];
                                //套餐退单
                                scombTuiD = row.tdMoney;
                                if (!scombTuiD) scombTuiD = 0;
                            }
                            //非套餐退单
                            sql = "select sum(zheQianMoney+zuoFaZheQianTotal) tdMoney1 from pos_order_caipin where CAST(num as float)<0 and orderId in (select a.guid from pos_order a INNER JOIN pos_billing b on a.jiesuanId=b.guid where " + condition + " b.jieSuanNo is not null)"
                            billingDao.query(sql).then(function (ret1) {
                                var tuiD = 0;
                                if (ret1.detail.length > 0) {
                                    var row = ret1.detail[0];
                                    tuiD = row.tdMoney1;
                                    if (!tuiD) tuiD = 0;
                                }
                                banci_Zhangdans.moneyTuiDan = scombTuiD + tuiD;
                                return cb(null, banci_Zhangdans);
                            })
                        })
                    })

                }
            }
        }, function (err) {
            return cb(err);
        });
    };

    JiebanService.getBancis = function (param,cb)
    {
        var condition = '';
        if (param) {
            condition += param.currentOperatorid ? ("addOperatorId='" + param.currentOperatorid + "' AND ") : "";
            condition += param.startTime ? ("kaiBanTime>='" + param.startTime + "' AND ") : "";
            condition += param.endTime ? ("jieBanTime<='" + param.endTime + "' AND ") : "";
        }
        var sql = "select * from pos_banci where " + condition + " 1=1 ";
        banciDao.query(sql).then(function (result) {
            var bancis = [];
            for (var i in result.detail)
            {
                bancis.push(result.detail[i]);
            }
            return cb(null,bancis);
        }, function (err) {
            return cb(err);
        });
    }

    /// #endregion

    JiebanService.getYoumian = function (banciNo, cb) {
        var sql = "select bd.bizDesc typeName,sum(bd.amount) as sumMoney " +
            " from  (select orderId,orderCode,banCiNo,max(createTime) from pos_banci_order bc where banciNo='" + banciNo + "'  group by orderCode) bco " +
            " INNER JOIN pos_billing b ON bco.orderId = b.orderId  " +
            " left join pos_billing_detail bd on  b.guid = bd.jieSuanId " +
            " where type='PAY' and bd.caiWuShuXing='优免' and cast(bd.amount as float)>0 AND b.isFanJieSuan=0 and bd.bizCode<>'INTERNAL_HYZSDH' group by bizDesc";

        billingDao.query(sql).then(function (result) {
            var resultList = [];

            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    var banci_YoumianItem = new Banci_JiebanItem();
                    banci_YoumianItem.name = row.typeName;
                    banci_YoumianItem.sumMoney = parseFloat(row.sumMoney).toFixed(BIZCONSTANT.MONEY_PRECISE);

                    resultList.push(banci_YoumianItem);
                }
            }
            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    }


    JiebanService.Jieban = function (banciNo, cb) {
        CanbieService.isLastCanbieByCurTime(function (err, result) {
            if (err)
                return cb(err);
            /*
             验证是否是最后一个餐别
             result  1:当前餐别是最后一个餐别   0：不是
             */
            if (result == 1) {
                banciDao.all(" status='0' ").then(function (result) {
                    //验证未结算的班次数量
                    if (result.length == 1) {
                        orderDao.all(" jiesuanTime is null ").then(function (result) {
                            //验证是否有未结算的账单
                            if (result.length > 0) {
                                var msg = "";
                                for (var i = 0; i < result.length; i++) {
                                    msg += ("桌台" + result[i].zhuotaiName + "的账单未结算，不能结班\r\n");
                                }
                                return cb({ message: msg });
                            }
                            JiebanService.saveJieban(banciNo, cb);
                        }, function (err) {
                            return cb(err);
                        });
                    } else {
                        JiebanService.saveJieban(banciNo, cb);
                    }
                }, function (err) {
                    return cb(err);
                });
            } else {
                JiebanService.saveJieban(banciNo, cb);
            }
        });
    };

    JiebanService.validateJieban = function (cb) {
        banciDao.all(" status='0' ").then(function (result) {
            var weiJiesuanZhuotaiName = [];
            //验证未结算的班次数量
            if (result.length == 1) {
                orderDao.all(" jiesuanTime is null ").then(function (result) {
                    //验证是否有未结算的账单
                    if (result.length > 0) {
                        var msg = "";
                        for (var i = 0; i < result.length; i++) {
                            weiJiesuanZhuotaiName.push(result[i].zhuotaiName);
                            //msg += ("桌台" + result[i].zhuotaiName + "的账单未结算，不能结班\r\n");
                        }
                    }
                    return cb(null, weiJiesuanZhuotaiName);
                }, function (err) {
                    return cb(err);
                });
            } else {
                return cb(null, weiJiesuanZhuotaiName);
            }
        }, function (err) {
            return cb(err);
        });
    }

    //用于校验是否有未结算的桌台
    JiebanService.validateJiebanByZhuotai = function (cb)
    {
        var sql = "SELECT * FROM pos_zhuotai where isDeleted='false' AND enabled='true' AND orderId is not null"
        banciDao.query(sql).then(function (result) {
            cb(null, result.detail);
        }, function (err) {
            cb(err);
        })
    }

    JiebanService.uploadJieban = function (cb) {
        var sql = "select * from pos_banci where  status=1 AND (syn = 0 OR syn is null)"
        banciDao.query(sql).then(function (result) {
//             console.log(result)
            //            return UploadService.syncJieban(result)
            var queryarr = [];

            cb(null,result.detail);
        }, function (err) {
//            return console.error(err);
            cb(err);
        })
    }

    JiebanService.lastSaveJieban = function ( banciNo ) {
        var curTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");
//        var sql = "update pos_banci set syn='1' where banciNo='" + banciNo + "'"
        var sql = "update pos_banci set syn='1' where  status=1 AND (syn = 0 OR syn is null)"

        banciDao.query(sql).then(function (result) {
            console.log("ok");
        }, function (err) {
            console.log("no");
        })
    };

    JiebanService.saveJieban = function (banciNo, cb,snap) {

        var ordersql = "SELECT * FROM pos_order where banciNo='" + banciNo + "'";

        banciDao.query(ordersql).then(function (result) {
            var ordercount = result.detail.length;
            var orderidstr = '';
            for (var i in result.detail)
            {
                var order = result.detail[i];
                orderidstr +=  order.guid + ",";
            }
            if (ordercount > 0)
                orderidstr = orderidstr.substr(0, orderidstr.length - 1);

            var curTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");
            var sql = "update pos_banci set status='1', jieBanTime='" + curTime + "', snap ='#|" + snap + "#|', orderCount=" + ordercount + ",orderIds='" + orderidstr + "' where banciNo='" + banciNo + "'"

            banciDao.query(sql).then(function (result) {
                return cb(null, banciNo);
            }, function (err) {
                return cb(err);
            });
        }, function (err) {
            return cb(err);
        })


    };


    return JiebanService;
}])