var TABLES_SCHEME = [
        {
            name: "tmp_uniqueid",
            columns: [
                { name: 'id', type: 'text primary key' },
                { name: 'usedate', type: 'text' },
                { name: 'usetype', type: 'text' },
                { name: 'seq', type: 'integer' }
            ]
        },          
        {
            name: 'pos_area',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'areaCode', type: 'text' },
                { name: 'areaName', type: 'text' },
                { name: 'mdId', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_zhuotai',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'areaId', type: 'text' },
                { name: 'quickCode', type: 'text' },
                { name: 'canweishu', type: 'integer' },
                { name: 'mdId', type: 'text' },
                { name: 'orderId', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'operatorId', type: 'text' },
                { name: 'operatorName', type: 'text' },
                { name: 'isDeleted', type: 'text' },
                { name: 'consumptionId', type: 'text' }
            ]
        },
        {
            name: 'pos_order',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'mdId', type: 'text' },
                { name: 'mdCode', type: 'text' },
                { name: 'zhuotaiId', type: 'text' },
                { name: 'zhuotaiName', type: 'text' },
                { name: 'renshu', type: 'integer' },
                { name: 'status', type: 'integer' },//1:空账单；2：已点菜；3：已预结；4：已结算
                { name: 'comments', type: 'text' },
                { name: 'totalPrice', type: 'NUMERIC' },
                { name: 'totalNum', type: 'integer' },
                { name: 'isDeleted', type: 'text' },
                { name: 'canBieCode', type: 'text' },//餐别CODE
                { name: 'canBieName', type: 'text' },//餐别名称
                { name: 'jieSuanOperatorId', type: 'text' },//结算人员的ID- 结算
                { name: 'jieSuanOperatorCode', type: 'text' },//结算人员的工号- 结算
                { name: 'jieSuanOperatorName', type: 'text' },//结算人员的姓名- 结算
                { name: 'serverId', type: 'text' },//服务员工号,点菜员
                { name: 'serverName', type: 'text' },//服务员名字
                { name: 'serverGuid', type: 'text' },//服务员改点菜员，为点菜员GUID
                { name: 'operator', type: 'text' },//当前登录操作员,落单人员
                { name: 'operatorName', type: 'text' },//当前登录操作员名字
                { name: 'operatorCode', type: 'text' },//当前登录操作员工号
                { name: 'modTime', type: 'text' },//记录修改时间，需要时可使用
                { name: 'kaiTaiTime', type: 'text' },//开台时间
                { name: 'luoDanTime', type: 'text' },//落单时间
                { name: 'jieSuanTime', type: 'text' },//结算时间
                { name: 'isKaifapiao', type: 'text' },//是否开发票
                { name: 'isFanJieSuan', type: 'text' },//是否是反结算
                { name: 'fanJieSuanNum', type: 'INTEGER' }, //反结算次数
                { name: 'jieSuanId', type: 'text' }, //结算单的GUID
                { name: 'jieSuanNo', type: 'text' }, //结算单的流水号
                { name: 'cardNo', type: 'text' }, //会员卡号，如果用会员支付，那么此值为非空。 反之为空。
                { name: 'cardMemName', type: 'text' }, //会员名字
                { name: 'tradeNumber', type: 'text' }, //会员交易流水
                { name: 'tradeGuid', type: 'text' }, //会员交易GUID

                { name: 'areaGuid', type: 'text' }, //区域Guid
                { name: 'areaCode', type: 'text' }, //区域Code
                { name: 'areaName', type: 'text' }, //区域名称
                { name: 'zhuotaiCode', type: 'text' }, //桌台Code
                { name: 'canBieId', type: 'text' }, //餐别Code
                { name: 'ordersource', type: 'text' }, //下单类型
                { name: 'banciNo', type:"text"}, //和账单关联的班次号， 只有在结账的时候，才会真正关联
                { name: 'merge', type:"text"}, //合并标记
                { name: 'thirdOrderNo', type:"text"}, //第三方订单号，如微信订单号
                { name: 'jieSuanCanBieId', type:"text"},
                { name: 'jieSuanCanBieCode', type:"text"},
                { name: 'jieSuanCanBieName', type:"text"},
                { name: 'jieSuanTimeMill', type:"text"}, //进行最终结算的时候，结算的时间的毫秒级数值
                { name: 'huiYuanId', type:"text"}, //会员ID
                { name: 'couponNo', type:"text"}, //优惠券号
                { name: 'waimaiCustomerName', type:"text"},//外卖客户名字
                { name: 'waimaiCustomerPhone', type:"text"},//外卖客户电话
                { name: 'waimaiCustomerAddress', type:"text"},//外卖客户地址
                { name: 'waimaiDeliveryCharge', type: 'NUMERIC' },//外卖递送费
                { name: 'waimaiBoxCharge', type: 'NUMERIC' },//外卖餐盒费
                { name: 'tsAndwm', type:"text"}, //账单属性 目前只有两种 1.TS为堂室  2.WM为外卖
                { name: 'mom', type: 'NUMERIC' }, // 整桌翻倍的倍数，页面统计倍数
                { name: 'waimaiYouhui', type: 'NUMERIC' },//外卖平台优惠额
                { name: 'thirdPaymentType', type:"text"},//第三方支付类型，正念-zn
                { name: 'debugInfo', type:"text"}, //记录下反结算时候的内容信息，主要用于查明“一个订单多个有效billing的问题
                { name: 'temZkMoney', type: 'NUMERIC' } //折扣模板产生的折扣金额
            ]
        },
        {
            name: 'pos_caipin_type',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'dishTypeCode', type: 'text' },
                { name: 'dishTypeName', type: 'text' },
                { name: 'parentId', type: 'text' },
                { name: 'isFenTan', type: 'text' },
                { name: 'zheKou', type: 'integer' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_caipin',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'typeId', type: 'text' },
                { name: 'quickCode', type: 'text' },
                { name: 'salePrice', type: 'NUMERIC' },
                { name: 'hyPrice', type: 'NUMERIC' },
                { name: 'costprice', type: 'NUMERIC' },
                { name: 'unitId', type: 'text' },
                { name: 'unitName', type: 'text' },
                { name: 'minAgio', type: 'integer' },
                { name: 'printId', type: 'text' },
                { name: 'printName', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'customize', type: 'text' },
                { name: 'priceChange', type: 'text' },
                { name: 'needweigh', type: 'text' },
                { name: 'isScomb', type: 'text' },//是否套餐
                { name: 'isDeleted', type: 'text' },
                { name: 'caiwuTypeName', type: 'text' }, //菜品财务类别名
                { name: 'caiwuTypeId', type: 'text' },  //菜品财务类别ID
                { name: 'caiPuId', type: 'text' },  //菜谱ID
                { name: 'cpdept', type: 'text' },
                { name: 'cpdeptName', type: 'text' },
                { name: 'commissionPrice', type: 'text' }, //提成金额
                { name: 'commissionTypeId', type: 'text' } //提成方式， 001-按数量提成 002-按比例提成
            ]
        },
        {
            name: 'pos_caipin_unit',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'caipinId', type: 'text' },
                { name: 'unitId', type: 'text' },
                { name: 'unitName', type: 'text' },
                { name: 'price', type: 'NUMERIC' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_order_caipin',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderId', type: 'text' },
                { name: 'caipinId', type: 'text' },
                { name: 'caipinCode', type: 'text' },
                { name: 'orderCaipinType', type: 'integer' },//类型(1:点菜，2:退菜)
                { name: 'name', type: 'text' },
                { name: 'price', type: 'NUMERIC' },
                { name: 'costprice', type: 'NUMERIC' },
                { name: 'num', type: 'NUMERIC' },
                { name: 'tuiNum', type: 'NUMERIC' },
                { name: 'zengNum', type: 'NUMERIC' },
                { name: 'orgNum', type: 'NUMERIC' },//整桌翻倍前的数量为了作为原始基数计算翻倍
                { name: 'mom', type: 'NUMERIC' }, // 整桌翻倍的倍数，计算定额加价
                { name: 'unitId', type: 'text' },
                { name: 'unitName', type: 'text' },
                { name: 'printId', type: 'text' },
                { name: 'printName', type: 'text' },
                { name: 'chupin', type: 'text' },
                { name: 'minAgio', type: 'integer' },//单品最低折扣
                { name: 'danPinBiLiZheKou', type: 'integer' },
                { name: 'danPinJineZheKou', type: 'NUMERIC' },
                { name: 'danPinZheKou', type: 'integer' },
                { name: 'luodan', type: 'integer' },
                { name: 'customize', type: 'text' },
                { name: 'zheQianMoney', type: 'text' },//1. 折前金额 - 结算
                { name: 'shiShouMoney', type: 'text' },//2 实收金额- 结算
                { name: 'zheKouMoney', type: 'text' },// 3折扣金额- 结算
                { name: 'fenTanSumMoney', type: 'text' },//4 分摊总计- 结算
                { name: 'moLingMoney', type: 'text' },// 5 抹零金额- 结算

                { name: 'zuoFaZheQianTotal', type: 'text' }, // 1 和当前菜品关联的做法折前金额 - 结算
                { name: 'zuoFaShiShouTotal', type: 'text' }, // 2 和当前菜品关联的做法实收合计- 结算
                { name: 'zuoFaZheKouTotal', type: 'text' }, //  3 和当前菜品关联的做法折扣金额- 结算
                { name: 'zuoFaFenTanTotal', type: 'text' },  // 4 和当前菜品关联的做法分摊合计- 结算
                { name: 'zuoFaMoLingTotal', type: 'text' },  // 5 和当前菜品关联的做法抹零合计- 结算

                { name: 'weight', type: 'text' },//菜品在当前账单中的权重
                { name: 'dianCaiYuanNo', type: 'text' },//点菜员No，默认是登录员工No
                { name: 'dianCaiYuan', type: 'text' },//点菜员工号，默认是登录员工
                { name: 'dianCaiYuanName', type: 'text' },//点菜员名字
                { name: 'operator', type: 'text' },
                { name: 'modTime', type: 'text' },
                { name: 'dianCaiTime', type: 'text' },
                { name: 'luoDanTime', type: 'text' },
                { name: 'jieSuanTime', type: 'text' }, //结算时间- 结算
                { name: 'chuPinTime', type: 'text' },
                { name: 'parentId', type: 'text' },//退菜属于的orderCaipinId
                { name: 'tuicaiReasonType', type: 'text' },//退菜原因类型 0-普通退菜 1-上退菜 2-临时估清
                { name: 'tuicaiReasonId', type: 'text' },//退菜原因id
                { name: 'needweigh', type: 'NUMERIC' },//是否需称重 0 不需要，1 需要，2，已确认
                { name: 'tuicaiReasonName', type: 'text' },//退菜原因name
                { name: 'isScomb', type: 'text' },//是否套餐

                { name: 'caipinTypeId', type: 'text' },//菜品类型ID
                { name: 'caipinTypeCode', type: 'text' },//菜品类型Code
                { name: 'caipinTypeName', type: 'text' },//菜品类型name
                { name: 'hyPrice', type: 'NUMERIC' },//会员价
                { name: 'caiwuTypeName', type: 'text' }, //菜品财务类别名
                { name: 'caiwuTypeId', type: 'text' },  //菜品财务类别ID
                { name: 'firstGuid', type: 'text' }, //移菜的GUID重构，存储原始GUID
                { name: 'orderZhuoTaiId', type: 'text' }, //zhuotaiId,关联pos_order_zhuotai的guid。 为了满足一单多桌台后，可以做一些桌台分析或区域分析类报表。
                { name: 'priceChange', type: 'text' }, //菜品可变价
                { name: 'cpdept', type: 'text' },
                { name: 'cpdeptName', type: 'text' },
                { name: 'tiaoZhiNum', type: 'text' }, //条只数单位。

                { name: 'dishFastNo', type: 'text' }, //菜品速查码
                { name: 'bestTypeId', type: 'text' },//菜品类别ID
                { name: 'bestTypeCode', type: 'text' },//菜品类别code
                { name: 'bestTypeName', type: 'text' }, //菜品类别name

                { name: 'commissionPrice', type: 'text' }, //提成金额
                { name: 'commissionTypeId', type: 'text' }, //提成方式， 001-按数量提成 002-按比例提成, 冗余POS_caipin中的提成信息
                { name: 'zengSongMoney', type: 'text' } //赠送金额，含做法金额
            ]
        },
        {
            name: 'pos_kouwei',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'kwCode', type: 'text' },
                { name: 'kwName', type: 'text' },
                { name: 'quickCode', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_zuofa_type',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderNo', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_zuofa',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'typeId', type: 'text' },
                { name: 'price', type: 'NUMERIC' },
                { name: 'quickCode', type: 'text' },
                { name: 'jiajiaType', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_caipin_zuofa',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'caipinId', type: 'text' },
                { name: 'zuofaId', type: 'text' },
                { name: 'zuofaName', type: 'text' },
                { name: 'jiajiaType', type: 'text' },
                { name: 'jiajiaTypeName', type: 'text' },
                { name: 'jiajiaPrice', type: 'NUMERIC' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_order_caipin_kouwei',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderCaipinId', type: 'text' },
                { name: 'kwId', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'operator', type: 'text' },
                { name: 'modTime', type: 'text' },
                { name: 'isScomb', type: 'text' },//是否套餐
                { name: 'orderScombCaipinId', type: 'text' }//订单中套餐关联菜品GUID
            ]
        },
        {
            name: 'pos_order_caipin_zuofa',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderCaipinId', type: 'text' },
                { name: 'zuofaId', type: 'text' },
                { name: 'typeId', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'price', type: 'NUMERIC' },
                { name: 'jiajiaType', type: 'text' },
                { name: 'operator', type: 'text' },
                { name: 'modTime', type: 'text' },

                { name: 'zheQianMoney', type: 'text' },//折前金额 - 结算
                { name: 'shiShouMoney', type: 'text' },//实收金额- 结算
                { name: 'zheKouMoney', type: 'text' },//折扣金额- 结算
                { name: 'fenTanSumMoney', type: 'text' },//分摊总计- 结算
                { name: 'moLingMoney', type: 'text' },// 抹零金额- 结算
                { name: 'weight', type: 'text' },//菜品在当前账单中的权重


                { name: 'jieSuanTime', type: 'text' }, //结算时间- 结算
                { name: 'isScomb', type: 'text' },//是否套餐
                { name: 'orderScombCaipinId', type: 'text' }//订单中套餐关联菜品GUID
            ]
        },
        {
            name: 'pos_zhekou',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'apply_whole_order', type: 'text' }, //是否是整单打折
                { name: 'discount', type: 'integer' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' },
                { name: 'mdId', type: 'text' }
            ]
        },
        {
            name: 'pos_tuicai_reason',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'retype', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_zengsong_reason',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'code', type: 'text' },
                { name: 'name', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' }
            ]
        },
        {
            name: 'pos_order_caipin_zengsong',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderCaipinId', type: 'text' },
                { name: 'reasonId', type: 'text' },
                { name: 'reasonName', type: 'text' },
                { name: 'num', type: 'NUMERIC' },
                { name: 'operator', type: 'text' },
                { name: 'modTime', type: 'text' }
            ]
        },

        {
            name: 'pos_billing',
            columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderId', type: 'text' },
                { name: 'orderNo', type: 'text' }, //账单号

                { name: 'zhangDanTotal', type: 'text' }, //账单总金额
                { name: 'shiShou', type: 'text' }, //实收金额
                { name: 'zhaoLing', type: 'text' },//找零金额
                { name: 'zheKouTotal', type: 'text' }, //折扣总金额（单品+赠送+整单比例）
                { name: 'fenTanTotal', type: 'text' }, //分摊总金额 （定额+抹零）
                { name: 'moLing', type: 'text' }, //抹零金额


                { name: 'jieSuanNo', type: 'text' },
                { name: 'banci', type: 'text' },
                { name: 'canbieCode', type: 'text' },
                { name: 'canBieName', type: 'text' },
                { name: 'device', type: 'text' },
                { name: 'memo', type: 'text' },
                { name: 'mdId', type: 'text' },
                { name: 'enabled', type: 'text' },
                { name: 'isDeleted', type: 'text' },
                { name: 'createTime', type: 'text' },
                { name: 'addOperatorId', type: 'text' },
                { name: 'addOperatorCode', type: 'text' },
                { name: 'addOperatorName', type: 'text' },
                { name: 'moneyTuiDan', type: 'text' },//退单金额,退菜金额(实收）
                { name: 'moneyZengSong', type: 'text' }, //赠送金额
                { name: 'moneyZheKou', type: 'text' }, //折扣金额（排除掉赠送的的金额） =  zheKouTotal - moneyZengSong

                { name: 'moneyDanPin', type:"text"},//单品折扣金额

                { name: 'moneyZhengDanBiLi', type:"text"},//整单比例金额
                { name: 'moneyZhengDanBiLiCode', type:"text"},//整单比例CODE
                { name: 'moneyZhengDanBiLiDiscount', type:"text"},//整单比例折扣率
                { name: 'moneyZhengDanBiLiName', type:"text"},//整单比例名字

                { name: 'moneyDingE', type:"text"}, //整单定额

                { name: 'isFanJieSuan', type: 'text' }, //是否是反结算，1表示是反结算， 0表示不是反结算
                { name: 'fanJieSuanReason', type: 'text' },//反结算原因
                { name: 'syn', type: 'INTEGER' },//上传状态 0 未上传，1 已成功上传
                { name: 'cardNo', type: 'text' }, //会员卡号，如果用会员支付，那么此值为非空。 反之为空。
                { name: 'cardMemName', type: 'text' }, //会员名字
                { name: 'tradeNumber', type: 'text' }, //会员交易 最后一次结账的时候所生成的 的凭据号
                { name: 'tradeGuid', type: 'text' }, //会员交易 最后一次结账的时候所生成的 的凭据号

                { name: 'canbieId', type: 'text' }, //餐别GUID
                { name: 'updateTimeMill', type: 'text' },//更新结算单的时候的时间的毫秒级数值
                { name: 'fanJieSuanAuthManId', type: 'text' },//反结算授权人id
                { name: 'fanJieSuanAuthManName', type: 'text' },//反结算授权人name
                { name: 'debugInfo', type:"text"}, //记录下反结算时候的内容信息，主要用于查明“一个订单多个有效billing的问题
                { name: 'hykZSMoney', type:"text"}, //会员卡赠送消费
                { name: 'jiFenMoney', type:"text"} //积分消费金额
            ]
        },
		{
		    name: 'pos_billing_detail',
		    columns: [
				{ name: 'guid', type: 'text primary key' },
				{ name: 'jieSuanNo', type: 'text' }, //结算单号
                { name: 'jieSuanId', type: 'text' }, //结算单Id
				{ name: 'bizId', type: 'text' },//财务科目ID
				{ name: 'bizCode', type: 'text' },
				{ name: 'bizAmount', type: 'INTEGER' },
				{ name: 'bizDesc', type: 'text' },
				{ name: 'type', type: 'INTEGER' },
				{ name: 'amount', type: 'text' },
				{ name: 'caiWuShuXing', type: 'text' },
                { name: 'isHyJf', type: 'text' }, //是否是会员积分
				{ name: 'seq', type: 'INTEGER' },
				{ name: 'device', type: 'text' },
				{ name: 'mdId', type: 'text' },
				{ name: 'isDeleted', type: 'text' },
				{ name: 'createTime', type: 'text' },
				{ name: 'addOperatorId', type: 'text' },
				{ name: 'addOperatorCode', type: 'text' },
				{ name: 'addOperatorName', type: 'text' },
                { name: 'ext1', type:"text"},//1.存放反值的值
                { name: 'thirdCouponNum', type:"text"}, //使用的第三方抵用券数量，如美团券
                { name: 'thirdCouponPayMoney', type:"text"}, //第三方抵用券购买金额
                { name: 'thirdCouponFaceValueMoney', type:"text"}, //第三方抵用券实际抵用金额
                { name: 'applyWholeOrder', type:"text"}, //仅仅对折扣有用，表示该折扣是否是应用于整单
                { name: 'hykZSMoney', type:"text"} //会员卡赠送消费
		    ]
		},
		{
		    name: 'printer',
		    columns: [
				{ name: 'guid', type: 'text primary key' },
				{ name: 'name', type: 'text' },
				{ name: 'code', type: 'text' },
				{ name: 'size', type: 'text' },
				{ name: 'backup_id', type: 'text' },
                { name: 'backup_id2', type: 'text' },
				{ name: 'mdId', type: 'text' },
				{ name: 'status', type: 'INTEGER' },
				{ name: 'createTime', type: 'text' },
				{ name: 'is_zhenda', type: 'INTEGER' }
		    ]
		},
		{
		    name: 'printer_config',
		    columns: [
				{ name: 'guid', type: 'text primary key' },
				{ name: 'printer_id', type: 'text' },
				{ name: 'name', type: 'text' },
				{ name: 'value', type: 'text' }
		    ]
		},
		{
		    name: 'printer_job',
		    columns: [
				{ name: 'guid', type: 'text primary key' },
				{ name: 'name', type: 'text' },
				{ name: 'createTime', type: 'text' },
				{ name: 'printer_id', type: 'text' },
                { name: 'final_printer_id', type: 'text' },
				{ name: 'status', type: 'INTEGER' },
				{ name: 'processing', type: 'INTEGER' },
				{ name: 'error_count', type: 'INTEGER' },
				{ name: 'job_no', type: 'text' }, // 打印流水号
				{ name: 'printTime', type: 'text' }, // 打印时间
				{ name: 'print_count', type: 'INTEGER' }, // 打印次数
				{ name: 'invoice_code', type: 'text' },
				{ name: 'ref', type: 'text' },
				{ name: 'order_id', type: 'text' },
				{ name: 'content', type: 'text' }
		    ]
		},
		{
		    name: 'printer_job_log',
		    columns: [
				{ name: 'guid', type: 'text primary key' },
				{ name: 'job_id', type: 'text' },
				{ name: 'createTime', type: 'text' },
				{ name: 'status', type: 'INTEGER' },
				{ name: 'message', type: 'text' }
		    ]
		},
		{
		    name: 'pos_caipin_guqing',
		    columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'caipinGuid', type: 'text' },
                { name: 'caipinName', type: 'text' },
                { name: 'caipinNum', type: 'NUMERIC' },
                { name: 'startTime', type: 'text' },
                { name: 'endTime', type: 'text' },
                { name: 'operatorId', type: 'text' },
                { name: 'operatorCode', type: 'text' },
                { name: 'operatorName', type: 'text' },
                { name: 'modTime', type: 'text' }
		    ]
		},
    {
        name: 'pos_hy_pingju', //会员的凭据
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'pingJuNo', type: 'text' }, //会员凭据号
            { name: 'jieSuanNo', type: 'text' }, //结算单号
            { name: 'hyCardNo', type: 'text' },//会员卡号
            { name: 'hyGuid', type: 'text' },//会员ID
            { name: 'mdId', type: 'text' },
            { name: 'createTime', type: 'text' },
            { name: 'addOperatorId', type: 'text' },
            { name: 'addOperatorCode', type: 'text' },
            { name: 'addOperatorName', type: 'text' }
        ]
    },

    {
        name: 'pos_hy_trans', //会员的交易信息
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'pingJuNo', type: 'text' }, //会员凭据，非唯一
            { name: 'hyCardNo', type: 'text' },//会员卡号
            { name: 'hyGuid', type: 'text' },//会员ID
            { name: 'jieSuanNo', type: 'text' }, //结算单号
            { name: 'orderNo', type: 'text' },//账单号
            { name: 'type', type: 'text' },//交易类型  现金消费，储值消费， 赠送消费
            { name: 'amount', type: 'text' }, //交易金额
            { name: 'paymentMethod', type: 'text' }, //支付方式
            { name: 'seq', type: 'INTEGER' },
            { name: 'device', type: 'text' },
            { name: 'mdId', type: 'text' },
            { name: 'isDeleted', type: 'text' },
            { name: 'createTime', type: 'text' },
            { name: 'addOperatorId', type: 'text' },
            { name: 'addOperatorCode', type: 'text' },
            { name: 'addOperatorName', type: 'text' }
        ]
    },
    {
        name: 'pos_cai_wu_ke_mu', //财务科目
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'code', type: 'text' },
            { name: 'name', type: 'text' },
            { name: 'isshishou', type: 'text' },//true or NULL 实收， 2 false == 优免
            { name: 'isDeleted', type: 'text' },
            { name: 'enabled', type: 'text' },
            { name: 'mdId', type: 'text' },
            { name: 'fklx', type: 'text' },//付款方式类型
            { name: 'isDisplay', type: 'text' },//是否显示 true  or false
            { name: 'isDisplayCz', type: 'text' },//充值是否显示 true  or false
            { name: 'isHyJf', type: 'text' } //true 或者 null认为参与会员积分，  false认为不参与会员积分
        ]
    },
    {
        name: 'pos_banci_order', //班次订单对应关系表
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'banciNo', type: 'text' },
            { name: 'orderId', type: 'text' },
            { name: 'orderCode', type: 'text' },
            { name: 'isDeleted', type: 'text' },
            { name: 'createTime', type: 'text' },
            { name: 'addOperatorId', type: 'text' },
            { name: 'addOperatorCode', type: 'text' },
            { name: 'banciId', type: 'text' },
            { name: 'addOperatorName', type: 'text' }
        ]
    },
    {
        name: 'pos_canbie', //餐别关系表
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'code', type: 'text' },
            { name: 'name', type: 'text' },
            { name: 'starttime', type: 'text' },
            { name: 'eattime', type: 'text' },
            { name: 'endtime', type: 'text' },
            { name: 'mdId', type: 'text' },
            { name: 'formatStarttime', type: 'text' },
            { name: 'formatEattime', type: 'text' },
            { name: 'formatEndtime', type: 'text' },
            { name: 'isDeleted', type: 'text' }
        ]
    },
	{
	    name: 'printer_status_log',
	    columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'printer_id', type: 'text' },
            { name: 'createTime', type: 'text' },
            { name: 'status', type: 'INTEGER' },
            { name: 'message', type: 'text' }
	    ]
	},
    {
        name: 'pos_setting',
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'serverIp', type: 'text' },
            { name: 'storeAccount', type: 'text' },
            { name: 'storePassword', type: 'text' },
            { name: 'storePattern', type: 'text' }
        ]
    },
    {
        name: 'pos_banci',  //班次号
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'banCiNo', type: 'text' }, //班次号
            { name: 'kaiBanTime', type: 'text' }, //开班时间
            { name: 'jieBanTime', type: 'text' }, //结班时间
            { name: 'status', type: 'text' }, //状态 0， 未结班，1为已结班
            { name: 'addOperatorId', type: 'text' }, //当前班次人的ID
            { name: 'addOperatorCode', type: 'text' }, //当前班次人的工号
            { name: 'syn', type: 'INTEGER' }, //是否上传
            { name: 'orderCount', type: 'INTEGER' }, //本班次账单数
            { name: 'orderIds', type: 'text' }, //本班次订单ID，以逗号分隔
            { name: 'addOperatorName', type: 'text' }, //当前班次人的名字
            { name: 'snap', type: 'text' } //当前快照
        ]
    },
    {
        name: 'pos_system_config',  //前台系统配置
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'systemConfigName', type: 'text' }, //值名称
            { name: 'systemConfigAlias', type: 'text' }, //别名
            { name: 'systemConfigValue', type: 'text' }, //具体的值
            { name: 'valueType', type: 'text' }, //值属于的类别
            { name: 'mdId', type: 'text' },
            { name: 'operatorTime', type: 'text' },
            { name: 'operatorId', type: 'text' }, //当前班次人的ID
            { name: 'operatorCode', type: 'text' }, //当前班次人的工号
            { name: 'operatorName', type: 'text' }, //当前班次人的名字
            { name: 'mac', type: 'text' }, //MAC地址
            { name: 'isDeleted', type: 'text' }
        ]
    },
    {
        name: 'pos_scomb_caipin',  //套餐菜品
        columns: [
            { name: 'guid', type: 'text primary key' },
                { name: 'scombId', type: 'text' },//套餐ID
                { name: 'caipinId', type: 'text' },//套餐菜品ID
                { name: 'name', type: 'text' },//套餐菜品名称
                { name: 'num', type: 'NUMERIC' },//套餐菜品数量
                { name: 'unitId', type: 'text' },//套餐菜品单位ID
                { name: 'unitName', type: 'text' },//套餐菜品单位名称
                { name: 'salePrice', type: 'text' },//套餐菜品单位的单价
                { name: 'costprice', type: 'NUMERIC' },
                { name: 'isBeixuan', type: 'text' },//是否有备选
                { name: 'isDeleted', type: 'text' }
        ]
    },
    {
        name: 'pos_scomb_beixuan_caipin',  //套餐菜品中关联的备选菜品
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'scombId', type: 'text' },//套餐ID
                { name: 'scombCaipinId', type: 'text' },//套餐菜品ID
                { name: 'bxCaipinId', type: 'text' },//备选菜品ID
                { name: 'bxCaipinNum', type: 'NUMERIC' },//备选菜品数量
                { name: 'bxCaipinName', type: 'NUMERIC' },//备选菜品名称
                { name: 'bxCaipinUnitId', type: 'text' },//备选菜品单位ID
                { name: 'bxCaipinUnitName', type: 'text' },//备选菜品单位名称
                { name: 'bxCaipinSalePrice', type: 'text' },//备选菜品的单价
                { name: 'costprice', type: 'NUMERIC' },
                { name: 'isDeleted', type: 'text' }
        ]
    },
    {
        name: 'pos_print_receipt',  //
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'printId', type: 'text' },//
                { name: 'name', type: 'text' },//
                { name: 'number', type: 'text' }
        ]
    },
    {
        name: 'pos_print_receipt_template',  //打印模板
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'content', type: 'text' },//
                { name: 'name', type: 'text' },//
                { name: 'printReceiptId', type: 'text' }
        ]
    },
    {
        name: 'pos_print_scheme',  //
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'printid', type: 'text' },//
                { name: 'name', type: 'text' }
        ]
    },
    {
        name: 'pos_print_caipin',  //菜品打印方案
        columns: [
            { name: 'guid', type: 'text primary key' },
                { name: 'caipinId', type: 'text' },
                { name: 'caipinName', type: 'text' },
                { name: 'caipinCode', type: 'text' },
                { name: 'printSchemeId', type: 'text' },
                { name: 'caipinQuickCode', type: 'text' },
                { name: 'caipinTypeId', type: 'text' }
        ]
    },
    {
        name: 'pos_order_scomb_caipin',  //订单中的套餐关联菜品
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'orderCaipinId', type: 'text' },//订单中的菜品GUID
                { name: 'scombId', type: 'text' },//套餐ID （菜品ID）
                { name: 'caipinId', type: 'text' },//套餐关联的菜品ID
                { name: 'orderCaipinType', type: 'integer' },//类型(1:点菜，2:退菜)
                { name: 'name', type: 'text' },
                { name: 'price', type: 'NUMERIC' },
                { name: 'costprice', type: 'NUMERIC' },
                { name: 'num', type: 'NUMERIC' },
                { name: 'tuiNum', type: 'NUMERIC' },
                { name: 'zengNum', type: 'NUMERIC' },
                { name: 'unitName', type: 'text' },
                { name: 'printId', type: 'text' },
                { name: 'printName', type: 'text' },
                { name: 'chupin', type: 'text' },
                { name: 'minAgio', type: 'integer' },//单品最低折扣
                { name: 'danPinBiLiZheKou', type: 'integer' },
                { name: 'danPinJineZheKou', type: 'NUMERIC' },
                { name: 'danPinZheKou', type: 'integer' },
                { name: 'luodan', type: 'integer' },
                { name: 'zheQianMoney', type: 'text' },//折前金额 - 结算
                { name: 'shiShouMoney', type: 'text' },//实收金额- 结算
                { name: 'zheKouMoney', type: 'text' },//折扣金额- 结算
                { name: 'fenTanSumMoney', type: 'text' },//分摊总计- 结算
                { name: 'moLingMoney', type: 'text' },// 抹零金额- 结算
                { name: 'weight', type: 'text' },//菜品在当前账单中的权重

            { name: 'zuoFaZheQianTotal', type: 'text' }, // 1 和当前菜品关联的做法折前金额 - 结算
            { name: 'zuoFaShiShouTotal', type: 'text' }, // 2 和当前菜品关联的做法实收合计- 结算
            { name: 'zuoFaZheKouTotal', type: 'text' }, //  3 和当前菜品关联的做法折扣金额- 结算
            { name: 'zuoFaFenTanTotal', type: 'text' },  // 4 和当前菜品关联的做法分摊合计- 结算
            { name: 'zuoFaMoLingTotal', type: 'text' },  // 5 和当前菜品关联的做法抹零合计- 结算
            { name: 'dianCaiYuanNo', type: 'text' },//点菜员No，默认是登录员工No
                { name: 'dianCaiYuan', type: 'text' },//点菜员工号，默认是登录员工
                { name: 'dianCaiYuanName', type: 'text' },//点菜员名字
                { name: 'operator', type: 'text' },
                { name: 'modTime', type: 'text' },
                { name: 'dianCaiTime', type: 'text' },
                { name: 'luoDanTime', type: 'text' },
                { name: 'jieSuanTime', type: 'text' }, //结算时间- 结算
                { name: 'chuPinTime', type: 'text' },
                { name: 'parentId', type: 'text' },//退菜属于的orderCaipinId
                { name: 'tuicaiReasonType', type: 'text' },//退菜原因类型 0-普通退菜 1-上退菜 2-临时估清
                { name: 'tuicaiReasonId', type: 'text' },//退菜原因id
                { name: 'needweigh', type: 'NUMERIC' },//是否需称重 0 不需要，1 需要，2，已确认
                { name: 'tuicaiReasonName', type: 'text' },//退菜原因name
                { name: 'isScomb', type: 'text' },//是否套餐
                { name: 'scombMainCaipinId', type: 'text' },//套餐菜品的主菜ID
                { name: 'hyPrice', type: 'NUMERIC' },//会员价
                { name: 'caipinTypeId', type: 'text' }, //菜品类型ID
                { name: 'caipinTypeCode', type: 'text' },//菜品类型code
                { name: 'caipinTypeName', type: 'text' } //菜品类型名称
        ]
    },
    {
        name: 'pos_person_role',  //人员角色关联表
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'roleName', type: 'text' },//角色名称
                { name: 'roleCode', type: 'text' },//角色Code
                { name: 'roleid', type: 'text' },//角色ID
                { name: 'userid', type: 'text' }//用户ID                
        ]
    },
    {
        name: 'pos_person_func_mission',  //人员操作权限关联表
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'functionId', type: 'text' },//操作权限ID
                { name: 'functionUrl', type: 'text' },//操作权限地址
                { name: 'operateId', type: 'text' },//Operatorid,用于权限控制
                { name: 'userId', type: 'text' },//用户ID
                { name: 'userType', type: 'text' },//用户类型  表示是角色 还是单个用户 对应 userID,是角色 userId就是角色ID  如果是用户  就是用户ID
                { name: 'checked', type: 'text' }//是否开启              
        ]
    },
    {
        name: 'pos_person_pos_mission',  //人员数据权限关联表
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'userId', type: 'text' },//用户ID
                { name: 'userType', type: 'text' },//用户类型  表示是角色 还是单个用户 对应 userID,是角色 userId就是角色ID  如果是用户  就是用户ID
                { name: 'dataName', type: 'text' },//数据权限名称
                 { name: 'dataValue', type: 'text' }//数据权限值
        ]
    },
    {
        name: 'pos_person',  //人员表
        columns: [
                { name: 'guid', type: 'text primary key' },
                { name: 'personNo', type: 'text' },//工号
                { name: 'password', type: 'text' },//密码
                { name: 'personName', type: 'text' },//名称
                { name: 'phone', type: 'text' },//联系电话
                { name: 'personStatus', type: 'integer' },//状态ID
                { name: 'personStatusName', type: 'text' },//状态名称
                { name: 'deviceName', type: 'text' },//登录的设备名称
                { name: 'lastLoginTime', type: 'text' },//最后的登录时间
                { name: 'clientName', type: 'text' },//Socekt客户端名称
                { name: 'deleted', type: 'text' }
        ]
    }
    ,
    {
        name: 'pos_ajaxlog',  //记录所有AJAX请求的详细
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'keywords', type: 'text' },//关键字
            { name: 'req', type: 'text' },//请求
            { name: 'res', type: 'text' },//相应
            { name: 'mdId', type: 'text' },//
            { name: 'addOperatorId', type: 'text' },//
            { name: 'addOperatorCode', type: 'integer' },//
            { name: 'addOperatorName', type: 'text' },//
            { name: 'createTime', type: 'text' },
            { name: 'url', type: 'text' }
        ]
    }
     ,
    {
        name: 'pos_wxlogin',  //记录点菜机与操作员的关系（可根据点菜机编号查询到操作员）
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'dcj', type: 'text' },//
            { name: 'operatorID', type: 'text' },//
            { name: 'operatorName', type: 'text' },//
            { name: 'addTime', type: 'text' },//
            { name: 'modTime', type: 'text' },//
            { name: 'version', type: 'integer' }
        ]
    }
     ,
    {
        name: 'pos_wxlsh',  //记录点菜机流水号（已存在的流水号直接返回成功）
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'dcj', type: 'text' },//
            { name: 'lsh', type: 'text' },//
            { name: 'addTime', type: 'text' }
        ]
    }
	 ,
    {
        name: 'pos_clientwindow_settings',  //pc分屏显示配置
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'type', type: 'text' }, // image or html
            { name: 'data', type: 'text' },
			{ name: 'seq', type : 'integer'},
			{ name: 'is_active', type : 'integer'},
			{ name: 'duration', type: 'text'} // 广告停留时间，以"秒"为单位
        ]
    }
    ,
    {
        name: 'pos_entitynamemap',  //连锁菜品entityNameMap信息
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'entityGuid', type: 'text' }, //
            { name: 'entityName', type: 'text' },
            { name: 'entityType', type : 'text'},  //PosCaiWuTypeInfo --付款方式 PosKouWeiInfo -- 口味管理 PosPresentReasonInfo -- 赠菜原因 PosTuiCaiReasonInfo -- 退菜原因 PosZheKouTemplateInfo -- 折扣模板 PosZuoFaInfo -- 做法管理 PosZuoFaTypeInfo -- 做法类型 PosChainMDCaipuInfo -- 门店菜谱 PosCaiPinInfo/PosChainCaipuCaipinInfo -- 菜品
            { name: 'sendTime', type : 'text'},
            { name: 'status', type: 'integer'}, //状态：1，新增数据 2，历史数据
            { name: 'redisIdSet', type: 'text'},
            { name: 'redisId', type: 'text'},
            { name: 'createTime', type: 'text'} //创建时间
        ]
    },
    {
        name: 'pos_redisKeyStorage',
        columns: [
            { name: 'redisId', type: 'text primary key' },
            { name: 'createTime', type: 'text'} //创建时间
        ]
    },
    {
        name: 'pos_order_zhuotai',  //账单桌台关系表
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'orderId', type: 'text' }, //当前账单ID
            { name: 'zhuotaiId', type: 'text' }, //桌台ID
            { name: 'zhuotaiCode', type : 'text'},  //
            { name: 'zhuotaiName', type : 'text'},
            { name: 'areaId', type: 'text' },
            { name: 'areaCode', type: 'text'},
            { name: 'areaName', type: 'text'},
            { name: 'renshu', type: 'text'}, //人数
            { name: 'hisOrderId', type: 'text' }, //历史账单ID(如果没有合并账单，跟当前账单Id一致,用于拆分账单还原数据)
            { name: 'isDeleted', type: 'text' },
            { name: 'hisOrderCode', type: 'text' },//原账单号(用于拆帐时判断是否需要生成账单号)
            { name: 'luoDanTime', type: 'text' },//桌台是否已落单
            { name: 'totalPrice', type: 'NUMERIC' }//桌台的总价
        ]
    },

    {
        name: 'sys_log',  //操作日志表
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'type', type : 'text'},  // POS
            { name: 'operationUser', type : 'text'}, //操作员
            { name: 'operatonDateTime', type: 'text' },//添加时间
            { name: 'operationAddress', type: 'text'},//添加的IP
            { name: 'operationDesc', type: 'text'},//点菜。。。。一些东西
            { name: 'operationType', type: 'text' },//暂时放点菜。。。。一些东西
            { name: 'syn', type: 'INTEGER' },//上传状态 0 未上传，1 已成功上传
        ]
    },
    {
        name: 'pos_sys_print_receipt_template',  //打印模板表
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'code', type: 'text' },  // POS
            { name: 'newContent', type: 'text' }, //新模板内容
            { name: 'sourceContent', type: 'text' },//内置80模板内容
            { name: 'sourceContent58', type: 'text' },//内置58模板内容
            { name: 'guiGe', type: 'text' },//内置模板规格
            { name: 'addtime', type: 'text' },
            { name: 'isdeleted', type: 'text' }
        ]
    },
    {
        name: 'pos_consumption_type',  //消费类型
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'state', type: 'text' },  // false禁用 true启用
            { name: 'consumptionName', type: 'text' },
            { name: 'isdeleted', type: 'text' }
        ]
    },
    {
        name: 'pos_consumption_caipin',  //消费类型关联的菜品
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'caipinNum', type: 'text' },  
            { name: 'caipinId', type: 'text' },
            { name: 'consumptionId', type: 'text' },
            { name: 'isdeleted', type: 'text' },
            { name:'realCaipinId', type:'text'}
        ]
    },
    {
        name: 'pos_third_coupon',  //第三方团购卷
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'state', type: 'text' }, // false禁用 true启用
            { name: 'isDiscount', type: 'text' }, //true 打折的时候不使用 false 打折的时候可以使用
            { name: 'isLimitUsing', type: 'text' }, //true 无限期使用 fasle 有限期的使用
            { name: 'thirdCouponName', type: 'text' },//卷名称
            { name: 'payTypeId', type: 'text' },//付款方式id
            { name: 'payManey', type: 'text' },//支付金额
            { name: 'faceValueManey', type: 'text' },//面额
            { name: 'useTimes', type: 'text' },//单笔使用卷的数量
            { name: 'closingDate', type: 'text' },//截止日期
            { name: 'isdeleted', type:'text'}
        ]
    },
    {
        name: 'pos_third_coupon_not_use_caipintype',  //第三方券不不能使用的菜品类别
        columns: [
            { name: 'guid', type: 'text primary key' },
            { name: 'caipinDishTypeId', type: 'text' },//菜品类别id
            { name: 'posThirdCouponId', type: 'text' },//第三方团购卷id 关联
            { name: 'isdeleted', type: 'text' }
        ]
    }
];














