Utils.showSuccessInfo = function (message) {
    Utils.showSuccessInfoDelay(message, 200);
}

Utils.showLoading = function (msg) {
    $.maskLoader('show', msg);
}

Utils.hideLoading = function () {
    $.maskLoader('hide');
}

Utils.isMobile = function () {
    return window.yunshan.isMobilePhone();
}

Utils.showSuccessInfoDelay = function (message, delay) {
    if ($('#resultMsg').is(':visible')) {
        window.setTimeout(function () {
            Utils.showSuccessInfoDelay(message, delay);
        }, 500);
        return;
    }
    var msgInfo = message ? message : LANGUAGECACHE["str_tip_worksuccess"];
    $('#resultMsg').html(msgInfo).removeClass().addClass("success").show();
    window.setTimeout(function () {
        $('#resultMsg').fadeOut(1000)
    }, delay);
}

Utils.showFailureInfo = function (message) {
    Utils.showFailureInfoDelay(message, 2000);
}

var timeoutProcess;
Utils.showFailureInfoDelay = function (message, delay) {
    if ($('#resultMsg').is(':visible')) {
        // window.setTimeout(function () {
        //     Utils.showFailureInfoDelay(message, delay);
        // }, 500);
        if(!Utils.isEmpty(timeoutProcess)){
            clearTimeout(timeoutProcess);
        }
        $('#resultMsg').hide();
        Utils.showFailureInfoDelay(message, delay);
        return;
    }
    var msgInfo = message ? message : LANGUAGECACHE["str_tip_workfail"];
    $('#resultMsg').html(msgInfo).removeClass().addClass("failure").show();
    timeoutProcess = window.setTimeout(function () {
        $('#resultMsg').fadeOut(1000);
    }, delay);
}

Utils.setStorage = function (key, value) {
    localStorage.setItem(key, JSON.stringify({val: value}));//转换成json字符串序列
}
Utils.getStorage = function (key) {
    var val = localStorage.getItem(key);//获取存储的元素
    if (Utils.isEmpty(val)) {
        return null;
    } else {
        var dataobj = JSON.parse(val);//解析出json对象
        return dataobj.val;
    }
}

