var crmsdk = { BaseHost: SERVER_HOST.BASE_HOST + API_CONTEXT.CRM ,
               BaseHost2: SERVER_HOST.BASE_HOST + API_CONTEXT.BASIC 
             };// '/sop-crm-api/api' };

crmsdk.AjaxLogger = null;

crmsdk.post = function (urlmode, data, callback,errorcallback,setstyle) {
    if (!data || data == null)
        data = {};

    BIZCONSTANT.POSUSER.json4common(data);

    data.cardAddress = CONSTANTS.SystemConfigs['HotelAddress'] ? CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue : '';
    data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
    data.orgName = BIZCONSTANT.POSUSER.HotelName;

    if(!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;

    //BIZCONSTANT.POSUSER
    
    if(setstyle){
        this.BaseHost = this.BaseHost2
    }
    
    var url =urlmode.value+ "?token=123&t=1";

    jQuery.ajax({
        type: "POST",
        url: this.BaseHost + url,
        data: JSON.stringify(data),
        contentType: "application/json",
        dataType: "json",
        success: function (result) {
            if (crmsdk.AjaxLogger) {
                crmsdk.AjaxLogger.log(BIZCONSTANT.POSUSER, urlmode.name, JSON.stringify(data), JSON.stringify(result),url);
            }
            callback(result);
        },
        error: function (error, errdata, errorThrown) {
            if (crmsdk.AjaxLogger) {
                crmsdk.AjaxLogger.error(error.status, urlmode.name, JSON.stringify(data), errorThrown, url);
            }
            Utils.showFailureInfo('与会员服务器通信失败<br>HTTP 状态：' + error.status + '<br>' + errorThrown);
            if (errorcallback)
                errorcallback('与会员服务器通信失败<br>HTTP 状态：' + error.status + '<br>' + errorThrown);
        }
    });
}

crmsdk.get = function (url, callback) {
    jQuery.ajax({
        type: "GET",
        url: BaseHost + url,
        success: function (result) {
            callback(result);
        },
        error: function (error, data, errorThrown) {

        }
    });
}

