/**
 * Created by peter.shang on 2016-03-02.
 *
 * NODEJS http server 对外公开的服务
 */




/**
 *
 * @param jsonIn  example:
 * {"type":"taiKaNo,banCi"},
 * {"type","banci"}
 *
 * @param res
 */
function nextSeq(jsonIn, res) {
    var jsonSuccess = { result: BIZCONSTANT.PEER_SYNC_SUCCESS, desc: "success", detail: "" };
    var jsonError = { result: BIZCONSTANT.PEER_SYNC_FAILED, desc: "failed", detail: "" };

    var now = new Date();
    ieasyModule.get('UniqueIDService').nextSeq(now, jsonIn.type, function (err, model) {
        if (err) {
            error(jsonError, res);
        }

        var seqNo = now.format("yyyyMMdd") + Utils.formatSeqNo(model);
        jsonSuccess.detail = { seqNo: seqNo }
        success(jsonSuccess, res)
    });
}


/*
 * 局域网内所有的机器数据同步
 *
 */
/**
 *
 * @param jsonIn {guid: "111111", content: "dddd", "ts: "1456991103354"}
 * @param res
 */
function syncPeer(jsonIn, res) {
    //var d = ieasyModule.get('database');
    //console.log("*********************************");
    //console.log(jsonIn);
    //
    //var a = JSON.parse(unescape(jsonIn.content));
    //
    ////TODO, 重复性检查？？
    //
    //var jsonSuccess = {result:BIZCONSTANT.PEER_SYNC_SUCCESS, desc:"success", detail:""};
    //var jsonError = {result:BIZCONSTANT.PEER_SYNC_FAILED, desc:"failed", detail:""};
    //jsonSuccess.detail = {guid: jsonIn.guid};
    //jsonError.detail = {guid: jsonIn.guid};
    //
    //
    //console.log(a);
    //console.log("开始同步...");
    //
    //d.queryTransactionNoLogging(a).then(function(resultList){
    //    success(jsonSuccess, res)
    //    console.log("同步成功...");
    //}, function(err){
    //    error(jsonError, res);
    //    console.log(err);
    //    console.log("同步失败...");
    //
    //});
    //
    //console.log("*********************************");
}



function wxProcessor(jsonIn, res) {
	var jsonSuccess = { success: 1, message: ""};
	var jsonError = { success: 0, message: "" };
	//console.log(jsonIn);
	//console.log(res);
	var processor = WuXianProcessorManager.get(jsonIn.command);
	if(processor != null){
		processor.process(jsonIn.request, function(result){
			success(result, res);
		});
	}
	else{
		jsonError.message = "unsupported wuxian command";
		success(jsonError, res);
	}
}




function sqlExe(jsonIn, res) {
    var d = ieasyModule.get('database');
    //console.log("*********************************");
    //console.log(jsonIn);
    var jsonSuccess = { result: BIZCONSTANT.PEER_SYNC_SUCCESS, desc: "success", detail: "", rowsAffected: "" };
    var jsonError = { result: BIZCONSTANT.PEER_SYNC_FAILED, desc: "failed", detail: "" };
    /*
    d.queryTransactionWS(jsonIn).then(function(resultList){
		console.log(">>>>>>>>>>>>>>>>>>>>>>>>>> Sql Exec: " + ((new Date()).getTime() - t1));
        jsonSuccess.detail = resultList;
        success(jsonSuccess, res)
        console.log("SQL成功...");
    }, function(err){
        jsonError.detail = err;
        console.log(err);
        console.log("SQL失败...");
        success(jsonError, res)
    });*/
    d.queryTransactionWS(jsonIn, function (o) {
        //debugger;
        jsonSuccess.detail = o.resultList;
        jsonSuccess.rowsAffected = o.affectRowsResult;
        success(jsonSuccess, res)
        //console.log("SQL成功...");
    }, function (err) {
        jsonError.detail = err;
        //console.log(err);
        //console.log("SQL失败...");
        success(jsonError, res)

    });
}

function noProccessor(jsonIn, res) {
    var jsonSuccess = { result: BIZCONSTANT.PEER_SYNC_SUCCESS, desc: "success", detail: "" };
    var jsonError = { result: BIZCONSTANT.PEER_SYNC_FAILED, desc: "failed", detail: "" };
    jsonSuccess.detail = "找不到处理器";
    jsonSuccess.result = BIZCONSTANT.PEER_SYNC_NOMATCH;
    success(jsonSuccess, res)
}
/**
 *
 * @param json
 * @param res  http.response
 */
function error(json, res) {
    res.writeHead(200, {
        "Content-Type": "text/plain",
        "Access-Control-Allow-Origin": "*",
        "Access-Control-Allow-Methods": "GET, POST, OPTIONS",
        "Access-Control-Allow-Headers": "X-Requested-With, Content-Type"
    });
    res.write(JSON.stringify(json));
    res.end();
}

function success(json, res) {
    res.writeHead(200, {
        "Content-Type": "text/plain",
        "Access-Control-Allow-Origin": "*",
        "Access-Control-Allow-Methods": "GET, POST, OPTIONS",
        "Access-Control-Allow-Headers": "X-Requested-With, Content-Type"
    });
    res.write(JSON.stringify(json));



    res.end();
}

function Narrowed(rowsAffected, rows) {
    this.rowsAffected = rowsAffected;
    this.rows = rows;

}
function callMasterServer(param, callback, hostIP) {
    var str = JSON.stringify(param);
    //console.log("发送到主机的payload："+str);
    $.ajax({
        type: "post",
        url: hostIP === null ? BIZCONSTANT.MASTER_SERVER_URL : hostIP,
        dataType: "json",
        async: true,
        contentType: "application/json;",
        data: str,
        success: function (response) {
            BIZCONSTANT.PEER_CONNECTION_STATU = true;
            callback(response);
        },
        error: function (error, data, errorThrown) {
            BIZCONSTANT.PEER_CONNECTION_STATU = false;
            console.log("网络调用错误");
            //if (BIZCONSTANT.LOCALSTORAGE_INSTALLCONFIG != null)
            //    Utils.showFailureInfo("无法连接主机，请确认主机是否开启！");

            var jsonError = { result: BIZCONSTANT.PEER_SYNC_FAILED, desc: "failed", detail: {} };
            var installConfig = InstallConfigService.getTongbuLocalStorageInstallConfig();
            var HostIP = "";
            if (installConfig != null)
                HostIP = installConfig.masterHost;
			if(HostIP == null || HostIP == ""){
				jsonError.detail.message = "主机地址未设置，请到登陆界面左上角设置主机地址";
			}
			else{
				jsonError.detail.message = "无法正确连接到主机<br/>主机地址为：" + HostIP + "。<br/>请确认主机是否开启或查看主机8888端口是否被占用或禁用！";
            }

            if(jsonError.detail.message  !== null )
            Utils.showFailureInfo(jsonError.detail.message);
			callback(jsonError);
        }

    });
}



function generateParam(key, detail) {
    var param = {
        "key": key,
        "body": detail
    }

    return param;
}